/**************************************************************************
*
*                              J D I C
*	                  Japanese Dictionary System 
*                                                   Author: Jim Breen
***************************************************************************
*  Warning - MUST be compiled  with unsigned char                         *
***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <graphics.h>
#include <ctype.h>
#include <string.h>
#include <io.h>
#include <dir.h>
#include <dos.h>
#include <conio.h>

#define SPTAG '@'	  /* character that flags priority entries */
#define NRKANA 250*2   /*  size of the romaji to kana tables*/
#define TRUE 1
#define FALSE 0
#define BPCH (14*8)/8  /* bytes for each kiascii charater  */
#define NOHIST 10      /* size of stack of previous commands*/
#define LINESBACK 45   /*  number of lines to backspace in the 'b' command */
#define HITSIZE 1000	/* number of elements in the "hit" table   */
#define LastJIS 0x7426	/* last kanji in JIS X 0208-1990	*/

/* structures for the Nelson, etc. files    */
	typedef struct {
		unsigned char strokes;
    	unsigned char bushu;
    	unsigned short int indexn;
    	unsigned short int indexh;
    	unsigned char grade;
    	unsigned char onkun;
	unsigned char meanings;           /* To pad it to 32-bits */
	unsigned char padding;
	unsigned long int offset;
	} KINFORECORD;

	typedef struct {
    	unsigned int code;
    	unsigned int nelx;
    	short int index;
	} IDXRECORD;

int BackLines = LINESBACK;
int PixelPerRow = 17;
int Vmode = TRUE,debux = FALSE,FirstKanj = TRUE,Gron = FALSE,Bfont = FALSE;
int NHmode = TRUE,rstroke,bstroke,HRow,maxx,maxy,maxr,wild;
int EPmode=FALSE;
int EPinwd=FALSE;
int JISDisp=FALSE;
unsigned int kbsize,bsize,blsize,Msize,prowa;
void *blank,*lblank,*kblank,*bline;
int Bcolour = BLACK, Kcolour = LIGHTGRAY, Acolour = WHITE, Pcolour = WHITE;
int KIAcolour, attflag = FALSE,TestDic = TRUE;
int kfntspce=16, afntspce=8;
int vbrf=0,vbrd=0,vbri=0;
int Kmsg,nofkeys=0;
char fkeymapsf[21],fkeymapst[21];
int SJis;
int Fold,prow,pcol,pcolk,pcolsav,Smode = 0;
unsigned long diclen,indlen,dbyte, dbyte2,hittab[HITSIZE];
unsigned char kiain[BPCH*128];
int hitind,lineyy[50];
void *bline;
unsigned long it,indptr,lone,linepos[50];
char SKsav[10],ksch[30],sch[30],targ[30],ktarg[60],Bmsg[100];
char *meanstr,kanatab[NRKANA*2][7];
char Stype[3][4] = {"(E)","(H)","(K)"};
char NHmess[4] = {" N "};
char EPtype[4] = {"[P]"};
char Dname2[80] = {"jtoe.dct"};
char Dname[80] = {"edict"};
char EXTname[80] = {"edictext"};
char EXTJDXname[80] = {"edictext.jdx"};
char JDXname[80] = {"edict.jdx"};
char JDXname2[80] = {"jtoe.jdx"};
char font24name[80] = {""};
char DnameList[10][80],JDXnameList[10][80];
int NoDics = 0,MultDic=FALSE;
int GraphDriver = DETECT;
int GraphMode;
char BGIDir[50] = {""};
int iver = 26;		/* Version 2.6*/
int jiver = 14;		/*The last time the index structure changed was Version1.4*/
char sver[4] = {"2.6"};
char kanjidir[120] = {""},KIHead[60];
int Kinfopen = FALSE,KIndex = FALSE,Halpf = FALSE, ReDoScr = FALSE,Kindex = 0;
int LastIndex,KnjFlag,Kindopen=FALSE,Kutenf = FALSE;
int currhist=0,histout=0,histflag=FALSE;
int kcurrhist=0,khistout=0,khistflag=FALSE,KHType[NOHIST],KHVal[NOHIST];
char KHYomi[NOHIST][25] = {"","","","","","","","","",""};
int KHFlag,KHTIndex,KHVIndex;
char hist_line[NOHIST][21];
char resp;

#define NOFILT 10
int nofilts=FALSE,filton[NOFILT],filtact[NOFILT],filttype[NOFILT],filtcoden[NOFILT];
char filtnames[NOFILT][50],filtcodes[NOFILT][10][10];
char kanjsel1[10],kanjsel2[10],testline[1025],Kfilt[3];
int dbincr,kno,KDirect, Logopen=FALSE,Extopen=FALSE;
char LogFile[60] = {"jdic.log"};
unsigned char SingleFilter[50];
int SFFlag=FALSE;

char hotkeys[10][30];
int hotkeylen[10],hotkeyact=FALSE,hotkeyind,hotkeypos;
int JIS212 = FALSE;
int K212 = FALSE;
int k212open = FALSE,font212=FALSE;
char k212name[50];
long k212ind[255];
char fontfilename212[128];

/*====== prototypes========================================================*/
int Dispk212(char c2, char c3);
void AddHist(char *sch);
void eight2seven(int *p1,int *p2);
void CloseKind();
void GetKBStr(char *str);
void GetYomi(int yommode);
void HOut(char *s);
int HOutx(char *s);
int DoGetD();
int BushStrk(int ks, int sindx );
int DoNels(int nelind);
int BinSrch(int sindx, char *x, int ks);
int GetNo(char *gnstr);
int CursInp();
void NewCurs();
void ToggleCurs();
void PgDisp(char *kstr1, char *kstr2);
int DoRads();
int DoKIndex();
int DoStrk();
int DoBush(int bushind);
int DoKuten();
void InitScr();
void SeekErr(int iores);
char waitch();
void getvbuff (int *offp, FILE *fp, long vbo);
unsigned long jindex(unsigned long it);
int GetColour (char *s);
unsigned char dbchar(unsigned long it);
void DicInit();
void GetKey();
int DoYomi(int i);
void kouttextxy(int kx, int ky, char *s);
void kiaset();
int Rcfile(char *a,char *b);
int alphaoreuc(unsigned char c);
int Check_Cache(int kindex);
int FontSetUp  (void);
int jis2index(unsigned int hix, unsigned int lox );
void OutKanji(int index);
void DicSet  ();
int Kstrcmp2();
int addhit(long spot);
int kanaconv(int rpos, int rlen);
void Bomb( char *a);
int DoJIS();
void WordOut(char *ops);
void OpenKinf();

/***************************************************************************
* paging routines for Jim's Japanese software
* for use with jdic, jreader, etc
*currently used for: edict, edict.jdx
***************************************************************************/


#define VBUFFSIZE 1024  /* size in bytes for each virtual buffer  */
#define NOVB 500  /* maximum number of virtual buffers   */
#define MAXFNT 250   /*   "    "      "    fontfile        "       */
#define COLUMN (0x7f-0x21)
#define KVER 23    /* current version of kinfo.dat  */

void *vbuffs[NOVB];
int *vbptr[NOVB];
long usebuff[NOVB], vbusage = 1;
int *doffp,*joffp,foffp[MAXFNT];
int MAXDIC,MAXJDX;  /* formerly defines, now set dynamically */
int MAXDICTAB,MAXJDXTAB; 
int Load = TRUE;
int novbmax = NOVB,vbread = 0;
char debugb[50],vbrs[10],novbs[10];
int novbuff;
int f2currb = -1;
int f3currb = -1;
int OldJIS = TRUE,BigFont = FALSE;
char fontfilename[128];
char bfontfilename[128];
char helpfilename[128],helpfile[13] = {"jdic.hlp"};
char docfilename[128],docfile[13] = {"jdic26.doc"};

FILE *fhd,*fe,*fex,*fl,*fk,*fki,*fpd,*fpi,*fpf1,*fpf2,*fpf,*fpf3,*fpw2,*fopen();

unsigned long diclen,indlen;

/*    common variables for the DoKI routines   */

	IDXRECORD rec;
	KINFORECORD krec;
	int kcursize,cursize,kind,pcolx,is,ksp,hi,lo,ks,test,sindx,midsav,mid,iores,i;
	int bush,grade,nels,halp,strk,onk,kunk,PgOffs,PgInit,PgEnd,PgEOF;
	int PageIndex[1000],cresp,curpos,curcol,currow;
	char c,ops[120],fks[200];
	char kinffile[50],kinfidx[50],c1,c2;
	long idxlen,seekoff;
	void *kcurstore,*curstore;

/*====getchx  returns getch() apart from hotkeys======*/
int getchx()
{
	char gc;

	if (!hotkeyact) return(getch());

	gc = hotkeys[hotkeyind][hotkeypos++];
	if (hotkeypos >= hotkeylen[hotkeyind]) hotkeyact = FALSE;
	return(gc);
}

/*====DicSet check Dictionary and index table=======*/
void DicSet()
{
	unsigned long jdxtest[2];
  	lone = 1;
	jdxtest[0] = 0;

  	fpd=fopen(Dname,"rb");
  	if (fpd==NULL )
  	{
		sprintf(Bmsg,"\nCannot open dictionary file: %s\n",Dname);
		Bomb(Bmsg);
  	}
  	diclen = filelength(fileno(fpd));
  	diclen++;
  	dbyte = diclen;
  	fpi = fopen(JDXname,"rb");
  	if(fpi == NULL)
  	{
		sprintf(Bmsg,"\nCannot open index file: %s\n",JDXname);
		Bomb(Bmsg);
  	}
  	indlen = filelength(fileno(fpi));
	indptr = indlen/4-1;
	fread(jdxtest,4,1,fpi);
	if (jdxtest[0] != (diclen+jiver))
	{
		Bomb ("The dictionary and index files do not match! \n");
	}
	MAXDIC = (diclen/VBUFFSIZE)+1;
	MAXJDX = (indlen/VBUFFSIZE)+1;
}

/*====DicInit ====initialize dictionary buffers and load the dictionary*/

void DicInit()
{

  	int ndr,reqb,i;

	reqb =  MAXFNT+diclen/VBUFFSIZE + indlen/VBUFFSIZE+2 ;
  	if (novbmax > reqb) novbmax = reqb;
  	for (novbuff = 0; novbuff < novbmax; novbuff++)
  	{
  		usebuff[novbuff] = -1;
		if (coreleft() < 4000) break;
  		vbuffs[novbuff] = malloc(VBUFFSIZE);
		if (!vbuffs[novbuff])
		{
			break;
		}
  	}
	if(Load)
	{
		ndr = 100;
		if (ndr > novbuff) ndr = novbuff;
		for (i = 0; i < ndr; i++)
		{
			fread(vbuffs[i],1,VBUFFSIZE,fpf1);
			foffp[i] = i;
			vbptr[i] = &(foffp[i]);
			usebuff[i] = 1;
		}
		reqb = novbuff-ndr;
		if (reqb == 0) return;
		ndr = diclen/VBUFFSIZE;
		if (ndr > reqb) ndr = reqb;
		for (i = 100; i < ndr+100; i++)
		{
			fread(vbuffs[i],1,VBUFFSIZE,fpd);
			doffp[i-100] = i;
			vbptr[i] = &(doffp[i-100]);
			usebuff[i] = 1;
		}
  	}
}

/*=====dbchar====returns specified character from dictionary===============*/

unsigned char dbchar(unsigned long it)
{
	int vbo, vbc,ibuff;
	char *myp;
	long it2;

	it2 = it-1;
	if ((it2 < 0)||(it2 > diclen)) return(10);
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbc = it2 % VBUFFSIZE; /*offset within page  */

	if (doffp[vbo] == -1)
	{
		getvbuff(&(doffp[vbo]),fpd,vbo); /*not resident - get it  */
		vbrd++;
	}
	ibuff = doffp[vbo];         /*page is (now) resident  */
	usebuff[ibuff] = vbusage++;   /* flag this buffer as most recently used */
	myp = vbuffs[ibuff];
	return(myp[vbc]);
}

/*======jindex  returns specified entry from .jdx file========*/

unsigned long jindex(unsigned long it)
{
	int vbo, vbl,ibuff;
	long *myp;
	long it2;

	it2 = it*sizeof(long);
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbl = (it2 % VBUFFSIZE) / sizeof(long); /*offset within page  */

	if (joffp[vbo] == -1)
	{
		getvbuff(&(joffp[vbo]),fpi,vbo); /*not resident - get it  */
		vbri++;
	}
	ibuff = joffp[vbo];         /*page is (now) resident  */
	usebuff[ibuff] = vbusage++;   /* flag this buffer as most recently used */
	myp = vbuffs[ibuff];
	return(myp[vbl]);
}

/*======jfont  returns specified entry from font file========*/

void jfont(int it, int font[16])
{
	int vbo, vbl,ibuff;
	long it2;
	int *myp;
	int i;

	it2 = it;
	it2 *=32;   	/*  16x16 font offset in bytes  */
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbl = (it2 % VBUFFSIZE) / sizeof(int); /*offset within page  */

	if (foffp[vbo] == -1)
	{
		getvbuff(&(foffp[vbo]),fpf1,vbo); /*not resident - get it  */
		vbrf++;
	}
	ibuff = foffp[vbo];         /*page is (now) resident  */
	usebuff[ibuff] = vbusage++;   /* flag this buffer as most recently used */
	myp = vbuffs[ibuff];
	myp+=vbl;
	for (i = 0;i < 16; i++) font[i] = myp[i];
}
/*======jfont2  returns specified entry from JIS2 font file========*/
/*   because jis2 fonts are rarely used, the one local buffer is
     used repeatedly   */

void jfont2(int it, int font[16])
{
	int vbo, vbl,iores;
	long it2,seekoff;
	static char lbuff[VBUFFSIZE];
	int *myp,i;

	it2 = it;
	it2 *=32;   	/*  16x16 font offset in bytes  */
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbl = (it2 % VBUFFSIZE) / sizeof(int); /*offset within page  */

	if (f2currb != vbo)
	{
		seekoff = vbo;
		seekoff *= VBUFFSIZE;
		if((iores = fseek(fpf2,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(lbuff,1,VBUFFSIZE,fpf2);
		f2currb = vbo;
	}
	myp = &lbuff;
	myp+=vbl;
	for(i=0;i<16;i++) font[i] = myp[i];
}
/*======jfont3  returns specified entry from JIS212 font file========*/
/*   because jis212 fonts are rarely used, the one local buffer is
     used repeatedly   */

void jfont3(int it, int font[16])
{
	int vbo, vbl,iores;
	long it2,seekoff;
	static char lbuff3[VBUFFSIZE];
	int *myp,i;

	it2 = it;
	it2 *=32;   	/*  16x16 font offset in bytes  */
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbl = (it2 % VBUFFSIZE) / sizeof(int); /*offset within page  */

	if (f3currb != vbo)
	{
		seekoff = vbo;
		seekoff *= VBUFFSIZE;
		if((iores = fseek(fpf3,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(lbuff3,1,VBUFFSIZE,fpf3);
		f3currb = vbo;
	}
	myp = &lbuff3;
	myp+=vbl;
	for(i=0;i<16;i++) font[i] = myp[i];
}
/*=====getvbuff===allocates a free virtual buffer and reads in the page===*/

void getvbuff (int *offp, FILE *fp, long vbo)
{
	int ibuff,i,iores;
	long maxu,seekoff;

/*     find a free buffer, or free the LRU one   */
	vbread++;
	maxu = usebuff[0];
	ibuff = 0;
	for (i = 0; i < novbuff; i++)
	{
		if (usebuff[i] == -1)
		{
			ibuff = i;          /*free buffer available   */
			break;
		}
		else
		{
			if( usebuff[i] < maxu)   /*look for LRU buffer  */
			{
				maxu = usebuff[i];
				ibuff = i;
			}
		}
	}
	/*  read page into buffer   */
	if(usebuff[ibuff] >= 0) *vbptr[ibuff] = -1;
	vbptr[ibuff] = offp;
	*vbptr[ibuff] = ibuff;
	seekoff = vbo;
	seekoff *= VBUFFSIZE;
	if((iores = fseek(fp,seekoff,SEEK_SET)) != 0)SeekErr(iores);
	iores = fread(vbuffs[ibuff],1,VBUFFSIZE,fp);
}

/* === Function to read in JIS Kanji font into RAM ====================== */
int FontSetUp  (void)
{
	int i;

	strcpy(fontfilename212, kanjidir);
	strcat(fontfilename212, "jis21216.fnt");
	if( (fpf3 = fopen(fontfilename212,"rb")) != NULL) font212 = TRUE;
	if (OldJIS)
	{
		strcpy(fontfilename, kanjidir);
		strcat(fontfilename, "k16jis1.fnt");
		if( (fpf1 = fopen(fontfilename,"rb")) == NULL)
		{
			sprintf(Bmsg,"Can't open JIS-1 font file: %s\n",fontfilename);
			Bomb(Bmsg);
		}
		strcpy(fontfilename,kanjidir);
		strcat(fontfilename, "k16jis2.fnt");
    	if( (fpf2 = fopen(fontfilename,"rb")) == NULL)
    	{
			sprintf(Bmsg  ,"Can't open JIS-2 font file: %s\n",fontfilename);
        	Bomb(Bmsg);
    	}
	}
	else
	{
		strcpy(fontfilename, kanjidir);
		strcat(fontfilename, "kijis16.fnt");
		if( (fpf1 = fopen(fontfilename,"rb")) == NULL)
		{
			sprintf(Bmsg,"Can't open JIS16 font file: %s\n",fontfilename);
			Bomb(Bmsg);
		}
	}
	for (i = 0;i<MAXFNT;i++) foffp[i] = -1;
}

/* === Function to convert JIS Kanji code to index into our font data */
/* (Original code came from KD.C)		*/
int jis2index(unsigned int hix, unsigned int lox )
{
	unsigned int hi,lo;
	hi = hix;
	lo = lox;

	if(JIS212)
	{
		if(!(lo>0x20 && lo<0x7F && hi>0x0 && hi<0x76))
		{
			JIS212 = FALSE;
			return 0xb3;
		}
		if (!font212)
		{
			JIS212 = FALSE;
			return 0xb3;
		}
		if(hi == 0x21 && lo == 0x21)
		{ /* space */
			JIS212 = FALSE;
			hi = 0x22; lo = 0x44;
		}
		return (COLUMN*(hi-0x21)+(lo-0x21));
	}
/* hack by JWB to select between alternative font files, and to allow for the
extra 4 kanji in JIS X 0208 (1983) plus the 2 extra in JIS X 0208 (1990)  */
	if(OldJIS)
	{
	if(lo>0x20 && lo<0x7F && hi>0x20 && hi<0x75)
            hi = 94*hi + lo - 3135;  /* hi=94*(hi-33)+(lo-33) */
	else
            hi = 0x7e7e;   /* debug by K.M. *//* code out of range, apple mark */
	/* "hi" is reused */

        /*...........................range....notation..JIS code.....index... */
	if(hi>=282 && hi <=364)
		hi -= 73; 	/* 282..364  hiragana, $2421-$2473, 209-291  */
	else if(hi>=1410 && hi<=4374)
		hi -= 886; 	/* 1410..4374 kanji-1, $3021-$4f53, 524-3488 */
	else if(hi>=376 && hi<=461)
		hi -= 84; 	/* 376..461  katakana, $2521-$2576, 292-377  */
	else if(hi>=203 && hi<=212)
		hi -= 56;  	/* 203..212   0 .. 9,  $2330-$2339, 147-156  */
	else if(hi>=220 && hi<=245)
		hi -= 63; 	/* 220..245   A .. Z,  $2341-$235a, 157-182  */
	else if(hi>=252 && hi<=277)
		hi -= 69; 	/* 252..277   a .. z,  $2361-$237a, 183-208  */
	else if(hi>=470 && hi<=493)
                hi -= 92;      	/* 470..493   GREEK,   $2621-$2638  378-401  */
	else if(hi>=502 && hi<=525)
                hi -= 100;     	/* 502..525   greek,   $2641-$2658  402-425  */
	else if(hi>=564	&& hi<=596)
                hi -= 138;     	/* 564..596   RUSSIAN, $2721-$2741  426-458  */
	else if(hi>=612 && hi<=644)
                hi -= 153;     	/* 612..644   russian, $2751-$2771  459-491  */
				/*  n/a       linedraw,  n/a        492-523  */
	else if(hi<= 107)
		;  		/* 0..93               $2121-$217e, 0  -93   */
			   	/* 94..107             $2221-$222e, 94 -107  */
	else if(hi>=4418 && hi<=7809)
		hi -= 928;      /* 4418..7809 kanji-2, $5021-$7324, 3490-6881 */
	else	hi = 3489;   /* non printable */
	return(hi);
	}
	else      /* New JIS font file   */
	{
		if(!(lo>0x20 && lo<0x7F && hi>0x0 && hi<0x76))
			return 0xb3;

		if(hi == 0x21 && lo == 0x21)
		{ /* space */
			hi = 0x22; lo = 0x44;
		}
		return (COLUMN*(hi-0x21)+(lo-0x21));
	}
}
/* === Function to display 1 Kanji at current position ================ */
void OutKanji(int index)     /* 0 <= index <= 6876 */
{
	register int LRbits, ix;
	static int font[16];
	static int x,y,iy;

        /* Read current position */
	x = pcol;
	y = prow-4;

	if (JIS212) 
	{
		jfont3(index,font);	/* JIS-212  */
	}
	else
	{
		if (OldJIS)
		{
			if(index < 3490)
			{
				jfont(index,font);	/* JIS-1  */
			}
			else 
			{
				jfont2(index-3490,font);	/* JIS-2  */
			}
		}
		else
		{
			jfont(index,font);	/* JIS16  */
		}
	}

	/* display kanji -- font stored in TV scan format L->R, Top->Bottom */

	for(iy=0; iy< 16; iy++)
	{
		LRbits = font[iy];
		for(ix=0; ix< 16; ix++)
		{
    		if (LRbits & 1)
    		putpixel(ix+x, iy+y, Kcolour);
    		LRbits >>= 1;
		}
	}
	pcol += kfntspce;        /* Move 2 ASCII widths for next kanji */
}

/*=========string comparison function used in binary search ============*/
int Kstrcmp2()
{
	int c1,c2;
	int i;
/* effectively does a strnicmp on two "strings" , one in sch[] and the
   other pointed to by jindex(it)
   except it will make katakana and hiragana match (EUC A4 & A5) */

	for (i = 0; i<20 ; i++)
	{
		c1 = sch[i];
		c2 = dbchar(jindex(it)+i);
		if ((c1 == '\0')||(c2 == '\0')) return(0);
		if ((i % 2) == 0)
		{
			if (c1 == '\xA5')
			{
				c1 = '\xA4';
			}
			if (c2 == '\xA5')
			{
				c2 = '\xA4';
			}
		}
		if ((c1 >= 'A') && (c1 <= 'Z')) c1 |= '\x20'; /*fix ucase*/
		if ((c2 >= 'A') && (c2 <= 'Z')) c2 |= '\x20';
		if (c1 != c2 ) break;
	}
	return(c1-c2);
}
/*======function to test if this entry has already been displayed=====*/
int addhit(long spot)
{
	int i;
	for (i=0;i<=hitind;i++)
	{
		if(hittab[i] == spot) return(0);
	}
	if(hitind < HITSIZE-1) hitind++;
	hittab[hitind] = spot;
	return(1);
}

void jis2sjis(int *p1,int *p2)
{
    register unsigned char c1 = *p1;
    register unsigned char c2 = *p2;
    register int rowOffset = c1 < 95 ? 112 : 176;
    register int cellOffset = c1 % 2 ? 31 + (c2 > 95) : 126;

    *p1 = ((c1 + 1) >> 1) + rowOffset;
    *p2 = c2 + cellOffset;
}

		/* rectangle(0,maxy-60,maxx-2,maxy-24); */

void Vmsg(int mmode)
{
	int xp,yp1,yp2;

	putimage (4,maxy-55,bline,COPY_PUT);
	putimage (4,maxy-44,bline,COPY_PUT);
	xp = 4; yp1 = maxy-53; yp2 = maxy-38;

	switch (mmode)
	{

	case 1 :
outtextxy(xp,yp1,"Enter an English word, and press Enter to start the Search. Press F3 to");
outtextxy(xp,yp2,"to enter Japanese (hiragana/katakana) keys. See F1 for kanji selection.");
	break;
	case 2 :
outtextxy(xp,yp1,"Enter a Japanese word in Romaji, and press Enter to start the Search. Press");
outtextxy(xp,yp2,"F3 to toggle between English and kana modes. See F1 for kanji selection.");
	break;
	case 3 :
outtextxy(xp,yp1,"There are more entries to display for this key. Press M to see more entries,");
outtextxy(xp,yp2,"B to scan back up the dictionary, or A or Esc to enter a fresh search key.");
	break;
	case 4 :
outtextxy(xp,yp1,"You can now display compounds containing this kanji (A or F), or set the");
outtextxy(xp,yp2,"kanji as a filter for a later search (S). X or Esc returns to the prompt.");
	break;
	case 5 :
outtextxy(xp,yp1,"Use the arrow keys to position the cursor next to the kanji you want,");
outtextxy(xp,yp2,"and press Enter to select it. M continues, and X or Esc returns to prompt.");
	break;
	case 6 :
outtextxy(xp,yp1,"Position the marker next to the line that you wish to use, and press");
outtextxy(xp,yp2,"Enter (search key), L (log to a file) or E (display extended information)");
	break;
	case 7 :
outtextxy(xp,yp1,"Enter the reading of a kanji (in romaji), and press Enter to obtain");
outtextxy(xp,yp2,"a display of matching kanji. (Do not include okurigana.)");
	break;
	case 8 :
outtextxy(xp,yp1,"Enter the JIS code of a kanji as four hexadecimal digits, (preceded by 1");
outtextxy(xp,yp2,"for JIS X 0212), and press Enter.");
	break;
	case 9 :
outtextxy(xp,yp1,"Enter the Kuten code of a kanji as four decimal digits, and press Enter.");
outtextxy(xp,yp2," ");
	break;
	case 10 :
outtextxy(xp,yp1,"Enter the Shift-JIS code of a kanji as four hexadecimal digits, and press");
outtextxy(xp,yp2,"Enter.");
	break;
	case 11 :
outtextxy(xp,yp1,"Enter the Nelson index code of a kanji (numerics only) and press Enter.");
outtextxy(xp,yp2," ");
	break;
	case 12 :
outtextxy(xp,yp1,"Enter the Halpern index code of a kanji (numerics only) and press Enter.");
outtextxy(xp,yp2," ");
	break;
	case 13 :
outtextxy(xp,yp1,"Enter the Four-Corner index code of a kanji as 4 decimal digits and press");
outtextxy(xp,yp2,"Enter. ");
	break;
	case 14 :
outtextxy(xp,yp1,"Enter the SKIP index code of a kanji as 3 decimal numbers separated by `-',");
outtextxy(xp,yp2,"and press Enter. (+ and - repeats changing the last number up or down by 1.)");
	break;
	case 15 :
outtextxy(xp,yp1,"You have retrieved a previous search key. Press enter to repeat the search,");
outtextxy(xp,yp2,"edit the key, or press F4 for another key.");
	break;
	case 16 :
outtextxy(xp,yp1,"You have retrieved a previous kanji selection key. Press enter to repeat");
outtextxy(xp,yp2,"the display, or press Alt-F4 for another key.");
	break;
	case 17 :
outtextxy(xp,yp1,"You can activate/deactivate one of the filters by pressing its number");
outtextxy(xp,yp2,"followed by 1 to activate, and 0 to deactivate. Esc exits without change.");
	break;
	case 18 :
outtextxy(xp,yp1,"Specify a radical (bushu) by number, and press Enter. Then specify a ");
outtextxy(xp,yp2,"stroke (total) count (0 gets all). (+ & - can be used to vary repeats.)");
	break;
	case 19 :
outtextxy(xp,yp1,"Specify the (total) stroke count of a kanji, and press Enter.");
outtextxy(xp,yp2," ");
	break;
	case 20 :
outtextxy(xp,yp1,"The line has been copied to the logging-file. You can now type in");
outtextxy(xp,yp2,"up to 50 characters of text to go with the logged line.");
	break;
	case 21 :
outtextxy(xp,yp1,"You can initiate a search using this kanji, kana or English word as");
outtextxy(xp,yp2,"a key by pressing Enter. Press the space bar to see the next possible key.");
	break;
	case 22 :
outtextxy(xp,yp1,"Enter the number of strokes in the radicals you wish to see.");
outtextxy(xp,yp2," ");
	break;
	case 23 :
outtextxy(xp,yp1,"This is the main Help Screen. It gives a brief summary of all the");
outtextxy(xp,yp2,"possible commands.  Press any key to return to the main display.");
	break;
	case 24 :
outtextxy(xp,yp1,"Use the arrow keys to position the cursor next to the bushu you want,");
outtextxy(xp,yp2,"and press Enter to select it. M continues, and X or Esc returns to prompt.");
	break;
	case 25 :
outtextxy(xp,yp1,"Having selected a Bushu, you can specify a desired stroke count. For");
outtextxy(xp,yp2,"display of all Kanji with that bushu, press Enter. ");
	break;
	case 26 :
outtextxy(xp,yp1,"You can now switch to an alternative dictionary. The files available");
outtextxy(xp,yp2,"are listed above. Press the number of the one you want, Esc to return");
	break;
	case 27 :
outtextxy(xp,yp1,"There is more information about this entry. Press Enter to display");
outtextxy(xp,yp2,"the information, or press Esc to return to the normal dictionary.");
	break;
	case 28 :
outtextxy(xp,yp1,"That is the complete information about this entry. Press Enter to ");
outtextxy(xp,yp2,"return to the normal dictionary.");
	break;
	case 29 :
outtextxy(xp,yp1,"Type in a filter which will be applied to all searches (English or kana.)");
outtextxy(xp,yp2,"Press Enter to clear a previous Filter.");
	break;
	case 30 :
outtextxy(xp,yp1,"You can now display compounds containing this JIS X 0212 kanji (A or F)."); 
outtextxy(xp,yp2,"X or Esc returns to the prompt.");
	break;

	default :
outtextxy(xp,yp1,"        Help Information not available!");
	break;
	}
}

/*========kanaconv==convert romaji to kana==============================*/
int kanaconv(int rpos, int rlen)
{
/* rpos and rlen are the start and length of the romaji characters in
   array ksch.  Smode specifies hira or kata. If found, the kana is
   appended to ktarg and TRUE returned.                          */

	int koff,ki,ix;
	unsigned int khi,klo;

	koff = (Smode-1)*NRKANA;
	for(ki = 0; ki < rlen; ki++)
	{
		targ[ki] = ksch[rpos+ki];
	}
	targ[rlen] = 0;
	for (ki = koff; ki < koff+NRKANA; ki+=2)
	{
		if (strlen(targ) != strlen(kanatab[ki])) continue;
		if (stricmp(targ,kanatab[ki]) != 0) continue;
		strcat(ktarg,kanatab[ki+1]);
		pcolsav = pcol;
		pcol = pcolk;
		for (ix = 0; ix < strlen(kanatab[ki+1])-1;ix+=2)
		{
			khi = (kanatab[ki+1][ix]-128) & 0x7f;
			klo = (kanatab[ki+1][ix+1]-128) & 0x7f;
			OutKanji(jis2index(khi,klo));
		}
		pcolk = pcol;
		pcol = pcolsav;
		return (TRUE);
	}
	return(FALSE);
}
/*=====LoadKana===load up file of romaji to kana mappings===========*/
void LoadKana()
{
	int i,ih,mode;
	FILE *fp,*fopen();
	char kiadir[50],LKin[80],*ptr;

	for (i = 0; i < NRKANA*2; i++) strcpy(kanatab[i]," ");
	kiadir[0] = 0;
	if (strlen(kanjidir) > 1) strcpy(kiadir,kanjidir);
	strcat(kiadir,"romkana.cnv");
	fp=fopen(kiadir,"r");
	if (fp==NULL) Bomb("Cannot open ROMKANA.CNV\n");
	mode = 0;
	while (TRUE)
	{
		fgets(LKin,79,fp);
		if (feof(fp))break;
		LKin[strlen(LKin)-1] = '\0';
		if(LKin[0] == '#')continue;
		if((LKin[0] == '$')&&((LKin[1]|0x20) == 'h'))
		{
			mode = 0;
			ih = 0;
			continue;
		}
		if((LKin[0] == '$')&&((LKin[1]|0x20) == 'k'))
		{
			mode = 1;
			ih = 0;
			continue;
		}
		ptr = strtok(LKin," \t");
		strcpy(kanatab[mode*NRKANA+ih*2+1],ptr);
		ptr = strtok(NULL," \t\r\n");
		strcpy(kanatab[mode*NRKANA+ih*2],ptr);
		ih++;
		if(ih == NRKANA) Bomb("Too many romaji table entries!");
	}
	fclose(fp);
}

/*====GetColour====Convert colour name to ordinal=====================*/
int GetColour(char *s)
{
	int i;
	char cols[16][20] = {
		"black",
		"blue",
		"green",
		"cyan",
		"red",
		"magenta",
		"brown",
		"lightgray",
		"darkgray",
		"lightblue",
		"lightgreen",
		"lightcyan",
		"lightred",
		"lightmagenta",
		"yellow",
		"white"		};

	for (i = 0; i <16 ; i++)
	{
		if (strnicmp (s,cols[i],strlen(s)) == 0) return (i);
	}
	return(WHITE);
}

char DoFkey(char inpkey)
{
	int i;
	char inp;

	inp = inpkey;
	for(i = 0;i<nofkeys;i++) if (fkeymapsf[i] == inpkey) return(fkeymapst[i]);
	return(inp);
}

/*=====Rcfile - access and analyze "jdic.rc" or "moke.rc" file (if any)=====*/
int Rcfile(char *env, char *rcfile)
{
	char mokedir[128],rcstr[80],*rcwd,*ptr1,*ptr2;
	int hi,hk,ft,fn,rctemp;
	FILE *fm,*fopen();

	for (i=0;i<10;i++) hotkeylen[i] = 0;

	mokedir[0] = '\0';
	if (getenv(env)!= NULL)
	{
		strcpy(mokedir,getenv(env));
		strcat(mokedir,"\\");
	}
	strcat(mokedir,rcfile);
	fm = fopen(mokedir,"r");
	if (fm == NULL)
	{
		return(FALSE);
	}
	else
	{
  		for (i=0;i<NOFILT;i++)
  		{
  			filtact[i] = FALSE;
			filton[i] = FALSE;
  		}
		while(fgets(rcstr,79,fm) != NULL)
		{
			if (rcstr[strlen(rcstr)-1] < 0x20) rcstr[strlen(rcstr)-1]  = 0;
			rcwd = strtok(rcstr," \t");
			if( strnicmp("kanjipath",rcwd,9) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(kanjidir,rcwd);
				strcat(kanjidir,"\\");
				continue;
			}
			if( strnicmp("extfile",rcwd,7) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(EXTname,rcwd);
				strcpy(EXTJDXname,rcwd);
				strcat(EXTJDXname, ".jdx");
				continue;
			}
			if( strnicmp("verbose",rcwd,7) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				if (strnicmp("off",rcwd,3) == 0) Vmode = FALSE;
				continue;
			}
			if( strnicmp("dicfile",rcwd,7) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(DnameList[NoDics],rcwd);
				strcpy(JDXnameList[NoDics],strtok(rcwd," ."));
				strcat(JDXnameList[NoDics],".jdx");
				NoDics++;
				if (NoDics > 10) Bomb (" More than 10 dictionaries!");
				TestDic = FALSE;
				continue;
			}
			if( strnicmp("font24",rcwd,6) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(font24name,rcwd);
				continue;
			}
			if( strnicmp("bgipath",rcwd,7) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(BGIDir,rcwd);
				continue;
			}
			if( strnicmp("kanjicolor",rcwd,10) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				Kcolour = GetColour(rcwd);
				continue;
			}
			if( strnicmp("asciicolor",rcwd,10) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				Acolour = GetColour(rcwd);
				continue;
			}
			if( strnicmp("backcolor",rcwd,9) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				Bcolour = GetColour(rcwd);
				continue;
			}
			if( strnicmp("progcolor",rcwd,9) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				Pcolour = GetColour(rcwd);
				continue;
			}
			if( strnicmp("graphicstype",rcwd,12) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				if(strnicmp(rcwd,"ATT",3) == 0) attflag = TRUE;
				continue;
			}
			if( strnicmp("fkey",rcwd,4) == 0) 
			{
				rcwd = strtok(NULL," \t\f\r\n");
				if ((rcwd[0] | 0x20) == 'f') fkeymapsf[nofkeys] = 0x3a+atoi(rcwd+1);
				if ((rcwd[0] | 0x20) == 'a') fkeymapsf[nofkeys] = 0x67+atoi(rcwd+1);
				if ((rcwd[0] | 0x20) == 'c') fkeymapsf[nofkeys] = 0x5d+atoi(rcwd+1);
				rcwd = strtok(NULL," \t\f\r\n");
				if ((rcwd[0] | 0x20) == 'f') fkeymapst[nofkeys] = 0x3a+atoi(rcwd+1);
				if ((rcwd[0] | 0x20) == 'a') fkeymapst[nofkeys] = 0x67+atoi(rcwd+1);
				if ((rcwd[0] | 0x20) == 'c') fkeymapst[nofkeys] = 0x5d+atoi(rcwd+1);
				nofkeys++;
				continue;
			}
			if( strnicmp("halpern",rcwd,7) == 0) 
			{
				NHmode = FALSE;
				continue;
			}
			if( strnicmp("fontspace",rcwd,9) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				rctemp = rcwd[0] -'0';
				if ((rctemp == 0)||(rctemp==2)||(rctemp==4))
				{
					kfntspce = 16+rctemp;
					afntspce = kfntspce/2;
				}
				continue;
			}
			if( strnicmp("jdicmode",rcwd,8) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				rcwd[0] = rcwd[0] | 0x20;
				if((rcwd[0] == 'a') || (rcwd[0] == 'e')) Smode = 0;
				if(rcwd[0] == 'h') Smode = 1;
				if(rcwd[0] == 'k') Smode = 2;
				continue;
			}
			if (strnicmp("kmacro",rcwd,6) == 0)
			{
				if ((rcwd[6] < '0') || (rcwd[6] > '9')) continue;
				hi = rcwd[6] - '0';
				rcwd = strtok(NULL," \t");
				hotkeylen[i] = 0;
				while (rcwd != NULL)
				{
					if (strlen(rcwd) == 1) hotkeys[hi][hotkeylen[hi]++] = rcwd[0];
					if (strlen(rcwd) == 2) 
					{
						if (rcwd[0] == '_')
						{
							if ((rcwd[1] | 0x20) == 'e') hotkeys[hi][hotkeylen[hi]++] = 0x1b;
							if ((rcwd[1] | 0x20) == 'r') hotkeys[hi][hotkeylen[hi]++] = '\r';
							if ((rcwd[1] | 0x20) == 's') hotkeys[hi][hotkeylen[hi]++] = ' ';
						}
						else
						{
							hk = 0x44;
							if ((rcwd[1] | 0x20) > '0') hk = 0x3b + rcwd[1] - '1';
							hotkeys[hi][hotkeylen[hi]++] = 0;
							hotkeys[hi][hotkeylen[hi]++] = hk;
						}
					}
					if ((strlen(rcwd) == 3) && (rcwd[1] == '_'))
					{
						hk = 0x68;
						if ((rcwd[0] | 0x20) == 'c') hk = 0x5e;
						hk = hk + rcwd[2] - '1';
						if (rcwd[2] == '0') hk+=10;
						hotkeys[hi][hotkeylen[hi]++] = 0;
						hotkeys[hi][hotkeylen[hi]++] = hk;
					}
					rcwd = strtok(NULL," \t");
				}
			}
			if (strnicmp("jdicfilt",rcwd,8) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				sscanf(rcwd,"%d",&fn);
				if ((fn < 0)||(fn > NOFILT)) continue;
				rcwd = strtok(NULL," \t\f\r\n");
				sscanf(rcwd,"%d",&ft);
				if (ft > 2) continue;
				filttype[fn] = ft;
				rcwd = strtok(NULL," \t\f\r\n");
				filton[fn] = FALSE;
				if(strnicmp("on",rcwd,2) == 0) 
				{
					filton[fn] = TRUE;
					nofilts  = TRUE;
				}
				rcwd = strtok(NULL,"\"");
				strcpy(filtnames[fn],rcwd);
				ft=0;
				rcwd = strtok(NULL," \t\f\r\n");
				while(rcwd != NULL)
				{
					strcpy(filtcodes[fn][ft],rcwd);
					ft++;
					rcwd = strtok(NULL," \t\f\r\n");
				}
				if(ft==0)continue;
				filtcoden[fn] = ft;
				filtact[fn] = TRUE;
				continue;
			}
		}
	}
	fclose(fm);
	if(strlen(kanjidir) > 1)
	{
		strcpy(Dname,kanjidir);
		strcpy(Dname2,kanjidir);
		strcpy(JDXname,Dname);
		strcpy(JDXname2,Dname);
		strcat(Dname,"edict");
		strcat(Dname2,"jtoe.dct");
		strcat(JDXname,"edict.jdx");
		strcat(JDXname2,"jtoe.jdx");
	}
	return(TRUE);
}

/*=====WordOut====display a word, folding line if necessary========*/
void WordOut(char *ops)
{
	int sl;
	
	if (ops[0] == SPTAG)
	{
		setcolor(Kcolour);
		KIAcolour = Kcolour;
		strcpy(ops,ops+1);
	}
	sl = strlen(ops);
	if (sl*afntspce+pcol > maxx-11)
	{
		if ((strlen(ops) == 1) && (ops[0] == ' '))
		{
			ops[0] = 0;
			return;
		}
		pcol = 40;
		prow+=17;
		Fold = TRUE;
	}
	kouttextxy(pcol,prow,ops);
	pcol=pcol+sl*afntspce;
	ops[0] = 0;
	setcolor(Acolour);
	KIAcolour = Acolour;
}

/*====kouttextxy===emulates outtextxy using kiascii fonts==========*/
void kouttextxy(int kx, int ky, char *s)
{
	int ift,fr,fc,i,ib,bit,jiaoff,fce,byte;

	if (Bfont)   /* if this font is disabled use bgi fonts   */
	{
		outtextxy(kx,ky,s);
		return;
	}
	for (i = 0 ; i < strlen(s); i++)
	{

		jiaoff = s[i];
		jiaoff *= BPCH;
		ift = 0;
		for ( fr = 0; fr < 14; fr++)
		{
			fce = 0;
			for (fc = 0; fc >=0; fc--)
			{
				byte = kiain[jiaoff+ift+fc];
				for(ib = 0;ib < 8;ib++)
				{
					bit = byte & 1;
					if (bit)putpixel(kx+i*afntspce+fce,ky+fr-4,KIAcolour);
					byte >>= 1;
					fce+=1;
				}
			}
			ift=ift+1;
		}
	}
}

/*===kiaset====read in kiascii font file (if necessary)============*/
void kiaset()
{

	FILE *fp,*fopen();
	char kiadir[50];
	if(Bfont)return;   /* using bgi fonts  */
	kiadir[0] = 0;
	if (strlen(kanjidir) > 1) strcpy(kiadir,kanjidir);
	strcat(kiadir,"kiascii.fnt");
	fp=fopen(kiadir,"rb");
	if (fp == NULL) Bomb("Cannot open kiascii.fnt file");
	fread(kiain,BPCH*128,1,fp);
	fclose(fp);
}

/*====waitch===wait for keypress, flush if Fn, etc===================*/
char waitch()
{
	char wc;
	wc = getchx();
	if (wc != 0) return(wc);
	wc = getchx();
	return(wc);
}

/*=====HOutx=== display a line of the help screen (Esc exit)========*/
int HOutx(char *s)
{
	char c;

	if(HRow >= maxr-32)
	{
		putimage (4,maxy-20,bline,COPY_PUT);
		outtextxy(10,maxy-14,"Press any key to continue (Esc to exit).");
		HRow = 16;
		c=getchx();
		if(c == 0) c=getchx();
		InitScr();
		if (c == 0x1b) return (TRUE);
	}
	outtextxy(10,HRow,s);
	HRow+=12;
	return (FALSE);
}
/*=====HOut=== display a line of the help screen===================*/
void HOut(char *s)
{
	char c;

	if(HRow >= maxr-32)
	{
		putimage (4,maxy-20,bline,COPY_PUT);
		outtextxy(10,maxy-14,"Press any key to continue.");
		HRow = 16;
		c=getchx();
		if(c == 0) c=getchx();
		InitScr();
	}
	outtextxy(10,HRow,s);
	HRow+=12;
}

/*===DispSK== Common code to display current search==================*/

void DispSK(char *skl)
{
	unsigned int khi,klo;
	putimage (4,maxy-20,bline,COPY_PUT);
	prowa = maxy-14;
	prow = maxy-16;
	pcol = 245;
	pcolk = maxx-300;
	outtextxy(10,prowa,Stype[Smode]);
	outtextxy(40,prowa,"Search Key (Esc to quit): ");
  	outtextxy(maxx-136,prowa,"[F1 for Help]");
	if (skl[0] <= 127)
	{
		for (i = 0; i < strlen(skl); i++)
		{
			ops[0] = skl[i];
			ops[1] = 0;
			outtextxy(pcol,prowa,ops);
			pcol+=afntspce;
		}
		is = strlen(skl);
	}
	else
	{
		pcolsav = pcol;
		pcol = pcolk;
		for (i = 0; i < strlen(skl)-1;i+=2)
		{
			if (skl[i] == 0x8f)
			{
				JIS212 = TRUE;
				khi = (skl[i+1]-128) & 0x7f;
				klo = (skl[i+2]-128) & 0x7f;
				i++;
			}
			else
			{
				khi = (skl[i]-128) & 0x7f;
				klo = (skl[i+1]-128) & 0x7f;
			}
			OutKanji(jis2index(khi,klo));
			JIS212 = FALSE;
		}
		pcolk = pcol;
		pcol = pcolsav;
	}
}

void UserKeys()
{
	int i,j,kn1,kn2;
	char c,ops[80],kc1[8],kc2[8];

	HRow+=4;
	HOut("User Mapped Function Keys");
	HRow+=6;
	for (i = 0; i < nofkeys; i++)
	{
		j = fkeymapsf[i];
		if ((j >= 0x3b) && (j <= 0x44)) 
		{
			strcpy(kc1,"F");
			kn1 = j-0x3a;
		}
		if ((j >= 0x68) && (j <= 0x71)) 
		{
			strcpy(kc1,"Alt-F");
			kn1 = j-0x67;
		}
		if ((j >= 0x5e) && (j <= 0x67)) 
		{
			strcpy(kc1,"Ctrl-F");
			kn1 = j-0x5d;
		}
		j = fkeymapst[i];
		if ((j >= 0x3b) && (j <= 0x44)) 
		{
			strcpy(kc2,"F");
			kn2 = j-0x3a;
		}
		if ((j >= 0x68) && (j <= 0x71)) 
		{
			strcpy(kc2,"Alt-F");
			kn2 = j-0x67;
		}
		if ((j >= 0x5e) && (j <= 0x67)) 
		{
			strcpy(kc2,"Ctrl-F");
			kn2 = j-0x5d;
		}
		sprintf (Bmsg,"%s%d is mapped to %s%d",kc1,kn1,kc2,kn2);
		HOut(Bmsg);
	}
	HRow+=5;
}

/*=====GetKey====collect search key from keyboard. Convert to kana.======*/

void GetKey()
{
	int ho,i,j,k,ksp,khi,klo;
	char fff[4],c,ops[80],kc1[8],kc2[8];
	char ts1[10],ts2[10],ts3[10];

	Kmsg = 5;
	FirstKanj = TRUE;
	KHFlag = FALSE;
	histflag = FALSE;
	histout = currhist;
	khistout = kcurrhist;
	KHTIndex = 0;
	KHVIndex = 0;
	SJis = FALSE;
/* collect the search string   */
  is = 0;
  ksp = 0;
  c = 0;
  ktarg[0] = 0;
  wild = FALSE;
  while (TRUE)   /* loop until Enter is pressed   */
  {
	if (ksp != 0)    /* tidy up after last romaji->kana conversion by
	                    removing and blanking converted ascii    */
	{
		strcpy(sch,ksch+ksp);
		strcpy(ksch,sch);
		strcpy(ops,sch);
		putimage(245,prowa-8,kblank,COPY_PUT);
		outtextxy(245,prowa,ops);
		pcol = pcol - ksp*afntspce;
		is = is-ksp;
		ksp=0;
	}
	c = getchx();
	if (c == '\r') break;	/* end of input */

/* ESC = premature end */
	if (c == 0x1b)
	{
		putimage (4,maxy-20,bline,COPY_PUT);
		outtextxy(4,maxy-14,"Esc Pressed! Press Y or Esc to Exit, any other to Continue");
		c = getchx();
		if ((c == 0x1b)||(c=='y')||(c=='Y'))
		{
			closegraph();
			exit(0);
		}
		else 
		{
			if(strlen(ktarg) > 0) 
			{
				DispSK(ktarg);
			}
			else
			{
				DispSK(sch);
			}
		}
		continue;
	}
/* Ctrl J  change from ascii to kana */
	if (c == 0x0A)
	{
		if(Smode == 0)
		{
			Smode = 1;
			putimage(10,prowa,lblank,COPY_PUT);
			outtextxy(10,prowa,Stype[Smode]);
		}
  		if (Vmode)
  		{
  			if(Smode == 0) Vmsg(1);
  			if(Smode != 0) Vmsg(2);
  		}
		continue;
	}
/* an "l" in kana mode will change to ascii  */
	if ((c == 'l')&&(Smode > 0))
	{
		Smode = 0;
		putimage(10,prowa,lblank,COPY_PUT);
		outtextxy(10,prowa,Stype[Smode]);
  		if (Vmode)
  		{
  			if(Smode == 0) Vmsg(1);
  			if(Smode != 0) Vmsg(2);
  		}
		continue;
	}
/* a "q" in kana mode will toggle between hiragana & katakana  */
	if ((c == 'q')&&(Smode > 0))
	{
		Smode  = (Smode % 2)+1;
		putimage(10,prowa,lblank,COPY_PUT);
		outtextxy(10,prowa,Stype[Smode]);
		continue;
	}
/* leading character == 0 => function key   */
	if (c == 0)
	{
		c = DoFkey(getchx());  /* Remap Fn keys (if any) */

		if ((c >= 0x78) && (c <= 0x81))  /* hotkey trigger*/
		{
			hotkeyact = TRUE;
			hotkeyind = c - 0x77;
			if (c == 0x81) hotkeyind = 0;
			hotkeypos = 0;
			continue;
		}
		if (c == 0x3d)      /*F3  - toggle input mode */
		{
			Smode = (Smode+1) % 3;
			putimage(10,prowa,lblank,COPY_PUT);
			outtextxy(10,prowa,Stype[Smode]);
			c = 0;
  			if (Vmode)
  			{
  				if(Smode == 0) Vmsg(1);
  				if(Smode != 0) Vmsg(2);
  			}
			continue;
		}
		if (c == 0x5e)		/*Ctrl F1 - toggle "verbose" mode */
		{
			if (Vmode)
			{
				Vmode = FALSE;
			}
			else
			{
				Vmode = TRUE;
			}
			ReDoScr = TRUE;
			return;
		}
		if (c == 0x67)		/*Ctrl F10 - turn on endless display mode */
		{
			wild = TRUE;
			outtextxy(maxx-32,prowa,"[U]");
			continue;
		}
		if (c == 0x60)		/*Ctrl F3 - Display Status Information */
		{
			InitScr();
			HRow = 30;

			HOut("          J D I C   S T A T U S");
			HRow+=4;
			sprintf (Bmsg,"Dic: %s  Fnts: %s ",Dname,fontfilename);
			if (!Bfont)
			{
				strcat(Bmsg,kanjidir);
				strcat(Bmsg,"kiascii.fnt");
			}
			HOut(Bmsg);
			sprintf (Bmsg,"Page buffers: %d  Page Faults: (Dic) %d (Ind) %d (Fonts) %d",novbuff,vbrd,vbri,vbrf);
			HOut(Bmsg);
			sprintf (Bmsg,"Extension file: %s  ",EXTname);
			strcpy(ts1,"(Closed)");
			if (Extopen) strcpy(ts1,"(Open)");
			strcat(Bmsg,ts1);
			HOut(Bmsg);
			strcpy(ts1,"Nelson");
			if (!NHmode) strcpy(ts1,"Halpern");
			strcpy(ts2,"English");
			if (Smode ==1)strcpy(ts2,"Hiragana");
			if (Smode ==2)strcpy(ts2,"Katakana");
			strcpy(ts3,"OFF");
			if (Vmode) strcpy(ts3,"ON");
			sprintf (Bmsg,"Input Mode: %s  Kanji Display Mode: %s  On-line Help Mode: %s",ts2,ts1,ts3);
			HOut(Bmsg);
			HRow+=8;
			i=0;
			for(j = 0;j < NOFILT;j++)
			{
				if(!filtact[j])continue;
				if(!filton[j])continue;
				sprintf(ops,"No: %d Type: %d  Name: %s",j,filttype[j],filtnames[j]);
				if (i == 0)
				{
					HOut("Active Filter Settings");
					i=1;
				}
				HOut(ops);
			}
			if (i==0) HOut("No Filters Active");
			if (nofkeys > 0) UserKeys();
			HRow+=8;
HOut("  Press any key to return to the Dictionary ......");
			c = waitch();
			ReDoScr = TRUE;
			return;
		}
		if (c == 0x3e)		/* F4 - Pop a previous search  */
		{
			if (histout == 0) continue;
			histflag = TRUE;
			histout--;
			strcpy(sch,hist_line[histout ]);
			strcpy(ktarg,hist_line[histout ]);
			ksp = 0;
			DispSK(sch);
			if (Vmode) Vmsg(15);
			continue;
		}
		if (c == 0x6a)		/* Alt F3  - Toggle English & Priority  */
		{
			if(EPmode)
			{
				EPmode = FALSE;
			}
			else
			{
				EPmode = TRUE;
			}
			putimage(8,5,kblank,COPY_PUT);
			if (EPmode) outtextxy(4,5,EPtype);
			continue;
		}
		if (c == 0x5f)		/* Ctrl-F2 - Clear & set one-off filter   */
		{
			SFFlag = TRUE;
			putimage(18,5,kblank,COPY_PUT);
			if (Vmode) Vmsg(29);
			putimage (4,maxy-20,bline,COPY_PUT);
			strcpy(Bmsg,"Filter: ");
			outtextxy(10,prowa,Bmsg);
			pcol = 245;
			if (Smode == 0)
			{
				GetKBStr(SingleFilter);
			}
			else
			{
				prowa = maxy-14;
				GetYomi(Smode);
				strcpy(SingleFilter,ktarg);
			}
			if(strlen(SingleFilter) == 0) SFFlag = FALSE;
			if (SFFlag) outtextxy(25,5,"[F]");
			ReDoScr = TRUE;
			return;
		}

		if (c == 0x62)		/* Ctrl-F5 - Toggle JIS Display Mode  */
		{
			if (JISDisp)
			{
				JISDisp = FALSE;
				NHmess[2] = ' ';
			}
			else
			{
				JISDisp = TRUE;
				NHmess[2] = 'J';
			}
			putimage(maxx-20,5,blank,COPY_PUT);
			outtextxy(maxx-28,5,NHmess);
			continue;
		}
		if (c == 0x61)		/* Ctrl-F4 - Toggle Nelson & Halpern Modes  */
		{
			if(NHmode)
			{
				NHmode = FALSE;
				NHmess[1] = 'H';
			}
			else
			{
				NHmode = TRUE;
				NHmess[1] = 'N';
			}
			putimage(maxx-20,5,blank,COPY_PUT);
			outtextxy(maxx-28,5,NHmess);
			continue;
		}
		if ((c >= 0x3f)&&(c <= 0x44))	/* F5-10  Kanji Indexed Search   */
		{
			Kindex = 0x42-c;
			KDirect = FALSE;
			KIndex = TRUE;
			Halpf = FALSE;
			Kutenf = FALSE;
			rstroke = 0;
			return;
		}
		if (c == 0x6b)  /* Alt F4  Retrieve from Kanji Search History   */
		{
			sch[0] = 0;
			ktarg[0] = 0;
			if (khistout == 0) continue;
			khistflag = TRUE;
			khistout--;
			i = KHType[khistout];
			j = KHVal [khistout];
			putimage (4,maxy-20,bline,COPY_PUT);
			if (Vmode) Vmsg(16);
			switch(i)
			{
				case 1 :
					sprintf(ops,"Kanji History Selection - Bushu: %d Stroke: %d ",j/100,j % 100);
					outtextxy(10,maxy-14,ops);
					break;
				case 2 :
					sprintf(ops,"Kanji History Selection - Strokes: %d ",j);
					outtextxy(10,maxy-14,ops);
					break;
				case 3 :
					sprintf(ops,"Kanji History Selection - Nelson: %d ",j);
					outtextxy(10,maxy-14,ops);
					break;
				case 4 :
					sprintf(ops,"Kanji History Selection - Halpern: %d ",j);
					outtextxy(10,maxy-14,ops);
					break;
				case 5 :
					sprintf(ops,"Kanji History Selection - JIS: %x%x",j >> 8,j&0xff);
					outtextxy(10,maxy-14,ops);
					break;
				case 6 :
					sprintf(ops,"Kanji History Selection - Kuten: %d ",j);
					outtextxy(10,maxy-14,ops);
					break;
				case 7 :
					sprintf(ops,"Kanji History Selection - Yomikata:");
					outtextxy(10,maxy-14,ops);
					strcpy(ktarg,KHYomi[khistout]);
					pcol = 15+strlen(ops)*8;
					for(j=0;j<strlen(KHYomi[khistout]);j+=2)
						OutKanji(jis2index(KHYomi[khistout][j]&0x7f,KHYomi[khistout][j+1]&0x7f));
					break;
				case 8 :
					sprintf(ops,"Kanji History Selection - Kanji:");
					outtextxy(10,maxy-14,ops);
					pcol = 18+strlen(ops)*8;
					OutKanji(jis2index((j >> 8)&0x7f,j&0x7f));
					break;
				case 9 :
					sprintf(ops,"Kanji History Selection - Four Corner Code: %d ",j);
					outtextxy(10,maxy-14,ops);
					break;
				case 10 :
					sprintf(ops,"Kanji History Selection - SKIP Code: %d-%d-%d ",j/900,(j % 900)/30,(j % 30));
					outtextxy(10,maxy-14,ops);
					break;
				case 11 :
					sprintf(ops,"Kanji History Selection - SJIS: %x%x",(j >> 8) & 0xff,j & 0xff);
					outtextxy(10,maxy-14,ops);
					break;
				case 12 :
					sprintf(ops,"Kanji History Selection - JIS 212 Kanji:");
					outtextxy(10,maxy-14,ops);
					pcol = 18+strlen(ops)*8;
					JIS212 = TRUE;
					OutKanji(jis2index((j >> 8)&0x7f,j&0x7f));
					JIS212 = FALSE;
					break;
				default :
					sprintf(ops,"Error! Value %d %X%X at stack pos %d",i,i>>8,i&0xff,khistout);
					outtextxy(10,maxy-14,ops);
					waitch();
					break;
			}
			c = getchx();
			if (c == '\r')
			{
				KIndex = TRUE;
				KHTIndex = i;
				KHVIndex = j;
				return;
			}
			if (c == 0x1b) 
			{
				ReDoScr = TRUE;
				return;
			}
			is = c;
			ungetch(is);
			continue;
		}
		if (c == 0x6c)  /* Alt F5  Radical display with starting Stroke Count */
		{
			Kindex = 3;
			KDirect = FALSE;
			KIndex = TRUE;
			Halpf = FALSE;
			Kutenf = FALSE;
			putimage (4,maxy-20,bline,COPY_PUT);
			outtextxy(10,maxy-14,"Initiating Radical Display");
			if (Vmode) Vmsg(22);
			rstroke = GetNo("Strokes (0 for all): ");
			Kmsg = 24;
			return;
		}
		if (c == 0x6d)  /* Alt F6  Four Corner Search */
		{
			KIndex = TRUE;
			KDirect = FALSE;
			Kindex = 4;
			Halpf = FALSE;
			return;
		}
		if (c == 0x6e)  /* Alt F7  SKIP Code Search */
		{
			KIndex = TRUE;
			KDirect = FALSE;
			Kindex = 5;
			Halpf = FALSE;
			return;
		}
		if (c == 0x6f)  /* Alt F8  Halpern Search */
		{
			KIndex = TRUE;
			KDirect = FALSE;
			Kindex = 0;
			Halpf = TRUE;
			return;
		}
		if (c == 0x70)  /* Alt F9 Kuten Search  */
		{
			KIndex = TRUE;
			KDirect = FALSE;
			Kindex = -1;
			Kutenf = TRUE;
			return;
		}		
		if (c == 0x66)  /* Ctrl F9 Shift-JIS Search  */
		{
			KIndex = TRUE;
			KDirect = FALSE;
			Kindex = -1;
			Kutenf = FALSE;
			SJis = TRUE;
			return;
		}		
		if (c == 0x71)  /* Alt F10 Pick a key from screen and/or log line */
		{
			KIndex = TRUE;
			Halpf = FALSE;
			Kutenf = FALSE;
			if (Vmode) Vmsg(6);
			if(!DoGetD()) KIndex = FALSE; /* either no key or non-kanji*/
			return;
		}
		if (c == 0x69)		/* Alt-F2 Select Alt Dictionary */
		{
			InitScr();
			if (Vmode) Vmsg(26);
			ReDoScr = TRUE;			
			if (!MultDic)
			{
				outtextxy(10,30,"No alternative dictionaries available!");
outtextxy(10,40,"  Press any key to return to the Dictionary ......");
				c=waitch();
				return;
			}
			outtextxy(30,30,"Alternative Dictionary Selection");
			i = 45;
			for (j = 0; j<=NoDics;j++)
			{
				sprintf(Bmsg,"No: %d %s",j,DnameList[j]);
				outtextxy(10,i,Bmsg);
				i+=15;
			}
			i+=5;
			outtextxy(10,i,"Enter the number of the new Dictionary, or Esc to exit without change:");
			c = getchx();
			if (c == 0x1b)return;
			j = c-'0';
			if ((j >= 0) && (j <= NoDics))
			{
				strcpy(Bmsg,"No: X Selected  Press any key to continue...");
				Bmsg[4] = c;
				outtextxy(10,i+15,Bmsg);
				NHmess[0] = c;
				fclose(fpd);
				fclose(fpi);
				strcpy(Dname,DnameList[j]);
				strcpy(JDXname,JDXnameList[j]);
				for (j = 0;j<MAXDICTAB;j++)
				{
					if(doffp[j] != -1)
					{
						usebuff[doffp[j]] = -1;
						doffp[j] = -1;
					}
				}
				for (j = 0;j<MAXJDXTAB;j++)
				{
					if(joffp[j] != -1)
					{
						usebuff[joffp[j]] = -1;
						joffp[j] = -1;
					}
				}
				DicSet();
				waitch();
				return;
			}
			else
			{
				outtextxy(10,i+15,"INVALID! .... press any key to return");
				waitch();
				return;
			}
		}
		if (c == 0x3c)		/* F2  Set Filter(s)   */
		{
			InitScr();
			if (Vmode) Vmsg(17);
			ReDoScr = TRUE;			
			i = 45;
			outtextxy(10,30,"Filter Setting        (Press Esc to return without change)");
			for(j = 0;j < NOFILT;j++)
			{
				if(!filtact[j])continue;
				strcpy(fff,"OFF");
				if(filton[j])strcpy(fff,"ON ");
				sprintf(ops,"No: %d Type: %d Status: %s Name: %s",j,filttype[j],fff,filtnames[j]);
				outtextxy(15,i,ops);
				i+=15;
			}
			outtextxy(15,i,"Modify which Filter?");
			c = getchx();
			if (c ==  0x1b) return;
			k = c-'0';
			if ((k <0)||(k >NOFILT))
			{
				outtextxy(220,i,"INVALID!");
outtextxy(10,210,"  Press any key to return to the Dictionary ......");
				c=waitch();
				return;
			}
			ops[0] = c;
			ops[1] = 0;
			outtextxy(200,i,ops);
			i+=15;
			outtextxy(15,i,"OFF (0) or ON (1)");
			c = getchx();
			if (c == 0x1b)return;
			ops[0] = c;
			outtextxy(200,i,ops);
			if(c == '0') 
			{
				filton[k] = FALSE;
				outtextxy(220,i,"OFF");
			}
			if(c == '1')
			{
				filton[k] = TRUE;
				outtextxy(220,i,"ON");
			}
outtextxy(10,i+25,"  Press any key to return to the Dictionary ......");
			c = waitch();			
			nofilts = FALSE;
			for(j = 0;j < NOFILT;j++)if(filton[j])nofilts=TRUE;
			return;
		}
		if (c == 0x68)		/* Alt-F1 Documentation Display	*/
		{
			InitScr();
			HRow = 30;

			fhd = fopen(docfilename, "r");
			if (fhd == NULL)
			{
				sprintf(Bmsg,"Unable to open: %s",docfilename);
				Bomb(Bmsg);
			}
			while(!feof(fhd))
			{
				fgets(ops,79,fhd);
				if(feof(fhd)) break;
				if (ops[strlen(ops)-1] < 0x20) ops[strlen(ops)-1] = 0;
				if (HOutx(ops)) break;
			}

			fclose(fhd);
			HRow+=2;
			HOut("  Press any key to return to the Dictionary ......");
			c = waitch();
			ReDoScr = TRUE;
			return;
		}
			
		if (c == 0x3b)		/* F1  Help Screen             */
		{
			InitScr();
			if (Vmode) Vmsg(23);
			HRow = 30;
			fhd = fopen(helpfilename, "r");
			if (fhd == NULL)
			{
				sprintf(Bmsg,"Unable to open: %s",helpfilename);
				Bomb(Bmsg);
			}
			while(!feof(fhd))
			{
				fgets(ops,79,fhd);
				if(feof(fhd)) break;
				if (ops[strlen(ops)-1] < 0x20) ops[strlen(ops)-1] = 0;
				HOut(ops);
			}
			fclose(fhd);
			HRow+=2;
			if (nofkeys > 0) UserKeys();
			HOut("  Press any key to return to the Dictionary ......");
			c = waitch();
			ReDoScr = TRUE;
			return;
		}
	}
	/* at this point, if a previous search key has been retrieved, it
	is about to be edited, so force it to be saved	*/
	histflag = FALSE;

	if (c == 0x8)  /* backspace  */
	{
		if (Smode == 0)    /* ascii mode - simple */
		{
			if ( is > 0 )
			{
				sch[is-1] = '\0';
				c = ' ';
				is--;
				pcol -= afntspce;
				putimage(pcol,prowa,blank,COPY_PUT);
				continue;
			}
		}
		else
		{
			if (is != 0)  /* kana mode - back over a romaji  */
			{
				sch[is-1] = '\0';
				ksch[is-1] = '\0';
				c = ' ';
				is--;
				pcol -= afntspce;
				putimage(pcol,prowa,blank,COPY_PUT);
				continue;
			}
			else
			{
				if (strlen(ktarg) != 0)  /* kana mode - back over a kana  */
				{
					ktarg[strlen(ktarg)-2] = '\0';
					pcolk-=kfntspce;
					putimage(pcolk,prow-4,kblank,COPY_PUT);
					continue;
				}
			}
		}
	}
	if (c > 32)   /* ordinary character - store and display   */
	{
		sch[is] = c;
		sch[is+1] = '\0';
		ksch[is] = c;
		ksch[is+1] = '\0';
		ops[0] = c;
		ops[1] = '\0';
		outtextxy(pcol,prowa,ops);
		pcol += afntspce;
		is++;
  	}
	strlwr(sch);
	strlwr(ksch);
	if ((Smode != 0) && (ksp != is))
	{

/* the input string so far is now parsed for romaji -> kana conversions.
   function "kanaconv" is used for the various sub-strings    */

/* if there is an "nn", "nm" or "mm", convert to first to "q" to force it to be
   converted to a kana "n"   */
		if ((ksch[ksp] == 'n')&&(ksch[ksp+1] == 'n')) ksch[ksp] = 'q';
		if ((ksch[ksp] == 'm')&&(ksch[ksp+1] == 'm')) ksch[ksp] = 'q';
		if ((ksch[ksp] == 'm')&&(ksch[ksp+1] == 'n')) ksch[ksp] = 'q';
		if ((ksch[ksp] == 'n')&&(ksch[ksp+1] == 'm')) ksch[ksp] = 'q';
/* if there is "nx", where "x" is not a vowel or a "y", force the "n".  */
		if (((ksch[ksp] == 'm') || (ksch[ksp] == 'n')) && (ksch[ksp+1] != 0))
		{
			c = ksch[ksp+1];
			if((c!='y')&&(c!='a')&&(c!='e')&&(c!='i')&&(c!='o')&&(c!='u')&&(c!='\''))
			{
				ksch[ksp] = 'q';
			}
		}
		if(kanaconv(ksp,1))  /*  match on a,e,i,o,u,q or -  ?  */
		{
			ksp++;
			continue;
		}
		if (ksch[ksp] == ksch[ksp+1])  /* double consonant - force small
						 "tsu" */
		{
			ksch[ksp] = '*';
			kanaconv(ksp,1);
			ksp++;
			continue;
		}
		if(kanaconv(ksp,2))  /* match on two letter syllable   */
		{
			ksp+=2;
			continue;
		}
		if(kanaconv(ksp,3))  /*match on 3 letter syllable    */
		{
			ksp+=3;
			continue;
		}
		if(kanaconv(ksp,4))  /*match on 4 letter syllable    */
		{
			ksp+=4;
			continue;
		}
	}		/* end of rom->kana */
  }			/* end of while loop */
  if ((Smode !=0)&&(ksch[ksp] =='n'))  /*flush out a trailing "n"*/
  {
	ksch[ksp] = 'q';
	kanaconv(ksp,1);
  }

  if (Smode!= 0) strcpy(sch,ktarg);
  if (sch[0] < 128) 
  {
	sch[6] = 0;  /*truncate overlong ascii keys */
  }
  else
  {
  	sch[12] = 0; /* truncate kana keys */
  }
  if (histflag) return;
  AddHist(sch);
  if ((Smode == 0) && EPmode)
  {
			j = strlen(sch);
			strcpy(ksch,sch);
			sch[j+1] = 0;
			for (i=0 ; i < j ; i++) sch[i+1] = ksch[i];
			sch[0] = SPTAG;
			sch[6] = 0;
  }
}

void AddHist(char *sch)
{

  int i;

  if (currhist == NOHIST)
  {
  	currhist--;
	for(i=0;i < NOHIST-1;i++) strcpy(hist_line[i], hist_line[i+1]);
  }
  strcpy(hist_line[currhist++],sch);
  histout = currhist;
}

/*===AddKH===add kanji search details to history list===============*/
void AddKH(khtype,khval)
{
	int h;

    if (kcurrhist == NOHIST)
    {
  	    kcurrhist--;
	    for(h=0;h < NOHIST-1;h++) 
		{
			KHType[h] = KHType[h+1];
			KHVal [h] = KHVal [h+1];
			strcpy(KHYomi[h],KHYomi[h+1]);
		}
    }
	KHType[kcurrhist] = khtype;
	KHVal [kcurrhist] = khval ;
	strcpy(KHYomi[kcurrhist],ktarg);
	kcurrhist++;
}
/*=====Bomb===print error message and quit==========================*/

void Bomb( char *m)
{
	if(Gron)closegraph();  /* worry about graphics mode  */

	printf(m);
	printf("\n");
	exit(0);
}

/*======SeekErr====report file error & exit==============================*/
void SeekErr(int iores)
{
	sprintf(debugb,"Seek error %d",iores);
	Bomb(debugb);
}

/*====DoBush====carry out Bushu display==============================*/
int DoBush(int bushind)
{
	int dbtemp,indbush;

	indbush = bushind;
	if (indbush == 0)
	{
		indbush = GetNo("Bushu No: ");
		if (indbush == 0) return(0);
	}
	putimage (4,maxy-20,bline,COPY_PUT);
	sprintf(Bmsg,"Searching on Radical %d ",indbush);
	outtextxy(10,maxy-14,Bmsg);
	bstroke = GetNo("Strokes (0 for all): ");
	AddKH(1,indbush*100+bstroke);
	if (BinSrch(indbush,"kinfobsh.idx",1) == 0) return(0);
	dbincr = 0;
	while (TRUE)
	{
		if (BinSrch(indbush,"kinfobsh.idx",1) == 0) return(0);
		dbtemp = BushStrk(1,indbush);
		if (dbincr == 0) return (dbtemp);
		bstroke = bstroke+dbincr;
		InitScr();
	}
}

/*=====GetYomi====collect search yomikata from keyboard. Convert to kana.===*/

void GetYomi(int yommode)
{
	int smodesave,is,ksp;
	char c,ops[20];

/* collect the search string   */
  smodesave = Smode;
  Smode = yommode;
  is = 0;
  ksp = 0;
  c = 0;
  ktarg[0] = 0;
  while (TRUE)   /* loop until Enter is pressed   */
  {
	if (ksp != 0)    /* tidy up after last romaji->kana conversion by
	                    removing and blanking converted ascii    */
	{
		strcpy(sch,ksch+ksp);
		strcpy(ksch,sch);
		strcpy(ops,sch);
		putimage(pcol,prowa,blank,COPY_PUT);
		putimage(245,prowa-8,kblank,COPY_PUT);
		outtextxy(pcol,prowa,ops);
		pcol = pcol - ksp*afntspce;
		is = is-ksp;
		ksp=0;
	}
	c = getchx();
	if (c == '\r') break;	/* end of input */

	if (c == 8)  /* backspace  */
	{
			if (is != 0)  /* kana mode - back over a romaji  */
			{
				sch[is-1] = '\0';
				ksch[is-1] = '\0';
				c = ' ';
				is--;
				pcol -= afntspce;
				putimage(pcol,prowa,blank,COPY_PUT);
				continue;
			}
			else
			{
				if (strlen(ktarg) != 0)  /* kana mode - back over a kana  */
				{
					ktarg[strlen(ktarg)-2] = '\0';
					pcolk-=kfntspce;
					putimage(pcolk,prow-4,kblank,COPY_PUT);
					continue;
				}
			}
	}
	if (c > 32)   /* ordinary character - store and display   */
	{
		sch[is] = c;
		sch[is+1] = '\0';
		ksch[is] = c;
		ksch[is+1] = '\0';
		ops[0] = c;
		ops[1] = '\0';
		outtextxy(pcol,prowa,ops);
		pcol += afntspce;
		is++;
  	}
	strlwr(sch);
	strlwr(ksch);
	if (ksp != is)
	{

/* the input string so far is now parsed for romaji -> kana conversions.
   function "kanaconv" is used for the various sub-strings    */

/* if there is an "nn", "nm" or "mm", convert to first to "q" to force it to be
   converted to a kana "n"   */
		if ((ksch[ksp] == 'n')&&(ksch[ksp+1] == 'n')) ksch[ksp] = 'q';
		if ((ksch[ksp] == 'm')&&(ksch[ksp+1] == 'm')) ksch[ksp] = 'q';
		if ((ksch[ksp] == 'n')&&(ksch[ksp+1] == 'm')) ksch[ksp] = 'q';
/* if there is "nx", where "x" is not a vowel or a "y", force the "n".  */
		if ((ksch[ksp] == 'n')&&(ksch[ksp+1] != 0))
		{
			c = ksch[ksp+1];
			if((c!='y')&&(c!='a')&&(c!='e')&&(c!='i')&&(c!='o')&&(c!='u')&&(c!='\''))
			{
				ksch[ksp] = 'q';
			}
		}
		if(kanaconv(ksp,1))  /*  match on a,e,i,o,u,q or -  ?  */
		{
			ksp++;
			continue;
		}
		if (ksch[ksp] == ksch[ksp+1])  /* double consonant - force small
						 "tsu" */
		{
			ksch[ksp] = '*';
			kanaconv(ksp,1);
			ksp++;
			continue;
		}
		if(kanaconv(ksp,2))  /* match on two letter syllable   */
		{
			ksp+=2;
			continue;
		}
		if(kanaconv(ksp,3))  /*match on 3 letter syllable    */
		{
			ksp+=3;
			continue;
		}
		if(kanaconv(ksp,4))  /*match on 4 letter syllable    */
		{
			ksp+=4;
			continue;
		}
	}		/* end of rom->kana */
  }			/* end of while loop */
  if (ksch[ksp] =='n')  /*flush out a trailing "n"*/
  {
	ksch[ksp] = 'q';
	kanaconv(ksp,1);
  }
  Smode = smodesave;

}
/*=====OpenKinf=====open kinfo.dat file if not already open=========*/
void OpenKinf()
{
	if(!Kinfopen)
	{
		strcpy(kinffile,kanjidir);
		strcat(kinffile,"kinfo.dat");
	  	fk=fopen(kinffile,"rb");
  		if (fk==NULL )
  		{
			sprintf(Bmsg,"\nCannot open file: %s\n",kinffile);
			Bomb(Bmsg);
  		}
		Kinfopen = TRUE;
	}
}
/*=======DoYomi====Carry out yomikata kanji display ====================*/
int DoYomi(int yomif)
{
	char ops1[6],ops2[6];
	typedef struct {
		unsigned char ryomi[6];
		unsigned long int rindex;
		unsigned short int rcount;
	} YOMTAB;

	YOMTAB  yrec;

	int i,iyk,rjis[1];
	char fyyfil[50],fyjfil[50];
	FILE *fyy,*fyj;

	strcpy(fyyfil,kanjidir);
	strcat(fyyfil,"kinfyomi.dat");
	strcpy(fyjfil,kanjidir);
	strcat(fyjfil,"kinfyomi.jis");
	fyy = fopen(fyyfil,"rb");
	if(fyy == NULL) Bomb("Unable to open yomikata file");
	fyj = fopen(fyjfil,"rb");
	if(fyj == NULL) Bomb("Unable to open yomikata file");
	if(!yomif)
	{
		if (Vmode) Vmsg(7);
		putimage (4,maxy-20,bline,COPY_PUT);
		prowa = maxy-14;
		outtextxy(10,prowa,"Yomikata Search Key:");
		GetYomi(1);
		AddKH (7,0);
	}
	for(i=0;i<6;i++)sch[i] = 0;
	for(i=0;i<6;i++)
	{
		if(ktarg[i*2] == 0)break;
		sch[i] = ktarg[i*2+1] & 0x7f;
	}

	idxlen = filelength(fileno(fyy));
	lo = 0;
	hi = idxlen/sizeof(YOMTAB)-1;
	while(TRUE)
	{
		mid = (lo+hi)/2;

		seekoff = mid;
		seekoff *= sizeof(YOMTAB);
		if((iores = fseek(fyy,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(&yrec,sizeof(YOMTAB),1,fyy);
		test = strncmp(sch,yrec.ryomi,6);
		if(test < 0)
		{
			hi = mid-1;
		}
		else
		{
			lo = mid+1;
		}
		if ((test == 0) || (lo > hi)) break;
	}
	if (test != 0)
	{
		kouttextxy(40,maxr/2,"Kanji index not found!  Press any key to continue.....");
		c = waitch();
		fclose(fyy);
		fclose(fyj);
		return(0);
	}
	seekoff = yrec.rindex;
	seekoff *= sizeof(int);
	if((iores = fseek(fyj,seekoff,SEEK_SET)) != 0)SeekErr(iores);
	iyk = 0;
	while(TRUE)
	{
		PgOffs = 0;
		PgInit = TRUE;
		PgEnd = FALSE;
		PgEOF = FALSE;
		sprintf(KIHead,"Kanji Selection By Yomikata ");

		for ( ;iyk < yrec.rcount; iyk++)
		{
			iores = fread(&rjis,sizeof(int),1,fyj);
			c1 = rjis[0] >> 8;
			c2 = rjis[0] & 0xff;
			KnjFlag = TRUE;
			OpenKinf();
			seekoff = ((c1 & 0x7f)-0x30)*94 + (c2&0x7f)-0x21;
			seekoff *= sizeof(KINFORECORD);
			if((iores = fseek(fk,seekoff,SEEK_SET)) != 0)SeekErr(iores);
			iores = fread(&krec,sizeof(KINFORECORD),1,fk);
			if (krec.padding != KVER) Bomb("Incorrect kinfo.dat version!");
			nels = krec.indexn;
			halp = krec.indexh;
			strk = krec.strokes;
			sprintf(ops2,"%d",strk);
			sprintf(ops1,"%d",nels);
			if(!NHmode)sprintf(ops1,"%d",halp);
			PgDisp(ops1,ops2);
			PageIndex[PgOffs] = rjis[0] & 0x7f7f;
			PgOffs++;
			if (PgEnd) break;
		}
		if (iyk == yrec.rcount) PgEOF = TRUE;
		NewCurs();
		cresp = CursInp();
		if (cresp > 0)
		{
			fclose(fyy);
			fclose(fyj);
			return (cresp);
		}
		if (cresp < 0)
		{
			fclose(fyy);
			fclose(fyj);
			return(0);
		}
		if (PgEOF)
		{
			seekoff = yrec.rindex;
			seekoff *= sizeof(int);
			if((iores = fseek(fyj,seekoff,SEEK_SET)) != 0)SeekErr(iores);
			PgEOF = FALSE;
			iyk = 0;
		}
	}
}

/*=========DoKIndex===carry out Nelson, etc search & display=============*/
int DoKIndex()
{
	int i,j,indnel,dbtemp;
	int p1,p2,kn,JIScode;

	putimage (4,maxy-20,bline,COPY_PUT);
	CloseKind();
	if(KHTIndex != 0)
	{
		i = KHTIndex;
		j = KHVIndex;
		KHFlag = TRUE;
		switch(i)
		{
			case 1 :
				bstroke = KHVIndex % 100;
				j = KHVIndex / 100;
				if (BinSrch(j,"kinfobsh.idx",1) == 0) return(0);
				dbincr = 0;
				while (TRUE)
				{
					if (BinSrch(j,"kinfobsh.idx",1) == 0) return(0);
					dbtemp = BushStrk(1,j);
					if (dbincr == 0) break;
					bstroke = bstroke+dbincr;
					InitScr();
				}
				j = dbtemp;
				if (j == 0) return(TRUE );
				if (DoNels(j)== 0)return(TRUE);	
				return(FALSE);
			case 2 :
				if (BinSrch(j,"kinfostr.idx",0) == 0) return(0);
				j = BushStrk(0,j);
				if (j == 0) return(TRUE );
				if (DoNels(j)== 0)return(TRUE);	
				return(FALSE);
			case 3 :
				indnel = BinSrch(j,"kinfonel.idx",2);
				if (indnel == 0) return(0);
				CloseKind();
				j = rec.index;
				if (DoNels(j)== 0)return(TRUE);	
				return(FALSE);
			case 4 :
				indnel = BinSrch(j,"kinfohal.idx",2);
				if (indnel == 0) return(0);
				CloseKind();
				j = rec.index;
				if (DoNels(j)== 0)return(TRUE);	
				return(FALSE);
			case 5 :
				JIScode = KHVIndex;
				if ((JIScode < 0x3021) || (JIScode > LastJIS)) return(0);
				if (DoNels(JIScode)== 0)return(TRUE);	
				return(FALSE);
			case 6 :
				kn = KHVIndex;
				JIScode = (((kn/100)+0x20) << 8)+((kn % 100)+0x20);
				if ((JIScode < 0x3021) || (JIScode > LastJIS)) return(0);
				if (DoNels(JIScode)== 0)return(TRUE);	
				return(FALSE);
			case 7 :
				if ((kind = DoYomi(TRUE)) == 0) return(TRUE);
				if (DoNels(kind) == 0) return (TRUE);
				return(FALSE);
			case 8 :
				if (DoNels(j) == 0) return (TRUE);
				return(FALSE);
			case 9 :
				if (BinSrch(j,"kinfofc.idx",2) == 0) return(0);
				j = BushStrk(2,j);
				if (j == 0) return(TRUE );
				if (DoNels(j) == 0) return (TRUE);
				return (FALSE);
			case 10 :
				sprintf(SKsav,"%d-%d-%d ",j/900,(j % 900)/30,(j % 30));
				if (BinSrch(j,"kinfoskp.idx",2) == 0) return(0);
				dbincr = 0;
				while (TRUE)
				{
					if (BinSrch(j,"kinfoskp.idx",2) == 0) return(0);
					dbtemp = BushStrk(3,j);
					if (dbincr == 0) break;
					j = j+dbincr;
					sprintf(SKsav,"%d-%d-%d ",j/900,(j % 900)/30,(j % 30));
					InitScr();
				}
				j = dbtemp;
				if (j == 0) return(TRUE );
				if (DoNels(j)== 0)return(TRUE);	
				return(FALSE);
			case 11 :
				JIScode = KHVIndex;
				p1 = (JIScode >> 8) & 0xff;
				p2 = JIScode & 0xff;
				eight2seven(&p1,&p2);
				JIScode = (p1 << 8) + p2;
				if ((JIScode < 0x3021) || (JIScode > LastJIS)) return(0);
				if (DoNels(JIScode)== 0)return(TRUE);	
				return(FALSE);
			case 12 :
				K212 = TRUE;
				JIScode = KHVIndex;
				if ((JIScode < 0x3021) || (JIScode > LastJIS)) return(0);
				if (DoNels(JIScode)== 0)return(TRUE);	
				return(FALSE);
		}
	}
	if(KDirect) 
	{
		if(DoNels(KDirect) == 0)
		{
			return(TRUE);
		}
		else
		{
			return(FALSE);
		}
	}
	prowa = maxy-14;
	outtextxy(10,prowa,"Entering Kanji Indexed Search. ");
	if (Kindex == 4)
	{
		if (Vmode) Vmsg(13);
		if ((kind = DoFC()) == 0) return (TRUE);
		if (DoNels(kind) == 0) return (TRUE);
		return (FALSE);
	}
	if (Kindex == 5)
	{
		if (Vmode) Vmsg(14);
		if ((kind = DoSKIP()) == 0) return (TRUE);
		if (DoNels(kind) == 0) return (TRUE);
		return (FALSE);
	}
	if (Kindex == 2)
	{
		if (Vmode) Vmsg(18);
		if ((kind = DoBush(0)) == 0) return (TRUE);
		if (DoNels(kind) == 0) return (TRUE);
		return (FALSE);
	}
	if (Kindex == 1)
	{
		if (Vmode) Vmsg(19);
		if ((kind = DoStrk()) == 0) return (TRUE);
		if (DoNels(kind) == 0) return (TRUE);
		return (FALSE);
	}
	if (Kindex == 0)
	{
		if (DoNels(0) == 0) return (TRUE);
		return (FALSE);
	}
	if (Kindex == 3)
	{
		Kmsg = 24;
		if ((kind = DoRads()) == 0) return (TRUE);
		if (Vmode) Vmsg(25);
		if ((kind = DoBush(kind)) == 0) return (TRUE);
		if (DoNels(kind) == 0) return (TRUE);
		return (FALSE);
	}
	if (Kindex == -1)
	{
		if(Kutenf)
		{
			if (Vmode) Vmsg(9);
			if(DoKuten() == 0) return(TRUE);
			return(FALSE);
		}
		if(SJis)
		{
			if (Vmode) Vmsg(10);
			if(DoSJIS() == 0) return(TRUE);
			return(FALSE);
		}
		if (Vmode) Vmsg(8);
		if (DoJIS() == 0) return(TRUE);
		return(FALSE);
	}
	if (Kindex == -2)
	{
		if ((kind = DoYomi(FALSE)) == 0) return(TRUE);
		if (DoNels(kind) == 0) return (TRUE);
		return(FALSE);
	}
}

/*=======DoFC====Carry out Four Corner  display=======================*/
int DoFC()
{
	int indstrk;

	indstrk = GetNo("Four Corner Code: ");
	if (indstrk == 0) return(0);
	AddKH(9,indstrk);
	if (BinSrch(indstrk,"kinfofc.idx",2) == 0) return(0);
	return(BushStrk(2,indstrk));
}

/*=======DoSKIP====Carry out SKIP code display=======================*/
int DoSKIP()
{
	int dbtemp,indstrk,nos[3],i,j,n;
	char gnstr[20];

	n=0;
	nos[0] = nos[1] = nos[2] = 0;
	strcpy(gnstr,"SKIP code: ");
	outtextxy(330,prowa,gnstr);
	pcol = 330+9*strlen(gnstr);
	GetKBStr(sch);
	strcpy(SKsav,sch);
	for (i = 0; i < strlen(sch);i++)
	{
		if ((sch[i] >= '0') && (sch[i] <= '9'))
		{
			nos[n] = nos[n]*10+sch[i]-'0';
			continue;
		}
		if (sch[i] == '-')
		{
			n++;
			continue;
		}
	}
	indstrk = nos[0]*900+nos[1]*30+nos[2];
	if (indstrk == 0) return(0);
	AddKH(10,indstrk);
	dbincr = 0;
	while (TRUE)
	{
		if (BinSrch(indstrk,"kinfoskp.idx",2) == 0) return(0);
		dbtemp = BushStrk(3,indstrk);
		if (dbincr == 0) return (dbtemp);
		indstrk = indstrk+dbincr;
		sprintf(SKsav,"%d-%d-%d",indstrk/900,(indstrk % 900)/30,(indstrk % 30));
		InitScr();
	}
/*	if (BinSrch(indstrk,"kinfoskp.idx",2) == 0) return(0);
	return(BushStrk(3,indstrk));	*/
}
/*=======DoStrk====Carry out stroke count display=======================*/
int DoStrk()
{
	int indstrk;

	indstrk = GetNo("Strokes: ");
	if (indstrk == 0) return(0);
	AddKH(2,indstrk);
	if (BinSrch(indstrk,"kinfostr.idx",0) == 0) return(0);
	return(BushStrk(0,indstrk));
}

/*=========DoRads====Carry out Radical Display==========================*/
int DoRads()
{
	char tops[20];
	int tstroke;
	int anydisp;

	CloseKind();
	anydisp = FALSE;
	strcpy(kinfidx,kanjidir);
	strcat(kinfidx,"radicals.tm");
  	fki=fopen(kinfidx,"rb");
	Kindopen=TRUE;
  	if (fki==NULL )
  	{
		sprintf(Bmsg,"Cannot open file: %s ",kinfidx);
		outtextxy(10,30,Bmsg);
		outtextxy(10,50,"Press any key to return to the Dictionary function");
		c = waitch();
		return(0);
	}
	while(TRUE)
	{
		PgOffs = 0;
		PgInit = TRUE;
		PgEnd = FALSE;
		PgEOF = FALSE;
		strcpy(KIHead,"Radical (Bushu) Selection");
		ktarg[0] = 0;

		while (TRUE)
		{
			fgets(ops,19,fki);
			if (feof(fki))
			{
				PgEOF = TRUE;
				break;
			}
			if (rstroke > 0)
			{
				tstroke = 0;
				if (ops[0] < 127)
				{
					Bmsg[0] = ops[0]; Bmsg[1] = ops[1]; Bmsg[2] = 0;
					tstroke = atoi(Bmsg);
				}
				else
				{
					if (ops[0] == 0xa3) tstroke = ops[1] & 0x0f;
				}
				if ((tstroke == 0) || (tstroke < rstroke)) continue;
				rstroke = 0;
			}
			ops[strlen(ops)-1] = '\0';
			if (ops[strlen(ops)-1] < ' ') ops[strlen(ops)-1] = '\0';
			KnjFlag = TRUE;
			if (ops[0] < 127) KnjFlag = FALSE;
			c1 = ops[0] & 0x7f;
			c2 = ops[1] & 0x7f;
			strcpy(tops,ops+3);
			PgDisp(tops," ");
			anydisp = TRUE;
			for (i=0; i < strlen(tops); i++) if ((tops[i] < '0')||(tops[i] > '9')) tops[i] = ' ';
			PageIndex[PgOffs] = atoi(tops);
			PgOffs++;
			if (PgEnd) break;
		}
		if (!anydisp)
		{
			kouttextxy(40,maxr/2,"Radicals not found!  Press any key to continue.....");
			c = waitch();
			CloseKind();
			return(0);
		}
		NewCurs();
		Kmsg = 5;
		cresp = CursInp();
		if (cresp > 0)
		{
			CloseKind();
			return (cresp);
		}
		if (cresp < 0)
		{
			CloseKind();
			return(0);
		}
		if (PgEOF)
		{
			rewind(fki);
		}
	}
}

/*====PgDisp==display kanji & numbers for DoRads, etc ====================*/
void PgDisp(char *kstr1, char *kstr2)
{
	int i;
	char ptempstr[5];

	if (PgInit)
	{
		PgInit = FALSE;
		kouttextxy(16,20,KIHead);
		pcol = 16+afntspce*strlen(KIHead);
		prow = 20;
		if(strlen(ktarg) > 0) 
		{
			for (i = 0;i < strlen(ktarg);i+=2) OutKanji(jis2index(ktarg[i]&0x7f,ktarg[i+1]&0x7f));
		}
		pcol = 16;
		prow = 36;
	}
	pcolx = pcol;
	if (KnjFlag)
	{
		OutKanji(jis2index(c1&0x7f,c2&0x7f));
	}
	else
	{
		ops[0] = c1; ops[1] = '\0';
		outtextxy(pcolx+1,prow-3,ops);
		ops[0] = c2;
		outtextxy(pcolx+8,prow+6,ops);
	}
	if (!KnjFlag || ((c1 == 0x23)&&KnjFlag))
	{

		rectangle(pcolx-2,prow-7,pcolx+18,prow+15);
	}
	else
	{
		if (strlen(kstr1) > 2)
		{
			outtextxy(pcolx-6,prow+14,kstr1);
		}
		else
		{
			outtextxy(pcolx+2,prow+14,kstr1);
		}
	}
	if (JISDisp)
	{
		sprintf(ptempstr,"%X%X",c1&0x7f,c2&0x7f);
		outtextxy(pcolx,prow+24,ptempstr);
	}
	else
	{
		outtextxy(pcolx,prow+24,kstr2);
	}
	pcol = pcolx;
	pcol+=45;
	if (pcol+25 < maxx-4) return;
	pcol = 16;
	prow+=38;
	if (prow+38 < maxr-14) return;
	PgEnd = TRUE;
	return;
}

/*===ToggleCurs===toggle the cursor on/off in its current location=======*/
void ToggleCurs()
{
	putimage(curcol,currow,curstore,XOR_PUT);
}

/*=====DoGetD===Select search key from display or log entry============*/
int DoGetD()
{
	int bsres,i,Offer,KFlag,curk,nokanj;
	long extrec[2],schiy,extlen,extjdxlen;
	char cc,Ssch[20],Dsch[20],k1,LogLine[200];
	long ejdxtest[2];
	unsigned int khi,klo;

	curcol = 5;
	curk = 0;
	if (kno < 1) return(FALSE);
	putimage (4,maxy-20,bline,COPY_PUT);
	outtextxy(10,maxy-14,"Position Cursor on selected row & press Enter (Select) L (Log) E (Extn)");
	putimage(curcol,lineyy[0],kcurstore,XOR_PUT);
	while (TRUE)
	{
		c = getchx();
		if(c == 0x1b) return(FALSE);
		if(c == 0)
		{
			c = getchx();
			if ((c == 0x48) && (curk > 0))
			{
				putimage(curcol,lineyy[curk],kcurstore,XOR_PUT);
				curk--;
				putimage(curcol,lineyy[curk],kcurstore,XOR_PUT);
			}
			if ((c == 0x50) && (curk < kno-1))
			{
				putimage(curcol,lineyy[curk],kcurstore,XOR_PUT);
				curk++;
				putimage(curcol,lineyy[curk],kcurstore,XOR_PUT);
			}
		}
  
		if ((c == 'e') || (c == 'E'))
		{
			InitScr();
			if(!Extopen)
			{
				fe = fopen(EXTname,"rb");
				if (fe == NULL)
				{
					sprintf(Bmsg,"Cannot open %s",EXTname);
					Bomb(Bmsg);
				}
				fex = fopen(EXTJDXname,"rb");
				if (fex == NULL)
				{
					sprintf(Bmsg,"Cannot open %s",EXTJDXname);
					Bomb(Bmsg);
				}
				Extopen = TRUE;
  				extlen = filelength(fileno(fe));
				extlen++;
				fread(ejdxtest,sizeof(long),1,fex);
				if (ejdxtest[0] != (extlen+jiver))
				{
					sprintf(Bmsg,"EDICT Extension file & Index Mismatch! %ld %ld",ejdxtest[0],extlen+jiver);
					Bomb(Bmsg);
				}
			}
			schiy = linepos[curk];
  			extjdxlen = filelength(fileno(fex));
			i = 0;
			while(TRUE)
			{
				Dsch[i] = dbchar(schiy++);
				if (Dsch[i] == ' ')
				{
					Dsch[i] = 0;
					break;
				}
				i++;
			}
			lo = 0;
			hi = (extjdxlen/(2*sizeof(long)))-1;
			while(TRUE)
			{
				mid = (lo+hi)/2;
				seekoff = mid;
				seekoff *= (2*sizeof(long));
				seekoff+=sizeof(long);
				if((iores = fseek(fex,seekoff,SEEK_SET)) != 0)SeekErr(iores);
				iores = fread(&extrec,sizeof(long),2,fex);
				seekoff = extrec[0];
				if((iores = fseek(fe,seekoff,SEEK_SET)) != 0)SeekErr(iores);
				iores = fread(&Ssch,sizeof(char),19,fe);
				Ssch[19] = 0;
				for (i = 0;i<19;i++) 
				{
					if (Ssch[i] < 128) 
					{
						Ssch[i] = 0;
						break;
					}
				}
				bsres = strcmp(Dsch,Ssch);
				if(bsres < 0)
				{
					hi = mid-1;
				}
				else
				{
					lo = mid+1;
				}
				if ((bsres  == 0) || (lo > hi)) break;
			}
			if (bsres == 0)
			{
				seekoff = extrec[1];
				if((iores = fseek(fe,seekoff,SEEK_SET)) != 0)SeekErr(iores);
				prow = 20;
				kouttextxy(10,prow,"<");
				pcol=10+afntspce;
				khi = 0;
				while(!feof(fe))
				{
					fgets(LogLine,199,fe);
					if (feof(fe)) break;
					if ((LogLine[0] == '<') && (LogLine[1] > 128)) break;
					if (LogLine[strlen(LogLine)-1] < 0x20) LogLine[strlen(LogLine)-1] = 0;
					for (i = 0; i < strlen(LogLine); i++)
					{
						cc = LogLine[i];
						if (cc < 128) 
						{
							ops[0] = cc;
							ops[1] = 0;
							kouttextxy(pcol,prow,ops);
							pcol=pcol+afntspce;
							if (pcol > maxx-6) break;
						}
						if (cc >= 128)
						{
							if (cc == 0x8f)
							{
								JIS212 = TRUE;
								continue;
							}
							if (khi == 0)
							{
								khi = cc & 0x7f;
							}
							else
							{
								klo = cc & 0x7f;
								OutKanji(jis2index(khi,klo));
								if (pcol > maxx-6) break;
								khi = 0;
								klo = 0;
								JIS212 = FALSE;
							}
						}
					}
					prow = prow+17;
					pcol = 10;
					if (prow > maxr-32)  
					{
  						if (Vmode) Vmsg(27);
						putimage (4,maxy-20,bline,COPY_PUT);
						outtextxy(10,maxy-14,"Press Enter to continue Display, Esc to search again. ");
						c = waitch();
						InitScr();
						prow = 20;
						pcol = 10;
						if(c == 0x1b) return(FALSE);
					}
				}
  				if (Vmode) 
				{
					Vmsg(28);
				}
				putimage (4,maxy-20,bline,COPY_PUT);
				outtextxy(10,maxy-14,"Press Enter to continue.");
				c = waitch();
				InitScr();
				return(FALSE);
			}
			if (bsres != 0)
			{
				putimage (4,maxy-20,bline,COPY_PUT);
				outtextxy(10,maxy-14,"Not found in Extension file. Press Enter to continue. ");
				c = waitch();
				InitScr();
				return(FALSE);
			}
			ReDoScr = TRUE;
		}
		if ((c == 'L') || (c == 'l'))
		{
			if(!Logopen)
			{
				fl = fopen(LogFile,"at");
				if (fl == NULL)
				{
					sprintf(Bmsg,"Cannot open %s",LogFile);
					Bomb(Bmsg);
				}
				Logopen = TRUE;
			}
			schiy = linepos[curk];
			while(TRUE)
			{
				k1 = dbchar(schiy++);
				if (k1 == 10) break;
				fputc(k1,fl);
			}
			fprintf(fl,"\n");
			outtextxy(maxx-12,lineyy[curk],"L");
			putimage (4,maxy-20,bline,COPY_PUT);
			outtextxy(10,maxy-14,"Annotation to logged line: ");
			if (Vmode) Vmsg(20);
			pcol = 250;
			GetKBStr(LogLine);
			if(strlen(LogLine) > 0) fprintf(fl,"%s\n",LogLine);
			putimage (4,maxy-20,bline,COPY_PUT);
			outtextxy(10,maxy-14,"Position Cursor on selected row & press Enter to Select or L to log");
			c = 'l';
			if (Vmode) Vmsg (6);
		}
		if (c == '\r')
		{
			putimage (4,maxy-20,bline,COPY_PUT);
			schiy = linepos[curk];
			Offer = FALSE;
			KFlag = FALSE;
			Dsch[0] = 0;
			while(TRUE)
			{
				k1 = dbchar(schiy);
				if (k1 == 0x8f)
				{
					Dsch[0] = dbchar(schiy);
					Dsch[1] = dbchar(schiy+1);
					Dsch[2] = dbchar(schiy+2);
					Dsch[3] = 0;
					schiy+=2;
					Offer = TRUE;
					KFlag = TRUE;
					K212 = TRUE;
				}
				if (k1 >= 0xb0)
				{
					Dsch[0] = dbchar(schiy);
					Dsch[1] = dbchar(schiy+1);
					Dsch[2] = 0;
					schiy+=1;
					Offer = TRUE;
					KFlag = TRUE;
					K212 = FALSE;
				}
				if(((k1 >= 0xa1)&&(k1 <= 0xa5)) && KFlag)
				{
					schiy+=2;
					K212 = FALSE;
					continue;
				}
				if(((k1 >= 0xa1)&&(k1 <= 0xa5)) && !KFlag)
				{
					ops[0] = dbchar(schiy);
					ops[1] = dbchar(schiy+1);
					ops[2] = 0;
					strcat(Dsch,ops);
					schiy+=2;
					K212 = FALSE;
					continue;
				}
				if(((k1 >= 'a') && (k1 <= 'z')) || ((k1 >= 'A') && (k1 <= 'Z')))
				{
					ops[0] = k1 | 0x20;
					ops[1] = 0;
					strcat(Dsch,ops);
					schiy++;
					K212 = FALSE;
					continue;
				}
				if (strlen(Dsch) >= 2)
				{
					Offer = TRUE;
				}
				if (Offer)
				{
					prow = maxy-17;
					pcol = 350;
					putimage (4,maxy-20,bline,COPY_PUT);
					putimage (4,maxy-22,bline,COPY_PUT);
					if (Vmode) Vmsg(21);
					outtextxy(10,prow,"Enter to select, Space for next: ");
					if (Dsch[0] <127)
					{
						kouttextxy(pcol,prow,Dsch);
					}
					else
					{
						for (i=0; i < strlen(Dsch); i+=2)
						{
							if (Dsch[i] == 0x8f)
							{
								JIS212 = TRUE;
								i++;
							}
							OutKanji(jis2index(Dsch[i] & 0x7f,Dsch[i+1] & 0x7f));
							JIS212 = FALSE;
						}
					}
					c = getchx();
					if (c == 0x1b) return(FALSE);
					if (c == '\r')
					{
						if (Dsch[0] == 0x8f)
						{
							KDirect = ((Dsch[1] & 0x7f) << 8) + (Dsch[2] & 0x7f);
							strcpy(ktarg,Dsch+1);
							AddKH(12,KDirect);
							return(TRUE);
						}
						if (Dsch[0] >= 0xb0)
						{
							KDirect = ((Dsch[0] & 0x7f) << 8) + (Dsch[1] & 0x7f);
							AddKH(8,KDirect);
							return(TRUE);
						}
						if (Dsch[0] >= 0xa0)
						{
							Dsch[12] = 0;
							strcpy(sch,Dsch);
							strcpy(ktarg,Dsch);
							AddHist(sch);
							return(FALSE);
						}
						Dsch[6] = 0;
						strcpy(sch,Dsch);
						AddHist(sch);
						return(FALSE);
					}
				}
				Offer = FALSE;
				Dsch[0] = 0;
				if (k1 <127) KFlag = FALSE;
				if (k1 <12) return(FALSE);
				schiy++;
			}
		}
	}
}
/*====NewCurs===create a new cursor at the top of the screen==============*/
void NewCurs()
{
	curcol = 8;
	currow = 41;
	curpos = 0;
	ToggleCurs();
	putimage (4,maxy-20,bline,COPY_PUT);
	prowa = maxy-14;
	outtextxy(10,prowa,"Position Cursor and Enter to select, (M)ore Display or e(X)it function:");
	if (Vmode) Vmsg(Kmsg);
}

/*===CursInp===manage cursor movement, and return location info=========*/
int CursInp()
{
	int kpl;

	kpl = (maxx-4)/45;

	while(TRUE)
	{
		dbincr = 0;
		c  = getchx();
		if ((c  == 'm')||(c  == 'M'))
		{
			InitScr();
			return(0);
		}
		if ((c  == 'x')||(c  == 'X')||(c == 0x1b)) return(-1);
		if (c == '+')
		{
			dbincr = 1;
			return(-1);
		}
		if (c == '-')
		{
			dbincr = -1;
			return(-1);
		}

		if (c == '\0')
		{
			c = getchx();
			if (c == 0x51)
			{
				InitScr();
				return(0);
			}
			if ((curpos == PgOffs-1) && ((c == 0x50) || (c == 0x4d)))
			{
				InitScr();
				return(0);
			}
			if (( c == 0x4d)&&( curpos < PgOffs-1)) curpos++;
			if (( c == 0x4b)&&( curpos > 0)) curpos--;
			if ( c == 0x48) curpos-=kpl;
			if ( c == 0x50) curpos+=kpl;
			if ( c == 0x47) curpos=0;
			if ( c == 0x4f) curpos=((PgOffs-1)/kpl)*kpl;
			if ( curpos < 0 ) curpos = 0;
			if (curpos > PgOffs-1) curpos = PgOffs-1;
			ToggleCurs();
			curcol = (curpos % kpl) * 45 +8;
			currow = (curpos / kpl) *38+41;
			ToggleCurs();
			continue;
		}
		if ( c == '\r')
		{
			if(PageIndex[curpos] == 0) return(-1);
			InitScr();
			return (PageIndex[curpos]);
		}
	}
}
/*===GetKBStr====collect a string from the keyboard====================*/
/*   echo at pcol,prow     */
void GetKBStr(char *str)
{
/* collect the search string   */
  	is = 0;
	str[0] = 0;
  	c = 0;
  	while (TRUE)   /* loop until Enter is pressed   */
  	{
		c = getchx();
		if (c == '\r') break;	/* end of input */

/* ESC = premature end */
		if (c == 0x1b)
		{
			str[0] = 0;
			return;
		}
		if (c == 8)		/* backspace  */
		{
			if ( is > 0 )
			{
				str[is-1] = '\0';
				c = ' ';
				is--;
				pcol -= afntspce;
				putimage(pcol,prowa,blank,COPY_PUT);
				continue;
			}
		}
		if (c >= 32)   /* ordinary character - store and display   */
		{
			str[is] = c;
			str[is+1] = '\0';
			ops[0] = c;
			ops[1] = '\0';
			outtextxy(pcol,prowa,ops);
			pcol += afntspce;
			is++;
  		}
	}
}

/*====GetNo======collect a number from the keyboard====================*/
int GetNo(char *gnstr)
{
	outtextxy(330,prowa,gnstr);
	pcol = 330+9*strlen(gnstr);

	GetKBStr(sch);
	return(atoi(sch));
}

/*====BinSrch===carry out a binary search of an index file==============*/
int BinSrch(int sindx, char *bsf, int ks)
{
	strcpy(kinfidx,kanjidir);
	strcat(kinfidx,bsf);

	CloseKind();
  	fki=fopen(kinfidx,"rb");
	Kindopen = TRUE;
  	if (fki==NULL )
  	{
		sprintf(Bmsg,"\nCannot open file: %s\n",kinfidx);
		Bomb(Bmsg);
  	}
	idxlen = filelength(fileno(fki));
	lo = 0;
	hi = idxlen/sizeof(IDXRECORD)-1;
	LastIndex = hi;
	while(TRUE)
	{
		mid = (lo+hi)/2;

		seekoff = mid;
		seekoff *= sizeof(IDXRECORD);
		if((iores = fseek(fki,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(&rec,sizeof(IDXRECORD),1,fki);
		test = rec.nelx;
		if (ks == 1) test = (rec.code >> 8) & 0xff;
		if (ks == 0) test = rec.code & 0xff;
		if(sindx  < test)
		{
			hi = mid-1;
		}
		else
		{
			lo = mid+1;
		}
		if ((sindx  == test) || (lo > hi)) break;
	}
	if ( sindx  != test)
	{
		kouttextxy(40,maxr/2,"Kanji index not found!  Press any key to continue.....");
		c = waitch();
		CloseKind();
		return(0);
	}
	else
	{
		return(1);
	}
}

void CloseKind()
{
	if (Kindopen)
	{
		fclose(fki);
		Kindopen = FALSE;
	}
}

int GetHex(char *prompt)
{
	int JIScode;
	
	outtextxy(330,prowa,prompt);
	pcol = 420;

/* collect the search string   */
  	is = 0;
  	c = 0;
  	while (TRUE)   /* loop until Enter is pressed   */
  	{
		c = getchx();
		if (c == '\r') break;	/* end of input */

/* ESC = premature end */
		if (c == 0x1b)
		{
			return (0);
		}
		if (c == 8)		/* backspace  */
		{
			if ( is > 0 )
			{
				sch[is-1] = '\0';
				c = ' ';
				is--;
				pcol -= afntspce;
				putimage(pcol,prowa,blank,COPY_PUT);
				continue;
			}
		}
		if ((c >= 0x30 && c <= 0x39 ) || (c >= 0x41 && c <= 0x46) ||
		(c >= 0x61 && c <= 0x66))  /* ordinary character - store and display   */
		{
			sch[is] = c;
			sch[is+1] = '\0';
			ops[0] = c;
			ops[1] = '\0';
			outtextxy(pcol,prowa,ops);
			pcol += afntspce;
			is++;
  		}
	}
	JIScode = 0;
	for(is = 0; sch[is] != 0; is++)
	{
		if ((is == 0) && (sch[is] == '1'))
		{
			K212 = TRUE;
			continue;
		}
		c = sch[is] | 0x20;
		if (c < 0x40) c = c - '0';
		else
		c = c - 'a' + 10;
		JIScode = (JIScode << 4) + c;
	}
	return(JIScode);
}

/*===eight2seven - convert ShiftJIS to JIS ===========================*/

void eight2seven(int *p1,int *p2)   /* Ken Lunde's routine  */
{
  int temp;

  temp = *p2;
  if ((*p2 >= 64) && (*p2 <= 158))
    *p2 -= 31;
  else if ((*p2 >= 159) && (*p2 <= 252))
    *p2 -= 126;
  if ((temp > 127) && (temp <= 158))
    (*p2)--;
  if ((*p1 >= 129) && (*p1 <= 159)) {
    if ((temp >= 64) && (temp <= 158))
      *p1 = ((*p1 - 113) * 2) + 1;
    else if ((temp >= 159) && (temp <= 252))
      *p1 = (*p1 - 112) * 2;
  }
  else if ((*p1 >= 224) && (*p1 <= 239)) {
    if ((temp >= 64) && (temp <= 158))
      *p1 = ((*p1 - 177) * 2) + 1;
    else if ((temp >= 159) && (temp <= 252))
      *p1 = (*p1 - 176) * 2;
  }
}
/*====DoJIS====find & display according to JIS Code=====================*/
int DoJIS()
{
	int JIScode;
	
	JIScode = GetHex("JIS Code");
	if ((JIScode < 0x3021) || (JIScode > LastJIS)) return(0);
	AddKH(5,JIScode);
	return(DoNels(JIScode));
}

int DoSJIS()
{
	int JIScode,p1,p2;
	
	JIScode = GetHex("SJIS Code");
	AddKH(11,JIScode);
	p1 = (JIScode >> 8) & 0xff;
	p2 = JIScode & 0xff;
	eight2seven(&p1,&p2);
	JIScode = (p1 << 8) + p2;
	if ((JIScode < 0x3021) || (JIScode > LastJIS)) return(0);
	return(DoNels(JIScode));	
}	

int DoKuten()
{
	int kn,JIScode;
	
	kn = GetNo("Kuten Code: ");
	AddKH(6,kn);
	JIScode = (((kn/100)+0x20) << 8)+((kn % 100)+0x20);
	if ((JIScode < 0x3021) || (JIScode > LastJIS)) return(0);
	return(DoNels(JIScode));	
}	

/*=====BigKanji=====*/

void BigKanji(unsigned char c1, unsigned char c2)
{
	
  char font[72];
  long seekoff;
  int x,y,ift,ib,fr,fc,byte;
  int cx1,cx2;
	cx1 = c1 & 0x7f;
	cx2 = c2 & 0x7f;
	x=14+23;
	y=14;

	seekoff = COLUMN*(cx1-0x21) + cx2-0x21;
	seekoff*=72;
	if((iores = fseek(fpf,seekoff,SEEK_SET)) != 0)SeekErr(iores);
	fread(font,72,1,fpf);
	ift = 0;
	for ( fr = 0; fr < 24; fr++)
	{
		for (fc = 2; fc >=0; fc--)
		{
			byte = font[ift+fc];
			for(ib = 0;ib < 8;ib++)
			{
				if(byte & 1) putpixel(x,y,Kcolour);
				byte >>= 1;
				x--;
			}
		}
		ift=ift+3;
		x=14+23;
		y++;
	}
}
	
/*========== Dispk212 - carry out display of JIS 212 info  ================*/

int Dispk212(char c2, char c3)
{
	int i,yi,khi,klo;
	long yp;
	char *lstr,cc,yline[256],ylinebest[256];

	prow = 30;
	pcol=10;
	kouttextxy(pcol+40,prow," K A N J I  I N F O R M A T I O N  (JIS X 0212)");
	prow+=30;
	JIS212 = TRUE;
	OutKanji(jis2index(c2 & 0x7f,c3 & 0x7f));
	pcol+=16;
	JIS212 = FALSE;
	if (!k212open)
	{
		strcpy(k212name,kanjidir);
		strcat(k212name,"kanjd212.ind");
		fpw2 = fopen(k212name,"rb");
		if ( fpw2 == NULL)
		{
			sprintf(Bmsg," Cannot open: %s \n",k212name);
			outtextxy(10,10,Bmsg);
			return(0);
		}
		fread(k212ind,255*sizeof(long),1,fpw2);
		fclose(fpw2);
		strcpy(k212name,kanjidir);
		strcat(k212name,"kanjd212");
		fpw2 = fopen(k212name,"rb");
		if ( fpw2 == NULL)
		{
			sprintf(Bmsg," Cannot open: %s \n",k212name);
			outtextxy(10,10,Bmsg);
			return(0);
		}
		k212open = TRUE;
	}
	yi = c2;
	yp = k212ind[yi];
	if (yp == 0)
	{
		outtextxy(pcol,prow,"Cannot find this kanji in the KANJD212 file! (1)");
		sprintf(Bmsg,"%x%x",c2,c3);
		outtextxy(pcol,prow+20,Bmsg);
		outtextxy(pcol,prow+40,"  Press any key to return to the Dictionary ......");
		c=waitch();
		return(0);
	}
	yp--;
	fseek(fpw2, yp, SEEK_SET);
	while (!feof(fpw2))
	{
		fgets(yline,255,fpw2);
		if (yline[1] != c2)
		{
			outtextxy(pcol,prow,"Cannot find this kanji in the KANJD212 file! (2)");
			return(0);
		}
		if (yline[2] != c3) continue;
		strcpy(ylinebest,yline+4);
  		khi = 0;
  		klo = 0;
		for (i = 0; i < strlen(ylinebest)-1; i++)
		{
			if (pcol >= maxx-20)
			{
				pcol = 20;
				prow+=20;
			}
			cc = ylinebest[i];
			if (cc == 0x8f)
			{
				JIS212 = TRUE;
				continue;
			}
			if (cc < 128) /* non-Japanese, display it*/
			{
				ops[0]= cc;
				ops[1] = '\0';
				kouttextxy(pcol,prow,ops);
				pcol = pcol+=afntspce;
			}
			else   /* kana or kanji  */
			{
				if (khi == 0)
				{
					khi = (cc-128) & 0xff;
				}
				else
				{
					klo = (cc-128) & 0xff;
					OutKanji(jis2index(khi,klo));
					khi = 0;
					klo = 0;
					JIS212 = FALSE;
				}
			}
		}
		putimage (4,maxy-20,bline,COPY_PUT);
		prowa = maxy-14;
		outtextxy(10,prowa,"Display Compounds ((A)ll, (F)irst) or e(X)it function :");
		if (Vmode) Vmsg(30);
		while(TRUE)
		{
			sch[0] = '0';
			c  = getchx();
			FirstKanj = TRUE;
			if ((c  == 'A')||(c  == 'a'))FirstKanj = FALSE;
			if ((c  == 'A')||(c  == 'a')||(c == 'F')||(c =='f'))
			{
				c  = 'x';
				sch[0] = 0x8f;
				sch[1] = c2 | 0x80;
				sch[2] = c3 | 0x80;
				sch[3] = 0;
				InitScr();
			}
			if ((c  == 'x')||(c  == 'X')||(c == 0x1b)) break;
		}
		if (sch[0] != '0') return(1);
		return(0);
	}
}
/*====DoNels===find & display according to Nelson or Halpern No=============*/
int DoNels(int nelind)
{
	int ir,p1,p2,indsav,indnel,meank,prownext;
	char cs1,cs2;

/* nelind == 0 => need to search for nelson no, otherwise nelind = JIScode  */	
	indnel = nelind;
	i = indnel;
	if( indnel == 0)
	{
		if (Halpf)
		{
			if (Vmode) Vmsg(12);
			indnel = GetNo( "Halpern No: ");
			if(indnel == 0) return(0);
			AddKH(4,indnel);
			indnel = BinSrch(indnel,"kinfohal.idx",2);
		}
		else
		{
			if (Vmode) Vmsg(11);
			indnel = GetNo( "Nelson No: ");
			if(indnel == 0) return(0);
			AddKH(3,indnel);
			indnel = BinSrch(indnel,"kinfonel.idx",2);
		}
		if (indnel == 0) return(0);
		CloseKind();
		i = rec.index;
	}
	if (K212)
	{
		ir = Dispk212(((indnel >> 8) & 0x7f) | 0x80, (indnel & 0x7f) | 0x80);
		K212 = FALSE;
		AddKH(12,indnel);
		return(ir);
	}
	if(!KHFlag) AddKH(8,i);
	indsav = i;
	i = i - 0x3021;
	OpenKinf();
	seekoff = (i >> 8 )*94 + (i & 0xff);
	seekoff *= sizeof(KINFORECORD);
	if((iores = fseek(fk,seekoff,SEEK_SET)) != 0)SeekErr(iores);
	iores = fread(&krec,sizeof(KINFORECORD),1,fk);
	if (krec.padding != KVER) Bomb("Incorrect kinfo.dat version!");	
	bush = krec.bushu;
	grade = krec.grade;
	nels = krec.indexn;
	halp = krec.indexh;
	strk = krec.strokes;
	kunk = krec.onkun >> 4;
	onk = krec.onkun & 0xf;
	meank = krec.meanings >> 4;

	seekoff = krec.offset;
	if ((seekoff == -1L)||(seekoff == 0L))
	{
		krec.offset = 0;
		krec.onkun = 0;
		meank = 0;
		onk = 0;
		kunk = 0;
	}
	else
	{
		if((iores = fseek(fk,seekoff,SEEK_SET)) != 0)SeekErr(iores);
	}
	c1 = indsav >> 8;
	c2 = indsav & 0xff;
	p1 = c1 & 0x7f;
	p2 = c2 & 0x7f;
	jis2sjis(&p1,&p2);
	cs1 = p1;
	cs2 = p2;
	pcol = 15;
	prow = 45;
	prownext = 65;
	kouttextxy(20,23,"         K A N J I   I N F O R M A T I O N   D I S P L A Y");
	if(BigFont)
	{
		BigKanji(c1,c2);
	}
	else
	{
		OutKanji(jis2index(c1,c2));
	}
	sprintf (ops,"JIS: %X%X (%c%c) Kuten: %d SJIS: %X%X Bushu: %d Strokes: %d Grade: %d",c1,c2,c1,c2,((c1&0x7f)-0x20)*100+(c2&0x7f)-0x20,cs1,cs2,bush,strk,grade);
	kouttextxy(40,prow,ops);
	prow+=20;
	prownext+=20;
	sprintf (ops,"Nelson: %d Halpern: %d ",nels,halp);
	kouttextxy(40,prow,ops);
	prow+=20;
	prownext+=20;
	if ((krec.offset == 0)||(krec.onkun == 0))
	{
		kouttextxy(10,prow,"No yomikata available.");
		prow=prownext;
		prownext+=20;
	}
	else
	{
		if (onk > 0)
		{
			pcol = 85;
			kouttextxy(10,prow,"ONYOMI:");
			for (is = 0; is < onk; is++)
			{
				fgets(fks,39,fk);
				if(pcol+strlen(fks)*kfntspce > maxx-3)
				{
					prow+=20;
					prownext = prow+20;
					pcol = 85;
				}
				for (i = 0; i < strlen(fks)-1; i++)
				{
					if(fks[i] == 0x20)
					{
						OutKanji(jis2index(0x21,0x26));
						continue;
					}
					if(fks[i] == 0x1f)
					{
						OutKanji(jis2index(0x21,0x3c));
						continue;
					}
					OutKanji(jis2index(0x25,fks[i]));
				}
				pcol+=kfntspce;
			}
			prow+=20;
			prownext+=20;
		}
		if (kunk > 0)
		{
			pcol = 85;
			kouttextxy(10,prow,"KUNYOMI:");
			for (is = 0; is < kunk; is++)
			{
				fgets(fks,39,fk);
				if(pcol+strlen(fks)*kfntspce > maxx-3)
				{
					prow+=20;
					prownext = prow+20;
					pcol = 85;
				}
				for (i = 0; i < strlen(fks)-1; i++)
				{
					if(fks[i] == 0x20)
					{
						OutKanji(jis2index(0x21,0x26));
						continue;
					}
					if(fks[i] == 0x1f)
					{
						OutKanji(jis2index(0x21,0x3c));
						continue;
					}
					OutKanji(jis2index(0x24,fks[i]));
				}
				pcol+=kfntspce;
			}
			prow+=20;
			prownext+=20;
		}
	}
	if ((krec.offset == 0)||(meank == 0))
	{
		kouttextxy(10,prow,"No meanings available.");
	}
	else
	{
		if (meank > 0)
		{
			pcol = 85;
			kouttextxy(10,prow,"DETAILS:");
			for (is = 0; is < meank; is++)
			{
				fgets(fks,199,fk);
				fks[strlen(fks)-1] = '\0';
				if (is < meank-1)strcat(fks,"; ");
				meanstr = strtok(fks," ");
				while(meanstr != NULL)
				{
					if (pcol+strlen(meanstr)*afntspce > maxx-3)
					{
						pcol = 10; prow+=18;
					}
					for (i = 0; i < strlen(meanstr); i++)
					{
						ops[0] = meanstr[i]; ops[1] = '\0';
						kouttextxy(pcol,prow,ops);
						pcol+=afntspce;
					}
					ops[0] = ' '; ops[1] = '\0';
					kouttextxy(pcol,prow,ops);
					pcol+=afntspce;
					meanstr = strtok(NULL," ");
				}
			}
		}
	}
	putimage (4,maxy-20,bline,COPY_PUT);
	prowa = maxy-14;
	outtextxy(10,prowa,"Display Compounds ((A)ll, (F)irst), (S)et Filter or e(X)it function :");
	if (Vmode) Vmsg(4);
	while(TRUE)
	{
		sch[0] = '0';
		c  = getchx();
		FirstKanj = TRUE;
		if ((c  == 'A')||(c  == 'a'))FirstKanj = FALSE;
		if ((c  == 'A')||(c  == 'a')||(c == 'F')||(c =='f'))
		{
			c  = 'x';
			sch[0] = c1 | 0x80;
			sch[1] = c2 | 0x80;
			sch[2] = '\0';
			InitScr();
		}
		if ((c  == 'x')||(c  == 'X')||(c == 0x1b)) break;
		if ((c  == 's')||(c  == 'S')||(c == 0x1b)) 
		{
			Kfilt[0] = c1 | 0x80;
			Kfilt[1] = c2 | 0x80;
			Kfilt[2] = 0;
			break;
		}
	}
/*	fclose(fk);*/
	if (sch[0] != '0') return(1);
	return(0);
}

/*===BushStrk===common code for DoBush, DoStrk, etc ========================*/
int BushStrk(int ks, int sindx )
{
	char bschars[30];
	int pageok;

	while (mid >= 0)
	{
		if (ks == 1) test = (rec.code >> 8) & 0xff;
		if (ks == 0) test = rec.code & 0xff;
		if ((ks == 2)||(ks == 3)) test = rec.nelx;
		if ( sindx  != test)break;
		mid--;
		seekoff = mid;
		seekoff *= sizeof(IDXRECORD);
		if((iores = fseek(fki,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(&rec,sizeof(IDXRECORD),1,fki);
	}
	midsav = mid;
	while(TRUE)
	{
		PgOffs = 0;
		PgInit = TRUE;
		PgEnd = FALSE;
		PgEOF = FALSE;
		if (bstroke == 0) strcpy(bschars,"All stroke counts");
		if (bstroke != 0) sprintf(bschars,"%d stroke characters",bstroke);
		ktarg[0] = 0;
		if (ks == 0) sprintf(KIHead,"Kanji Selection  - %d stroke characters",sindx);
		if (ks == 1) sprintf(KIHead,"Kanji Selection  - Radical No. %d - %s",sindx,bschars);
		if (ks == 2) sprintf(KIHead,"Kanji Selection  - Four Corner Code: %d",sindx);
		if (ks == 3) sprintf(KIHead,"Kanji Selection  - SKIP Code: %s",SKsav);

		pageok = FALSE;
		while(TRUE)
		{
			mid++;
			if ( mid > LastIndex)
			{
				PgEOF = TRUE;
				break;
			}
			seekoff = mid;
			seekoff *= sizeof(IDXRECORD);
			if((iores = fseek(fki,seekoff,SEEK_SET)) != 0)SeekErr(iores);
			iores = fread(&rec,sizeof(IDXRECORD),1,fki);
			if (ks == 1) test = (rec.code >> 8) & 0xff;
			if (ks == 0) test = rec.code & 0xff;
			if ((ks == 2)||(ks == 3)) test = rec.nelx;
			if ( sindx  != test)
			{
				PgEOF = TRUE;
				break;
			}
			if((ks == 1) &&( bstroke != 0))
			{
				if((rec.code & 0xff) < bstroke) continue;
				if((rec.code & 0xff) > bstroke) 
				{
					PgEOF = TRUE;
					break;
				}
			}
			nels = rec.nelx;
			c1 = rec.index >> 8;
			c2 = rec.index & 0xff;
			sprintf(ops,"%d",nels);
			if ((!NHmode)||(ks == 3))
			{
				OpenKinf();
				i = rec.index - 0x3021;
				seekoff = (i >> 8 )*94 + (i & 0xff);
				seekoff *= sizeof(KINFORECORD);
				if((iores = fseek(fk,seekoff,SEEK_SET)) != 0)SeekErr(iores);
				iores = fread(&krec,sizeof(KINFORECORD),1,fk);
				if (krec.padding != KVER) Bomb("Incorrect kinfo.dat version!");	
				halp = krec.indexh;
				sprintf(ops,"%d",halp);
			}
			if (ks == 0)
			{
				sprintf(Bmsg,"%d",(rec.code >> 8));
			}
			else
			{
				sprintf(Bmsg,"%d",(rec.code &0xff));
			}
			if(ks == 2)
			{
				sprintf(ops,"%d",(rec.code >> 8));
				sprintf(Bmsg,"%d",(rec.code & 0xff));
			}
			if(ks == 3)
			{
				strcpy(Bmsg," ");
			}
			KnjFlag = TRUE;
			PgDisp(ops,Bmsg);
			PageIndex[PgOffs] = rec.index;
			PgOffs++;
			pageok = TRUE;
			if (PgEnd) break;
		}
		if (!pageok)
		{
			kouttextxy(16,20,KIHead);
			kouttextxy(30,50,"No Kanji for this Selection!");
		}
		NewCurs();
		cresp = CursInp();
		if (cresp > 0)
		{
			CloseKind();
			return (cresp);
		}
		if (cresp < 0)
		{
			CloseKind();
			return(0);
		}
		if (PgEOF)
		{
			mid = midsav;
			pageok = FALSE;
			PgEOF = FALSE;
		}
	}
}

/*=======InitScr====start a fresh screen=================================*/
void InitScr()
{
	char Heading[80];

	cleardevice();
	setlinestyle(SOLID_LINE,0xFFFF,THICK_WIDTH);
	rectangle(0,0,maxx-2,maxy-2);
	strcpy (Heading," J D I C - Japanese-English Dictionary System  Version ");
	strcat (Heading,sver);
  	outtextxy((maxx-9*strlen(Heading))/2,5,Heading);
	outtextxy(maxx-28,5,NHmess);
	if (EPmode) outtextxy(4,5,EPtype);
	if (SFFlag) outtextxy(25,5,"[F]");
	maxr = maxy;
	if (Vmode)
	{
		maxr = maxy-60+15;
		rectangle(0,maxy-60,maxx-2,maxy-24);
	}
}

/*===ScreenEnd==common end-of-screen processing==========================*/
int ScreenEnd()
{
	
	if(Fold) 
	{
		it--;
		hitind--;
	}
	setcolor(Pcolour);
/*XX*/
	putimage (4,maxy-20,bline,COPY_PUT);
	outtextxy(20,maxy-14,"(M)ore of this search, (B)ackup or (A)nother search: ");
	while(TRUE)
	{
		resp = getchx();
		if (resp == 0)
		{
			resp = getchx();
			if (resp == 0x49) resp = 'b';
			if (resp == 0x51) resp = 'm';
		}
		if ((resp == 'q') || (resp =='Q') ||(resp == 'b')||(resp == 'B')||(resp == 'A') || (resp == 'a')||(resp == 'm')||(resp == 'M')||(resp == 0x1b)) break;
	}
	if ((resp == 'q') || (resp =='Q') ||(resp == 'A') || (resp == 'a')||(resp == 0x1b)) return(TRUE);
	if ((resp == 'b')||(resp == 'B'))
	{
		wild = TRUE;
		it = it-BackLines;
		if(it < 0)it = 1;
	}
	InitScr();
	pcol = 10;
	prow = 20;
	setcolor(Acolour);
	kno = 0;
	return(FALSE);
}

/*                  M A I N                                      */
main(argc,argv)
int argc;
char **argv;
{
  char Mloc[20];
  unsigned long schix,schiy,schiz,lo,hi,itok,lo2,hi2;
  int FiltOK,slk,res,AnyDisp,hit,skip,brace,GError;
  int i,j,Keyin=FALSE,JOflag;
  unsigned int YomiSkip,khi,klo,cc,cc1;
  char fpage[256],ops[50],resp,strtmp[50];
  char **ap;
  struct ffblk ffblk;

  /*  get working environment info   */

  if (!Rcfile("JDICRC","jdic.rc"))Rcfile("MOKERC","moke.rc");
  kiaset();

  /*   get command line arguments   */
  if (argc > 1)
  {
	ap = argv;
	for (i = 0; i < argc-1; i++)
	{
		ap++;
		strcpy(strtmp,*ap);
		if (strcmpi(strtmp,"-d") == 0)  /* debug mode*/
		{
			debux = TRUE;
			continue;
		}
		if (strcmpi(strtmp,"-h") == 0)
		{
Bomb("Usage: jdic  [-bnn -Bnn -l -f -mMode -cdir -Llogfile] [dictionary-file]");
		}
		if ((strtmp[0] == '-')&&(strtmp[1] == 'b'))
		{
			if (strtmp[2] == 0)
			{
				ap++;
				i++;
				strcat(strtmp,*ap);
				if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
			}
			novbmax = atoi(strtmp+2);
			if (novbmax < 1) Bomb("JDIC: Don't be silly. Buffers are needed!");
			continue;
		}
		if ((strtmp[0] == '-')&&(strtmp[1] == 'B'))
		{
			if (strtmp[2] == 0)
			{
				ap++;
				i++;
				strcat(strtmp,*ap);
				if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
			}
			BackLines = atoi(strtmp+2);
			continue;
		}
		if ((strtmp[0] == '-')&&(strtmp[1] == 'L'))
		{
			if (strtmp[2] == 0)
			{
				ap++;
				i++;
				strcat(strtmp,*ap);
				if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
			}
			strcpy(LogFile,strtmp+2);
			continue;
		}

		if ((strtmp[0] == '-')&&(strtmp[1] == 'v'))
		{
			Vmode = FALSE;
			continue;
		}

		if ((strtmp[0] == '-')&&(strtmp[1] == 'l'))
		{
			Load = FALSE;
			continue;
		}
		if ((strtmp[0] == '-')&&(strtmp[1] == 'f'))
		{
			Bfont = TRUE;
			continue;
		}
		if ((strtmp[0] == '-')&&(strtmp[1] == 'm'))
		{
			if (strtmp[2] == 0)
			{
				ap++;
				i++;
				strcat(strtmp,*ap);
				if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
			}
			Smode = strtmp[2]-'0';
			strtmp[2] = strtmp[2] | 0x20;
			if((strtmp[2] == 'a') || (strtmp[2] == 'e')) Smode = 0;
			if(strtmp[2] == 'h') Smode = 1;
			if(strtmp[2] == 'k') Smode = 2;
			continue;
		}
		if ((strtmp[0] == '-')&&(strtmp[1] == 'c'))
		{
			if (strtmp[2] == 0)
			{
				ap++;
				i++;
				strcat(strtmp,*ap);
				if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
			}
			strcpy(ops,strtmp+2);
			strcat(ops,"\\jdic.rc");
  			if (!Rcfile("BLETCHXX",ops))
			{
				strcpy(ops,strtmp+2);
				strcat(ops,"\\moke.rc");
  				Rcfile("BLETCHXX",ops);
			}
			continue;
		}

		/* none of the above - assume dictionary name   */
		strcpy(DnameList[NoDics],*ap);
		strcpy(JDXnameList[NoDics],strtok(strtmp," ."));
		strcat(JDXnameList[NoDics],".jdx");
		NoDics++;
		if (NoDics > 10) Bomb (" More than 10 dictionaries!");
		TestDic = FALSE;
	}
  }
  if (NoDics > 0) 
  {
  	NoDics--;
	strcpy(Dname,DnameList[0]);
	strcpy(JDXname,JDXnameList[0]);
  }
/*  No user-specified dictionary, so test which default is present */
  if (TestDic)
  {
  	if ((i = findfirst(Dname,&ffblk,0)) != 0)
  	{
  		strcpy(Dname,Dname2);
		strcpy(JDXname,JDXname2);
	}
	strcpy(DnameList[0],Dname);
	strcpy(JDXnameList[0],JDXname);
  }
/*  check that all dictionary files are there, and find the largest so I
    can set the right table sizes   */

  MAXDICTAB=0; MAXJDXTAB=0;

  for (i = 0;i <= NoDics; i++)
  {
  	fpd = fopen(DnameList[i],"r");
	if(fpd == NULL)
	{
		sprintf(Bmsg,"Unable to open %s",DnameList[i]);
		Bomb(Bmsg);
	}
  	diclen = filelength(fileno(fpd));
	j = (diclen/VBUFFSIZE)+1;
	if (j > MAXDICTAB) MAXDICTAB = j;
	fclose(fpd);
  	fpd = fopen(JDXnameList[i],"r");
	if(fpd == NULL)
	{
		sprintf(Bmsg,"Unable to open %s",JDXnameList[i]);
		Bomb(Bmsg);
	}
  	indlen = filelength(fileno(fpd));
	j = (indlen/VBUFFSIZE)+1;
	if (j > MAXJDXTAB) MAXJDXTAB = j;
	fclose(fpd);
  }
  doffp = malloc(MAXDICTAB*sizeof(int));
  if (!doffp) Bomb("Insufficient memory!");
  joffp = malloc(MAXJDXTAB*sizeof(int));
  if (!joffp) Bomb("Insufficient memory!");
  for (i = 0; i < MAXDICTAB; i++) doffp[i] = -1;
  for (i = 0; i < MAXJDXTAB; i++) joffp[i] = -1;
  if (NoDics > 0) MultDic = TRUE;

/* sort out help & doc file paths  */
	strcpy(helpfilename, kanjidir);
	strcat(helpfilename, helpfile);
	strcpy( docfilename, kanjidir);
	strcat( docfilename,  docfile);

/* test which JIS font file is present  */
	strcpy(fontfilename, kanjidir);
	strcat(fontfilename, "kijis16.fnt");
	OldJIS = FALSE;
  	if ((i = findfirst(fontfilename,&ffblk,0)) != 0)
  	{
		OldJIS = TRUE;
	}
/* sort out if a 24x24 font is present */
	BigFont = FALSE;
	if (strlen(font24name) > 2)
	{
		strcpy(bfontfilename, kanjidir);
		strcat(bfontfilename, font24name);
  		if ((i = findfirst(bfontfilename,&ffblk,0)) == 0)
  		{
			BigFont= TRUE;
			fpf = fopen(bfontfilename,"rb");
  			if (fpf==NULL )
  			{
				sprintf(Bmsg,"\nCannot open dictionary file: %s\n",bfontfilename);
				Bomb(Bmsg);
  			}
		}
		else
		{
			sprintf(Bmsg,"\nCannot open dictionary file: %s\n",bfontfilename);
			Bomb(Bmsg);
		}
	}
	else
	{
		strcpy(bfontfilename, kanjidir);
		strcat(bfontfilename, "jis24");
  		if ((i = findfirst(bfontfilename,&ffblk,0)) == 0)
  		{
			BigFont= TRUE;
			fpf = fopen(bfontfilename,"rb");
  			if (fpf==NULL )
  			{
				sprintf(Bmsg,"\nCannot open dictionary file: %s\n",bfontfilename);
				Bomb(Bmsg);
  			}
		}
		else
		{
			strcpy(bfontfilename, kanjidir);
			strcat(bfontfilename, "asiya24.fnt");
  			if ((i = findfirst(bfontfilename,&ffblk,0)) == 0)
  			{
				BigFont= TRUE;
				fpf = fopen(bfontfilename,"rb");
  				if (fpf==NULL )
  				{
					sprintf(Bmsg,"\nCannot open dictionary file: %s\n",bfontfilename);
					Bomb(Bmsg);
  				}
			}
		}
  }
  /*  sort out graphics   */

  detectgraph(&GraphDriver,&GraphMode);
  if ( GraphDriver < 0)
  {
  	Bomb("No Graphics Driver Detected!\n");
  }
  if((stricmp(getenv("JGRAPHIC"),"ATT400") == 0)||(attflag))
  {
	GraphDriver = ATT400;
	GraphMode = 5;
  }
  if (getenv("BGI") != NULL)
  {
	strcpy(BGIDir,getenv("BGI"));
  }
  initgraph(&GraphDriver,&GraphMode,BGIDir);
  if ((GError = graphresult()) < 0)
  {
	sprintf(Bmsg,"Graphics Error: %s\n",grapherrormsg(GError));
	Bomb(Bmsg);
  }
  Gron = TRUE;
  maxx = getmaxx();
  maxy = getmaxy();
  maxr = maxy;
  setbkcolor(Bcolour);
  setcolor(Pcolour);
  cursize = imagesize(0,0,7,7);
  curstore = malloc(cursize);
  setlinestyle(SOLID_LINE,0xffff,THICK_WIDTH);
  line (50,50,57,50);
  line (50,53,57,53);
  getimage(50,50,57,55,curstore);
  kcursize = imagesize(0,0,3,7);
  kcurstore = malloc(kcursize);
  getimage(50,50,53,57,kcurstore);
  cleardevice();
  /*  set up some blank images for backspacing, etc.   */
  bsize = imagesize(0,0,7,7);
  blank = malloc(bsize);
  getimage(0,0,7,7,blank);
  Msize = imagesize(0,0,28,7);
  lblank = malloc(Msize);
  getimage(0,0,28,7,lblank);
  blsize = imagesize(0,0,maxx-20,16);
  bline = malloc(blsize);
  getimage(0,0,maxx-20,16,bline);
  kbsize = imagesize(0,0,40,16);
  kblank = malloc(kbsize);
  getimage(0,0,40,16,kblank);
  /*  initial banner  */
  KIAcolour = Acolour;
  sprintf(fpage,"JDIC Version %s (Japanese-English Dictionary System)",sver);
  kouttextxy((maxx-9*strlen(fpage))/2,maxy/3,fpage);
  sprintf(fpage,"Copyright J.W.Breen 1995.");
  kouttextxy((maxx-9*strlen(fpage))/2,maxy/3+20,fpage);
  sprintf(fpage,"Using Dictionary File: %s ",Dname);
  kouttextxy((maxx-9*strlen(fpage))/2,maxy/3+40,fpage);
  sprintf(fpage,"Press F1 for a summary of the keyboard commands");
  kouttextxy((maxx-9*strlen(fpage))/2,maxy-20,fpage);
  if (Load)
  {
  	sprintf (fpage,"Loading Dictionary and Fonts.  Please wait.....");
  	kouttextxy((maxx-9*strlen(fpage))/2,maxy/3+60,fpage);
  }

  FontSetUp  ();  /* Initialize JIS  file(s) */
  DicSet ();      /* set up dictionary buffers  */
  DicInit();      /* load dictionary  */
  NHmess[0] = '0';
  LoadKana();
  sprintf(novbs,"%d",novbuff);

  /*  This is the main loop driving the dictionary lookup  */

  while (TRUE)
  {

  /*  initialize the screen   */
  resp = ' ';
  InitScr();
  if (Vmode)
  {
  	if(Smode == 0) Vmsg(1);
  	if(Smode != 0) Vmsg(2);
  }
  ReDoScr = FALSE;
  YomiSkip = FALSE;
  if (Smode !=0)YomiSkip = TRUE;
  AnyDisp = FALSE;
  /*  get search key, unless already obtained   */
  if(!Keyin)
  {
  	prowa = maxy-14;
  	prow = maxy-16;
  	outtextxy(10,prowa,Stype[Smode]);
  	outtextxy(40,prowa,"Search Key (Esc to quit): ");
  	outtextxy(maxx-136,prowa,"[F1 for Help]");
  	pcol = 245;
  	pcolk = maxx-300;
	KIndex = FALSE;
	GetKey();
	YomiSkip = FALSE;
    if (Smode !=0)YomiSkip = TRUE;
  }
  Keyin = FALSE;
  if (KIndex)		/*  F5-10 was pressed, so do the Kanji Index lookup  */
  {
	YomiSkip = FALSE;
	if(DoKIndex()) continue;	/* Loop around unless successor search required */
  }
  if (ReDoScr) 
  {
  	Keyin = FALSE;
	continue;
  }
  setcolor(Acolour);

/* now do a binary search through the index table looking for a match  */
  if (strlen(sch) == 0) strcpy(sch,"qwerty@#");
  pcol = 10;
  prow = 20;
  khi = 0;
  klo = 0;
  lo = 1;
  hi = indptr;
  while(TRUE)
  {
  	it = (lo+hi)/2;
	res = Kstrcmp2();
	if (res == 0)
	{
		itok = it;
		lo2 = lo;
		hi2 = it;
		while (TRUE)
		{
			if(lo2+1 >= hi2) break;
			it = (lo2+hi2)/2;
			res = Kstrcmp2();
			if (res == 0)
			{
				hi2 = it;
				itok = it;
				continue;
			}
			else
			{
				lo2 = it+1;
			}
		}
		res = 0;
		it = itok;
		break;
	}
	if (res < 0)
	{
		hi = it-1;
	}
	else
	{
		lo = it+1;
	}
	if (lo > hi)break;
  }
/*  we have a match, so scan backwards up the table to find the first   */
  if (res == 0)
  {
	while (TRUE)
	{
		if(Kstrcmp2() == 0)
		{
			it--;
			if (it == 0)
			{
				it = 1;
				break;
			}
			continue;
		}
		else
		{
			it++;
			break;
		}
	}
  }
  else
  {
	it = 1;
  }
  hit = FALSE;
  hitind = 0;
  hittab[0] = -1;
  ops[0] = 0;
  kno = 0;

/* this is the display loop - usually one line per entry  */
  while (wild || (Kstrcmp2() == 0))   /* display as long as there are matches*/
  {
	schix = jindex(it);
	schiy = schix;
/* back off to the start of this line   */
	while ((dbchar(schix) != 10) && (schix >= 0)) schix--;
	schix++;
	JOflag = FALSE;
/* make copy of line for filter testing   */
	FiltOK = TRUE;
	slk=0;
	for(schiz=0;dbchar(schix+schiz)>=0x20;schiz++)
	{
		testline[schiz] = dbchar(schix+schiz);
		if(testline[schiz]=='/')slk++;
	}
	testline[schiz+1] = '\0';
	if(nofilts)
	{
		FiltOK = TRUE;
		if(nofilts>0)
		{
			for (i=0;i<NOFILT;i++)
			{
				if(!filtact[i]||!filton[i])continue;
				if(filttype[i] == 0)
				{
					FiltOK = FALSE;
					for(j=0;j<filtcoden[i];j++)
					{
						if(strstr(testline,filtcodes[i][j]) != NULL)
						{
							FiltOK = TRUE;
							break;
						}
					}
					if(FiltOK)break;
				}
				if((filttype[i] == 1)||((filttype[i] == 2)&&(slk <= 2)))
				{
					FiltOK = TRUE;
					for(j=0;j<filtcoden[i];j++)
					{
						if(strstr(testline,filtcodes[i][j]) != NULL)
						{
							FiltOK = FALSE;
							break;
						}
					}
					if(!FiltOK) break;
				}
			}
		}
	}
/*  check one-off kanji filter   */
	if (FiltOK && (Kfilt[0] != 0))
	{
		FiltOK = FALSE;
		for (i = 0; testline[i] != ' '; i+=2)
		{
			if (( testline[i] == Kfilt[0]) && (testline[i+1] == Kfilt[1]))
			{
				FiltOK = TRUE;
				break;
			}
		}
	}
/*  check one-off keyboard filter   */
	if (SFFlag && FiltOK)
	{
		FiltOK = FALSE;
		if (strstr(testline,SingleFilter) != NULL) FiltOK = TRUE;
	}
/* now work forwards, displaying the line if it passes the tests */
	if(FiltOK&&(wild || (addhit(schix) != 0))&&(!FirstKanj||( FirstKanj && (dbchar(schiy-1) < 127))))
	{
	AnyDisp = TRUE;
	Fold=FALSE;
	linepos[kno] = schix;
	lineyy[kno] = prow;
	kno++;
/* If it is a continous display, and the index points at a kanji, force the
   display of the yomikata */
	if (wild && (dbchar(schiy) > 0xa5)) YomiSkip = FALSE;
	if (wild && (dbchar(schiy) == 0x8f)) YomiSkip = FALSE;
/* First, display the matched word/kana string  */
	while (TRUE)
	{
		cc = dbchar(schiy);
		if (cc == SPTAG)
		{
			schiy++;
			continue;
		}
		if (cc < 128)
		{
			if (!isalnum(cc)) break;
		}
		if (cc < 128) /* non-Japanese, display it*/
		{
			ops[0]= cc;
			ops[1] = '\0';
			kouttextxy(pcol,prow,ops);
			pcol = pcol+afntspce;
			ops[0] = 0;
		}
		else   /* kana or kanji  */
		{
			if (cc == 0x8f)
			{
				JIS212 = TRUE;
				schiy++;
				continue;
			}
			if (khi == 0)
			{
				khi = (cc-128) & 0xff;
			}
			else
			{
				klo = (cc-128) & 0xff;
				OutKanji(jis2index(khi,klo));
				khi = 0;
				klo = 0;
				JIS212 = FALSE;
			}
		}
		schiy++;
	}
	pcol+=afntspce;
	hit = FALSE;
	skip = FALSE;
	brace = FALSE;
	/* If the first word has already been displayed, skip it.
	   Otherwise, put braces around the first word (kanji)  */
	if (schix == jindex(it))
	{
		skip = TRUE;
	}
	else
	{
		pcol-=7;
		OutKanji(jis2index(0x21,0x5A));  /* JIS [  */
		brace = TRUE;
	}
	while (TRUE)
	{
		cc = dbchar(schix);
		cc1 = dbchar(schix+1);
		if (cc < 32)
		{
			break;
		}
		if (cc==' ')skip = FALSE;
		if ((brace)&&(cc==' '))
		{
			brace = FALSE;
			OutKanji(jis2index(0x21,0x5B));     /* JIS ]  */
			pcol-=7;
		}
		/* turn off yomikata skipping when a ']' is reached  */
		if ((skip)&&(cc==']'))
		{
			skip = FALSE;
			schix++;
			continue;
		}
		/* skip yomikata display during a kana search  */
		if ((YomiSkip)&&(cc=='[')) skip = TRUE;
		/* put a () around the yomikata in an ascii or Kanji search */
		if ((!YomiSkip)&&(cc=='['))
		{
/*			pcol-=7;	*/
			OutKanji(jis2index(0x21,0x4A));  /* JIS (  */
			schix++;
			continue;
		}
		if ((!YomiSkip)&&(cc==']'))
		{
			OutKanji(jis2index(0x21,0x4B));  /* JIS )  */
			pcol-=7;
			schix++;
			continue;
		}
		if (skip)
		{
			schix++;
			continue;
		}
		if (cc < 128) /* non-Japanese, display it
					(fix up the EDICT "/") */
		{
			switch (cc) {
			
			case '/':
				if (hit)
				{
					if(cc1 >= 0x20)	strcat(ops,"; ");
				}
				else
				{
					hit = TRUE;
					strcpy (ops," ");
				}
				WordOut(ops);
				break;
			case '-':
				strcat(ops,"-");
				WordOut(ops);
				break;
			case '.':
				strcat(ops,".");
				WordOut(ops);
				break;
			case ' ':
				if (strlen(ops) > 0)
				{
					WordOut(ops);
					strcpy(ops," ");
					WordOut(ops);
				}
				if (JOflag && (!skip))
				{
					strcpy(ops," ");
					WordOut(ops);
				}
				break;
			default:
				strtmp[0] = cc;
				strtmp[1] = 0;
				strcat(ops,strtmp);
				JOflag = FALSE;
			}	
		}
		else   /* kana or kanji  */
		{
			JOflag = TRUE;
			if (cc == 0x8f)
			{
				JIS212 = TRUE;
				schix++;
				continue;
			}
			if (khi == 0)
			{
				khi = (cc-128) & 0xff;
			}
			else
			{
				klo = (cc-128) & 0xff;
				if (pcol+16 > maxx-6)
				{
					pcol = 40;
					prow+=17;
				}
				OutKanji(jis2index(khi,klo));
				khi = 0;
				klo = 0;
				JIS212 = FALSE;
			}
		}
		schix++;
	}
	prow = prow+17;
	pcol = 10;
	}
	if (prow > maxr-32)  /* no more room on screen */
	{
  		if (Vmode) Vmsg(3);
		if(ScreenEnd()) break;
	}
	it++;
	if (it >= indptr) break;
}
Kfilt[0] = 0;
setcolor(Pcolour);
if ((res != 0)||(!AnyDisp))
{
	kouttextxy(maxx/2-80,maxr/2,"No Match Found");
}
if ((resp == 'q') || (resp =='Q')||(resp == 0x1b)) break;
if ((resp == 'A') || (resp =='a')) continue;

/* we are now at the bottom of a short screen, so get the next search key */
  if (Vmode)
  {
  	if(Smode == 0) Vmsg(1);
  	if(Smode != 0) Vmsg(2);
  }
putimage (4,maxy-20,bline,COPY_PUT);
prowa = maxy-14;
prow = maxy-16;
outtextxy(10,prowa,Stype[Smode]);
outtextxy(40,prowa,"Search Key (Esc to quit): ");
outtextxy(maxx-136,prowa,"[F1 for Help]");
pcol = 245;
pcolk = maxx-300;
KIndex = FALSE;
GetKey();
Keyin = TRUE;
if (ReDoScr) Keyin = FALSE;
}
closegraph();
}
