/**************************************************************************
*                       J D X G E N
*                                                   Author: Jim Breen
***************************************************************************
*  Warning - with unsigned char                                           *
***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include <io.h>
#include <dos.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <string.h>

#define MAX_HANDLES 100
#define TRUE 1
#define FALSE 0
#define MAXFILES 100
#define RECPERFILE 25000
#define SPTAG '@'


typedef struct {
	char key[6];
	unsigned long index;
	} INDEXREC;

INDEXREC filerecs[MAXFILES];
INDEXREC outrec;

FILE *fd,*fopen();

float fnorec;
unsigned int fhs,fhj,fht[MAXFILES];
unsigned long recperfile=RECPERFILE,recfil,it,lone,charnost,charno,noent,space,spacelen;
char Dname[50] = {"edict"};
char JDXname[50] = {"edict.jdx"};
char *exlist[100];				/* list of words to be excluded */
int excount,exlens[100];
int jiver = 14;		/*The last time the index structure changed was Version1.4*/
char kanjidir[120] = {""};
unsigned long schi,diclen,ltemp,indlen,sortrecin=0,sortrecout=0;
int filek,i,inwd,jdxf,cstrp,saving,FirstEnt,isc,NoFiles = 0;
char systemp[50],TFname[50],SortFile[50] = {""};
char TempPath[50] = {""};
unsigned char c;
char currstr[500],strtmp[50];
char currstr2[500];
char fileasc[10];
unsigned int _openfd[MAX_HANDLES];  /* THIS MUST BE GLOBAL!!! */
int handlesAvail;
unsigned char     newHandleArray[MAX_HANDLES];

/*====== prototypes========================================================*/
int Rcfile(char *env, char *rcfile);
int alphaoreuc(unsigned char c);
void ExSet();
void moreHandles( void );

/****************************************************************************/
/*                                 moreHandles                              */
/****************************************************************************/

void moreHandles( void )

/*// Allocates more file handles from DOS.  Directly changes the handle count*/
/*// and handle array pointer in the PSP.*/

{
    /*static unsigned char far    newHandleArray[MAX_HANDLES];*/
    unsigned char far           *oldArray;
    unsigned int far            *psp;

 /* initialize table of handles and the first five reserved ones */

    memset( _openfd, 0xff, MAX_HANDLES );

    _openfd[0] = O_RDONLY | O_DEVICE;
    _openfd[1] = O_WRONLY | O_DEVICE;
    _openfd[2] = O_WRONLY | O_DEVICE;
    _openfd[3] = O_RDWR   | O_DEVICE | O_BINARY;
    _openfd[4] = O_WRONLY | O_DEVICE | O_BINARY;

/*// Init all the new handles to empty*/

    memset( newHandleArray, 0xff, MAX_HANDLES );

/*// Get the original table address and length*/

    psp = (unsigned int far *)MK_FP( _psp, 0x32 );
    oldArray = (unsigned char far *)MK_FP( psp[2], psp[1] );

/*// Copy the old bytes into the new table*/

    memcpy( newHandleArray, oldArray, psp[0] );

/*// Modify the PSP to point to the new table*/

    psp[0] = MAX_HANDLES;
    psp[1] = FP_OFF( newHandleArray );
    psp[2] = FP_SEG( newHandleArray );

    handlesAvail = psp[0] - 5;
/*
  Note that this line relies on the fact that Dos reserves 5 handles
  for its own use. If less handles are actually available, then some
  other process has reserved extra file handles for its own use.
*/
}

void Flush()
{
	if(recfil == 0) return;
	_close(fhs);

	sprintf(fileasc,"%d",100+NoFiles);
	sprintf(TFname,"%sjdx%c%c.tmp",TempPath,fileasc[1],fileasc[2]);
	sprintf(systemp,"sortf %s %s /L10",SortFile,TFname);
	system(systemp);
	fht[NoFiles] = open (TFname,O_RDONLY | O_BINARY);
	if (fht[NoFiles] < 0)
	{
		printf("\nCannot reopen work file\n");
		exit(1);
	}
	read(fht[NoFiles],&filerecs[NoFiles],sizeof(INDEXREC));

	NoFiles++;
	if (NoFiles == MAXFILES)
	{
		printf("\n Too Many temporary files\n");
		exit(1);
	}
	if (recfil == recperfile)
	{
    	fhs = open(SortFile,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY,S_IWRITE | S_IREAD);
    	if (fhs < 0)
    	{
	    	printf("\nCannot open work file\n");
	    	exit(1);
    	}
	}
    recfil = 0;
	noent = 0;
}
void AddEnt();
void AddEntx()   /* generate 2 indices for words with SPTAG in front */
{
	if (currstr[0] == SPTAG)
	{
		AddEnt();
		strcpy(currstr,currstr+1);
		charnost++;
	}
	AddEnt();
}

void AddEnt()
{
  int gotdigit,ie,iout,icur,fi;
  currstr[cstrp] = '\0';
  inwd = FALSE;
  if ((strlen(currstr) <= 2) && (currstr[0] < 127))
  {
	gotdigit = FALSE;
	for (ie = 0; ie < strlen(currstr); ie++)
	{
		if (isdigit(currstr[ie])) gotdigit = TRUE;
	}
	if (!gotdigit) saving = FALSE;
  }
  if (saving)
  {
	  if (currstr[0] < 128)
	  {
		  for (isc = 0; isc <= excount; isc++)
		  {
			  if (( exlens[isc] == strlen(currstr)) &&
			  (stricmp(currstr,exlist[isc]) == 0)   )
			  {
				  return;
			  }
		  }
	  }
	  for (iout = 0; iout < 6; iout++) 
	  {
	  	outrec.key[iout] = '\0';
	  }
	  icur = 0;
	  iout = 0;
	  while (iout < 6)
	  {
		if (currstr[icur] == '\0') break;
		if (currstr[icur] < 127)
		{
			if (currstr[icur] <= '9')
			{
				outrec.key[iout] = (currstr[icur] & 0x0f) + 1;
			}
			else
			{
				outrec.key[iout] = (currstr[icur] & 0x1f) + 11;
			}
			icur++;
			iout++;
			continue;
		}
		if ((currstr[icur] == 0xa4)||(currstr[icur] == 0xa5))
		{
			outrec.key[iout] = (currstr[icur+1] & 0x7f) + 10;
			iout++;
			icur+=2;
			continue;
		}
		if (currstr[icur] == 0x8f) /* JIS212*/
		{
			outrec.key[iout] = 40;
			outrec.key[iout+1] = currstr[icur+1];
			outrec.key[iout+2] = currstr[icur+2];
			iout+=3;
			icur+=3;
			continue;
		}
		if (currstr[icur] < 0xa4)
		{
			outrec.key[iout] = 41;
			outrec.key[iout+1] = currstr[icur];
			outrec.key[iout+2] = currstr[icur+1];
			iout+=3;
			icur+=2;
			continue;
		}
		outrec.key[iout] = currstr[icur];
		outrec.key[iout+1] = currstr[icur+1];
		icur+=2;
		iout+=2;
	}
	outrec.index = charnost;
	fi = write(fhs,&outrec,sizeof(INDEXREC));
	if (fi != sizeof(INDEXREC))
	{
		printf("\n Error writing temporary file\n");
		exit(1);
	}
	sortrecin++;
	recfil++;
	if (recfil == recperfile)
	{
		Flush();
		recfil = 0;
		printf("Resuming dictionary scan");
	}
  }
}

main(argc,argv)
int argc;
char **argv;
{
  char **ap,OutDisk,c;
  int ib,fi;
  long dicsize,spcalc,DiskFree;

  struct dfree    DiskTab;

  moreHandles();
  printf("\nJ D X G E N  V2.6 Index Table Generator for Japanese Dictionary files\n      Copyright (c) J.W. Breen, June 1996\n");
  printf("\nWARNING!!  This program takes a very long time to run .....\n");
  fnorec = coreleft();
  recperfile = fnorec/17.3;
  printf("Records/workfile set to : %ld.\n",recperfile);
  /*   get command line arguments   */
  if (argc > 1)
  {
	ap = argv;
	for (i = 0; i < argc-1; i++)
	{
		ap++;
		strcpy(strtmp,*ap);
		if ((strtmp[0] == '-')&&(strtmp[1] == 't'))
		{
			strcpy(TempPath,strtmp+2);
			strcat(TempPath,"\\");
			continue;
		}
		if ((strtmp[0] == '-')&&(strtmp[1] == 'r'))
		{
			recperfile = atol(strtmp+2);
			printf("Records/workfile set to : %ld by command-line request.\n",recperfile);
			continue;
		}
		/* none of the above - assume dictionary name   */
		strcpy(Dname,*ap);
		strcpy(JDXname,strtok(strtmp," ."));
		strcat(JDXname,".jdx");
    	printf("Commandline request to use files %s and %s \n",Dname,JDXname);
	}
  }
  if (!Rcfile("JDICRC","jdic.rc"))Rcfile("MOKERC","moke.rc");
  ExSet();
  inwd = FALSE;
  lone = 1;
  fd=fopen(Dname,"rb");
  if (fd==NULL )
  {
	printf("\nCannot open dictionary file\n");
	exit(1);
  }
  diclen = filelength(fileno(fd));
  ltemp = diclen+1;
  ltemp+=jiver;
  spcalc = (diclen/8)*16;
  strcpy(SortFile,TempPath);
  strcat(SortFile,"sortfile.xyz");
  if(SortFile[1] == ':')
  {
  	OutDisk = toupper(SortFile[0])-'A'+1;
  }
  else
  {
		OutDisk = getdisk() + 1;
  }
  getdfree(OutDisk, &DiskTab);
  DiskFree = (long) DiskTab.df_avail * DiskTab.df_sclus * DiskTab.df_bsec;
  printf("Free space on disk is : %ld \n",DiskFree);
  printf("Free space in RAM is : %ld \n",coreleft());
  if (spcalc > DiskFree)
  {
  	printf("WARNING! The disk space needed is expected to be %ldk bytes for the\noutput file and %ldk bytes for work files.\nDo you wish to proceed? (y/n)\n",((diclen/8)*5)/1024,((diclen/8)*11)/1024);
	c = getch();
	if(toupper(c) != 'Y') exit(0);
  }
  printf("Parsing the Dictionary...\n");
    fhs = open(SortFile,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY,S_IWRITE | S_IREAD);
    if (fhs < 0)
    {
	   	printf("\nCannot open work file\n");
	   	exit(1);
    }
  recfil = 0;
  saving = FALSE;
  cstrp = 0;
  charno = 0;
  while(!feof(fd))
  {
	  c = fgetc(fd);
	  charno++;
	  if (inwd)
	  {
		  if (!alphaoreuc(c))
		  {
			  FirstEnt = TRUE;
			  AddEntx();
			  FirstEnt = FALSE;
			  strcpy(currstr2,currstr);
			  charnost+=2;
			  ib=2;
			  if (currstr[0] == 0x8f)
			  {
			  	charnost++;
				ib++;
			  }
			  for (;(currstr2[ib] != 0) && (strlen(currstr2) >=2);)
			  {
			  	if (currstr2[ib] < 127)
				{
					ib++;
					charnost++;
					continue;
				}
				if ((currstr2[ib] <= 0xa5) && (currstr2[ib] != 0x8f))
				{
					ib+=2;
			  		charnost+=2;
					continue;
				}
				strcpy(currstr,currstr2+ib);
				cstrp = strlen(currstr);
				AddEntx();
				ib+=2;
			  	charnost+=2;
			    if (currstr[0] == 0x8f)
			    {
			  	  charnost++;
				  ib++;
			    }
			  }
		  }
		  else
		  {
			  currstr[cstrp] = c;
			  currstr[cstrp+1] = 0;
			  if(cstrp < 495) cstrp++;
		  }
	  }
	  else
	  {
		  if (alphaoreuc(c) || (c == SPTAG))
		  {
			  inwd = TRUE;
			  cstrp = 1;
			  currstr[0] = c;
			  currstr[1] = '\0';
			  saving = TRUE;
			  charnost = charno;
		  }
	  }
    }
	printf("Scan complete ... \n");
	Flush();
    fhj = open(JDXname,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY,S_IWRITE | S_IREAD);
    if (fhj < 0 )
    {
    	printf("\nCannot open %s output file\n",JDXname);
    	exit(1);
  	}


	printf("Merging %d workfile(s)\n",NoFiles);
	printf("Records in Index file: %ld\n",sortrecin);
	filek = NoFiles;
	if (NoFiles == 1)
	{
		NoFiles = 2;
		filerecs[1].key[0] = 0xff;
	}

	write(fhj,&ltemp,sizeof(long));
	while(1)

	{
		it = 0;
		for(i = 1; i < NoFiles;i++)
		{
			if (strncmp(filerecs[i].key,filerecs[it].key,6) < 0) it = i;
		}
		if ( filerecs[it].key[0] == 0xff)
		{
			_close(fhj);
			printf("Index file generation complete.\n");
			printf("\nRecords written: %ld \n",sortrecout);
			it = remove(SortFile);
			if (it != 0) printf ("File delete error. Reason: %s \n",sys_errlist[errno]);
			for (i = 0; i < filek; i++)
			{
				_close(fht[i]);
				sprintf(fileasc,"%d",100+i);
				sprintf(TFname,"%sjdx%c%c.tmp",TempPath,fileasc[1],fileasc[2]);
				it = remove(TFname);
				if (it != 0) printf ("File delete error. Reason: %s \n",sys_errlist[errno]);
			}
			exit(1);
		}
		fi = write(fhj,&filerecs[it].index,sizeof(long));
		if (fi != sizeof(long))
		{
			printf("Error writing index file\n");
			exit(1);
		}
		sortrecout++;
		if ((sortrecout % 100) == 0) printf("Records written: %ld \r",sortrecout);
		if(eof(fht[it]) == 1) 
		{
			filerecs[it].key[0] = 0xff;
			continue;
		}
		read(fht[it],&filerecs[it],sizeof(INDEXREC));
	}
}

/*=========function to set up the exclusion list for the index=========*/
void ExSet()
{
	char *ptr,*wds;
	int i;
/*  WARNING - do not put more than 100 words into this list		*/
	wds = "abbr male col abbr fem masc then and conj int pron pref suf syn ant from adv adj hon hum pol jap japanese ";
	ptr = strtok(wds," ");
	i = 0;
	while (ptr != NULL)
	{
		exlist[i] = ptr;
		exlens[i] = strlen(exlist[i]);
		i++;
		ptr = strtok(NULL," ");
	}
excount = i-1;
}
/*=======function to test a character for alpha or kana/kanji====*/
int alphaoreuc(unsigned char x)
{
	int c;

	c = x & 0xff;
	if(((c >= 65) && (c <= 90)) || ((c >= 97) && (c <= 122)))
	{
		return (TRUE);
	}
	if((c >= 48) && (c <= 57))
	{
		return (TRUE);
	}
	if ((c & 0x80) > 0)
	{
		return(TRUE);
	}
	return (FALSE);
}


/*=====Rcfile - access and analyze "jdic.rc" or "moke.rc" file (if any)=====*/
int Rcfile(char *env, char *rcfile)
{
	char mokedir[128],rcstr[80],*rcwd;
	FILE *fm,*fopen();

	mokedir[0] = '\0';
	if (getenv(env)!= NULL)
	{
		strcpy(mokedir,getenv(env));
		strcat(mokedir,"\\");
	}
	strcat(mokedir,rcfile);
	fm = fopen(mokedir,"r");
	if (fm == NULL)
	{
		return(FALSE);
	}
	else
	{
		while(fgets(rcstr,79,fm) != NULL)
		{
			rcwd = strtok(rcstr," \t");
			if( strnicmp("kanjipath",rcwd,9) != 0) continue;
			rcwd = strtok(NULL," \t\f\r\n");
			strcpy(kanjidir,rcwd);
			strcat(kanjidir,"\\");
			break;
		}
	}
	fclose(fm);
	if(strlen(kanjidir) > 1)
	{
		strcpy(rcstr,kanjidir);
		strcat(rcstr,Dname);
		strcpy(Dname,rcstr);
		strcpy(JDXname,Dname);
		strcat(JDXname,".jdx");
	}
}
