/************************************************************************** *
*                           J R E A D E R
*	                  Japanese Text Reader with Dictionary Lookup
*                                                   Author: Jim Breen
***************************************************************************
*  Warning - MUST be compiled with unsigned char                          *
***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <graphics.h>
#include <ctype.h>
#include <string.h>
#include <io.h>
#include <dir.h>
#include <dos.h>
#include <conio.h>

/*  structures for the kinfo.dat & kinfoxxx.idx files     */
typedef struct {
	unsigned char strokes;
   	unsigned char bushu;
   	unsigned short int indexn;
   	unsigned short int indexh;
   	unsigned char grade;
   	unsigned char onkun;
	unsigned char meanings;
   	unsigned char padding;           /* To pad it to 32-bits */
   	unsigned long int offset;
} KINFORECORD;

#define SPTAG '@'
#define TRUE 1
#define FALSE 0
#define SIZECACHE 256 /* JIS2 read cache  */
#define BPCH (14*8)/8  /* bytes for each kiascii character  */
#define MAXJIS 0x74*94+0x24    /*largest JIS2 kanji         */
#define KVER 23   /* version check for kinfo.dat  */
#define ISMARU(A)   (A >= 202 && A <= 206)
#define ISNIGORI(A) ((A >= 182 && A <= 196) || (A >= 202 && A <= 206))
#define HITSIZE 1000	/* number of elements in the "hit" table   */

int ShiftJIS = FALSE, Gron = FALSE,Load = TRUE,Bfont = FALSE,Maint = FALSE;
int LockEUC = FALSE,JIS212 = FALSE,JIS212ON=FALSE,JIS_FLIP;
int maxx,maxy,wild;
unsigned int cursize,kbsize,bsize,blsize,Msize,prowa;
void *curstore,*blank,*lblank,*kblank,*bline;
int Bcolour = BLACK, Kcolour = LIGHTGRAY, Acolour = WHITE, Pcolour = WHITE;
int KIAcolour,wskopen, FirstKanj, attflag = FALSE, Extopen=FALSE;
int k212open = FALSE,font212=FALSE;
int kfntspce=16, afntspce=8;
int JISmode = FALSE;
char filmode[5];
char DnameList[10][80],JDXnameList[10][80];
int NoDics = 0;

FILE *fpw,*fpw2,*fl,*fi;
FILE *fe,*fex;

int HRow,Fold,prow,pcol,pcolk,pcolsav,Smode = 0;
unsigned long indlen,diclen,dbyte,dbyte2,extlen,extjdxlen,hittab[HITSIZE];
unsigned char kiain[BPCH*128];
long lineno=0,linenosav;
int hitind;
unsigned long it,indptr,lone,long0 = 0;
char ops[80],sch[30],Bmsg[100];
char Dname[80] = {"edict"};
char JDXname[80] = {"edict.jdx"};
char EXTname[80] = {"edictext"};
char EXTJDXname[80] = {"edictext.jdx"};
char Dname2[80] = {"jtoe.dct"};
char JDXname2[80] = {"jtoe.jdx"};
char helpfilename[128],helpfile[13] = {"jdic.hlp"};
char docfilename[128],docfile[13] = {"jdic25.doc"};
char Rname[80] = {""};
int Rfirst = TRUE,REOF = FALSE,PBRK=FALSE;
int GraphDriver = DETECT;
int GraphMode;
int Logopen = FALSE;
int ScrBlnk=FALSE;
char BGIDir[20] = {""};
int iver = 26;		/* Version 2.6 */
int jiver = 14;		/*The last time the index structure changed was Version1.4*/
char sver[4] = {"2.6"};
char kanjidir[120] = {""};
char LogFile[30] = {"jreader.log"}, NextFile[80] = {""};
char wskname[50];
char k212name[50];
char logeng[80];
char LogLine[200];
char schbak[80];
long ScrollLine,wskind[255],k212ind[255];
char yline[256],ylinesave[256],*meanstr,*ykanj,*ykana;
char ylinebest[256];
unsigned char fbuff[50][256];
unsigned long Foffsets[50];
int fbcurs[50];
int chppage,lastline,maxyt,cursx,cursy,chpos,flcurr,flmin,flmax,flen[100],chline;
int verblen,LUlen,AutoLook = FALSE;
unsigned char vline[250],vstr[13];
unsigned char tempstr[512];
unsigned char vdicf[350][7],vinfl[350][21],vcomms[40][50];
int Vmsg = FALSE,Vmode = TRUE,Jverb = TRUE,vcommno[350];

struct ffblk ffblk;

/*====== prototypes========================================================*/
void Dispk212(char c2, char c3);
void TextSrch(int TStype);
void HOut(char *s);
void DoNelson();
void Verbinit();
int Vlookup();
int Kstrcmp3();
void SeekErr(int iores);
void Getlogeng(int rowpix);
void NextKanji();
void Logchars();
void SkipArt();
void Lookup();
void Yomilook();
void UpCur();
void DownCur();
void DecCur();
void IncCur();
void BackUp();
int GetColour(char *s);
int Kstrcmpy(int slen);
void NextPage();
void GetEUC(char *eucline);
void eight2seven(int *p1,int *p2);
void getvbuff (int *offp, FILE *fp, long vbo);
unsigned long jindex(unsigned long it);
void ToggleCurs();
unsigned char dbchar(unsigned long it);
void NewCurs();
void DicInit();
void kouttextxy(int kx, int ky, char *s);
void kiaset();
int Rcfile(char *a,char *b);
int jis2index(unsigned int hix, unsigned int lox );
void OutKanji(int index);
void DicSet  ();
int Kstrcmp2();
void Bomb( char *a);
int PixelPerRow = 17;

KINFORECORD krec;

/***************************************************************************
* paging routines for Jim's Japanese software
* for use with jdic, jreader, etc
*currently used for: edict, edict.jdx
***************************************************************************/
#define VBUFFSIZE 1024  /* size in bytes for each virtual buffer  */
#define NOVB 500  /* maximum number of virtual buffers   */
#define MAXFNT 250   /*   "    "      "    fontfile        "       */
#define COLUMN (0x7f-0x21)

void *vbuffs[NOVB];
int *vbptr[NOVB];
long usebuff[NOVB], vbusage = 1;
int *doffp,*joffp,foffp[MAXFNT];
int nelopen = FALSE, TestDic = TRUE;
int novbmax = NOVB;
int vbrf=0,vbrd=0,vbri=0;
char debugb[50],vbrs[10],novbs[10];
int novbuff;
int f2currb = -1;
int f3currb = -1;
int OldJIS = TRUE;
char fontfilename[128];
char fontfilename212[128];
int MAXDIC,MAXJDX;  /* formerly defines, now set dynamically */
int MAXDICTAB,MAXJDXTAB; 

FILE *fn,*fk,*fki,*fpd,*fpi,*fpf1,*fpf2,*fpf3,*fopen();

unsigned long diclen,indlen;

/*====DicSet check Dictionary and index table=======*/
void DicSet()
{
	unsigned long jdxtest[2];
  	lone = 1;
	jdxtest[0] = 0;

  	fpd=fopen(Dname,"rb");
  	if (fpd==NULL )
  	{
		sprintf(Bmsg,"\nCannot open dictionary file: %s\n",Dname);
		Bomb(Bmsg);
  	}
  	diclen = filelength(fileno(fpd));
  	diclen++;
  	dbyte = diclen;
  	fpi = fopen(JDXname,"rb");
  	if(fpi == NULL)
  	{
		sprintf(Bmsg,"\nCannot open index file: %s\n",JDXname);
		Bomb(Bmsg);
  	}
  	indlen = filelength(fileno(fpi));
	indptr = indlen/4-1;
	fread(jdxtest,4,1,fpi);
	if (jdxtest[0] != (diclen+jiver))
	{
		Bomb ("The dictionary and index files do not match! \n");
	}
	MAXDIC = (diclen/VBUFFSIZE)+1;
	MAXJDX = (indlen/VBUFFSIZE)+1;
}

/*====DicInit ====initialize dictionary buffers and load the dictionary*/

void DicInit()
{

  	int ndr,reqb,i;

	reqb =  MAXFNT+diclen/VBUFFSIZE + indlen/VBUFFSIZE+2 ;
  	if (novbmax > reqb) novbmax = reqb;
  	for (novbuff = 0; novbuff < novbmax; novbuff++)
  	{
  		usebuff[novbuff] = -1;
		if (coreleft() < 4000) break;
  		vbuffs[novbuff] = malloc(VBUFFSIZE);
		if (!vbuffs[novbuff])
		{
			break;
		}
  	}
	if(Load)
	{
		ndr = 100;
		if (ndr > novbuff) ndr = novbuff;
		for (i = 0; i < ndr; i++)
		{
			fread(vbuffs[i],1,VBUFFSIZE,fpf1);
			foffp[i] = i;
			vbptr[i] = &(foffp[i]);
			usebuff[i] = 1;
		}
		reqb = novbuff-ndr;
		if (reqb == 0) return;
		ndr = diclen/VBUFFSIZE;
		if (ndr > reqb) ndr = reqb;
		for (i = 100; i < ndr+100; i++)
		{
			fread(vbuffs[i],1,VBUFFSIZE,fpd);
			doffp[i-100] = i;
			vbptr[i] = &(doffp[i-100]);
			usebuff[i] = 1;
		}
  	}
}
/*====waitch===wait for keypress, flush if Fn, etc===================*/
char waitch()
{
	char wc;
	wc = getch();
	if (wc != 0) return(wc);
	wc = getch();
	return(wc);
}

/*=====dbchar====returns specified character from dictionary===============*/

unsigned char dbchar(unsigned long it)
{
	int vbo, vbc,ibuff;
	char *myp;
	long it2;

	it2 = it-1;
	if ((it2 < 0)||(it2 > diclen)) return(10);
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbc = it2 % VBUFFSIZE; /*offset within page  */

	if (doffp[vbo] == -1)
	{
		getvbuff(&(doffp[vbo]),fpd,vbo); /*not resident - get it  */
		vbrd++;
	}
	ibuff = doffp[vbo];         /*page is (now) resident  */
	usebuff[ibuff] = vbusage++;   /* flag this buffer as most recently used */
	myp = vbuffs[ibuff];
	return(myp[vbc]);
}

/*======jindex  returns specified entry from .jdx file========*/

unsigned long jindex(unsigned long it)
{
	int vbo, vbl,ibuff;
	long *myp;
	long it2;

	it2 = it*sizeof(long);
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbl = (it2 % VBUFFSIZE) / sizeof(long); /*offset within page  */

	if (joffp[vbo] == -1)
	{
		getvbuff(&(joffp[vbo]),fpi,vbo); /*not resident - get it  */
		vbri++;
	}
	ibuff = joffp[vbo];         /*page is (now) resident  */
	usebuff[ibuff] = vbusage++;   /* flag this buffer as most recently used */
	myp = vbuffs[ibuff];
	return(myp[vbl]);
}

/*======jfont  returns specified entry from font file========*/

void jfont(int it, int font[16])
{
	int vbo, vbl,ibuff;
	long it2;
	int *myp;
	int i;

	it2 = it;
	it2 *=32;   	/*  16x16 font offset in bytes  */
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbl = (it2 % VBUFFSIZE) / sizeof(int); /*offset within page  */

	if (foffp[vbo] == -1)
	{
		getvbuff(&(foffp[vbo]),fpf1,vbo); /*not resident - get it  */
		vbrf++;
	}
	ibuff = foffp[vbo];         /*page is (now) resident  */
	usebuff[ibuff] = vbusage++;   /* flag this buffer as most recently used */
	myp = vbuffs[ibuff];
	myp+=vbl;
	for (i = 0;i < 16; i++) font[i] = myp[i];
}
/*======jfont2  returns specified entry from JIS2 font file========*/
/*   because jis2 fonts are rarely used, the one local buffer is
     used repeatedly   */

void jfont2(int it, int font[16])
{
	int vbo, vbl,iores;
	long it2,seekoff;
	static char lbuff[VBUFFSIZE];
	int *myp,i;

	it2 = it;
	it2 *=32;   	/*  16x16 font offset in bytes  */
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbl = (it2 % VBUFFSIZE) / sizeof(int); /*offset within page  */

	if (f2currb != vbo)
	{
		seekoff = vbo;
		seekoff *= VBUFFSIZE;
		if((iores = fseek(fpf2,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(lbuff,1,VBUFFSIZE,fpf2);
		f2currb = vbo;
	}
	myp = &lbuff;
	myp+=vbl;
	for(i=0;i<16;i++) font[i] = myp[i];
}
/*======jfont3  returns specified entry from JIS212 font file========*/
/*   because jis212 fonts are rarely used, the one local buffer is
     used repeatedly   */

void jfont3(int it, int font[16])
{
	int vbo, vbl,iores;
	long it2,seekoff;
	static char lbuff3[VBUFFSIZE];
	int *myp,i;

	it2 = it;
	it2 *=32;   	/*  16x16 font offset in bytes  */
	vbo = it2/VBUFFSIZE;   /*page number*/
	vbl = (it2 % VBUFFSIZE) / sizeof(int); /*offset within page  */

	if (f3currb != vbo)
	{
		seekoff = vbo;
		seekoff *= VBUFFSIZE;
		if((iores = fseek(fpf3,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(lbuff3,1,VBUFFSIZE,fpf3);
		f3currb = vbo;
	}
	myp = &lbuff3;
	myp+=vbl;
	for(i=0;i<16;i++) font[i] = myp[i];
}

/*=====getvbuff===allocates a free virtual buffer and reads in the page===*/

void getvbuff (int *offp, FILE *fp, long vbo)
{
	int ibuff,i,iores;
	long maxu,seekoff;

/*     find a free buffer, or free the LRU one   */
	maxu = usebuff[0];
	ibuff = 0;
	for (i = 0; i < novbuff; i++)
	{
		if (usebuff[i] == -1)
		{
			ibuff = i;          /*free buffer available   */
			break;
		}
		else
		{
			if( usebuff[i] < maxu)   /*look for LRU buffer  */
			{
				maxu = usebuff[i];
				ibuff = i;
			}
		}
	}
	/*  read page into buffer   */
	if(usebuff[ibuff] >= 0) *vbptr[ibuff] = -1;
	vbptr[ibuff] = offp;
	*vbptr[ibuff] = ibuff;
	seekoff = vbo;
	seekoff *= VBUFFSIZE;
	if((iores = fseek(fp,seekoff,SEEK_SET)) != 0)SeekErr(iores);
	iores = fread(vbuffs[ibuff],1,VBUFFSIZE,fp);
}

/* === Function to read in JIS Kanji font into RAM ====================== */
int FontSetUp  (void)
{
	int i;

	strcpy(fontfilename212, kanjidir);
	strcat(fontfilename212, "jis21216.fnt");
	if( (fpf3 = fopen(fontfilename212,"rb")) != NULL) font212 = TRUE;
	if (OldJIS)
	{
		strcpy(fontfilename, kanjidir);
		strcat(fontfilename, "k16jis1.fnt");
		if( (fpf1 = fopen(fontfilename,"rb")) == NULL)
		{
			sprintf(Bmsg,"Can't open JIS-1 font file: %s\n",fontfilename);
			Bomb(Bmsg);
		}
		strcpy(fontfilename,kanjidir);
		strcat(fontfilename, "k16jis2.fnt");
    	if( (fpf2 = fopen(fontfilename,"rb")) == NULL)
    	{
			sprintf(Bmsg  ,"Can't open JIS-2 font file: %s\n",fontfilename);
        	Bomb(Bmsg);
    	}
	}
	else
	{
		strcpy(fontfilename, kanjidir);
		strcat(fontfilename, "kijis16.fnt");
		if( (fpf1 = fopen(fontfilename,"rb")) == NULL)
		{
			sprintf(Bmsg,"Can't open JIS16 font file: %s\n",fontfilename);
			Bomb(Bmsg);
		}
	}
	for (i = 0;i<MAXFNT;i++) foffp[i] = -1;
}

/* === Function to convert JIS Kanji code to index into our font data */
int jis2index(unsigned int hix, unsigned int lox )
/* original code from kd.c - hacked by JWB to allow for the unpacked type
of file, and to include the extra 4 kanji in JIS X 0208 (1983)	*/
{
	unsigned int hi,lo;
	hi = hix;
	lo = lox;

	if(JIS212)
	{
		if(!(lo>0x20 && lo<0x7F && hi>0x0 && hi<0x76))
		{
			JIS212 = FALSE;
			return 0xb3;
		}
		if (!font212)
		{
			JIS212 = FALSE;
			return 0xb3;
		}
		if(hi == 0x21 && lo == 0x21)
		{ /* space */
			JIS212 = FALSE;
			hi = 0x22; lo = 0x44;
		}
		return (COLUMN*(hi-0x21)+(lo-0x21));
	}
	if(OldJIS)
	{
	if(lo>0x20 && lo<0x7F && hi>0x20 && hi<0x75)
            hi = 94*hi + lo - 3135;  /* hi=94*(hi-33)+(lo-33) */
	else
            hi = 0x7e7e;   /* debug by K.M. *//* code out of range, apple mark */
	/* "hi" is reused */

        /*...........................range....notation..JIS code.....index... */
	if(hi>=282 && hi <=364)
		hi -= 73; 	/* 282..364  hiragana, $2421-$2473, 209-291  */
	else if(hi>=1410 && hi<=4374)
		hi -= 886; 	/* 1410..4374 kanji-1, $3021-$4f53, 524-3488 */
	else if(hi>=376 && hi<=461)
		hi -= 84; 	/* 376..461  katakana, $2521-$2576, 292-377  */
	else if(hi>=203 && hi<=212)
		hi -= 56;  	/* 203..212   0 .. 9,  $2330-$2339, 147-156  */
	else if(hi>=220 && hi<=245)
		hi -= 63; 	/* 220..245   A .. Z,  $2341-$235a, 157-182  */
	else if(hi>=252 && hi<=277)
		hi -= 69; 	/* 252..277   a .. z,  $2361-$237a, 183-208  */
	else if(hi>=470 && hi<=493)
                hi -= 92;      	/* 470..493   GREEK,   $2621-$2638  378-401  */
	else if(hi>=502 && hi<=525)
                hi -= 100;     	/* 502..525   greek,   $2641-$2658  402-425  */
	else if(hi>=564	&& hi<=596)
                hi -= 138;     	/* 564..596   RUSSIAN, $2721-$2741  426-458  */
	else if(hi>=612 && hi<=644)
                hi -= 153;     	/* 612..644   russian, $2751-$2771  459-491  */
				/*  n/a       linedraw,  n/a        492-523  */
	else if(hi<= 107)
		;  		/* 0..93               $2121-$217e, 0  -93   */
			   	/* 94..107             $2221-$222e, 94 -107  */
	else if(hi>=4418 && hi<=7809)
		hi -= 928;      /* 4418..7809 kanji-2, $5021-$7424, 3490-6881 */
	else	hi = 3489;   /* non printable */
	return(hi);
	}
	else
	{
		if(!(lo>0x20 && lo<0x7F && hi>0x0 && hi<0x76))
			return 0xb3;

		if(hi == 0x21 && lo == 0x21)
		{ /* space */
			hi = 0x22; lo = 0x44;
		}
		return (COLUMN*(hi-0x21)+(lo-0x21));
	}
}
/* === Function to display 1 Kanji at current position ================ */
void OutKanji(int index)     /* 0 <= index <= 6876 */
{
	register int LRbits, ix;
	static int font[16];
	static int x,y,iy;

        /* Read current position */
	x = pcol;
	y = prow-4;

	if (JIS212) 
	{
		jfont3(index,font);	/* JIS-212  */
	}
	else
	{
		if (OldJIS)
		{
			if(index < 3490)
			{
				jfont(index,font);	/* JIS-1  */
			}
			else 
			{
				jfont2(index-3490,font);	/* JIS-2  */
			}
		}
		else
		{
			jfont(index,font);	/* JIS16  */
		}
	}

        /* display kanji -- font stored in TV scan format L->R, Top->Bottom */
	for(iy=0; iy< 16; iy++)
	{
		LRbits = font[iy];
		for(ix=0; ix< 16; ix++)
		{
    		if (LRbits & 1)
    		putpixel(ix+x, iy+y, Kcolour   );
    		LRbits >>= 1;
		}
	}
	pcol += kfntspce;        /* Move 2 ASCII widths for next kanji */
}


/*=====Rcfile - access and analyze "jdic.rc" or "moke.rc" file (if any)======*/

int Rcfile(char *env, char *rcfile)
{
	char mokedir[128],rcstr[80],*rcwd;
	int rctemp;
	FILE *fm,*fopen();

	mokedir[0] = '\0';
	if (getenv(env)!= NULL)
	{
		strcpy(mokedir,getenv(env));
		strcat(mokedir,"\\");
	}
	strcat(mokedir,rcfile);
	fm = fopen(mokedir,"r");
	if (fm == NULL) return(FALSE);
	else
	{
		while(fgets(rcstr,79,fm) != NULL)
		{
			rcwd = strtok(rcstr," \t");
			if( strnicmp("kanjipath",rcwd,9) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(kanjidir,rcwd);
				strcat(kanjidir,"\\");
				continue;
			}
			if( strnicmp("extfile",rcwd,7) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(EXTname,rcwd);
				strcpy(EXTJDXname,rcwd);
				strcat(EXTJDXname, ".jdx");
				continue;
			}
			if( strnicmp("dicfile",rcwd,7) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(DnameList[NoDics],rcwd);
				strcpy(JDXnameList[NoDics],strtok(rcwd," ."));
				strcat(JDXnameList[NoDics],".jdx");
				NoDics++;
				if (NoDics > 10) Bomb (" More than 10 dictionaries!");
				TestDic = FALSE;
				continue;
			}
			if( strnicmp("bgipath",rcwd,7) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				strcpy(BGIDir,rcwd);
				continue;
			}
			if( strnicmp("kanjicolor",rcwd,10) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				Kcolour = GetColour(rcwd);
				continue;
			}
			if( strnicmp("asciicolor",rcwd,10) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				Acolour = GetColour(rcwd);
				continue;
			}
			if( strnicmp("backcolor",rcwd,9) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				Bcolour = GetColour(rcwd);
				continue;
			}
			if( strnicmp("progcolor",rcwd,9) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				Pcolour = GetColour(rcwd);
				continue;
			}
			if( strnicmp("fontspace",rcwd,9) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				rctemp = rcwd[0] -'0';
				if ((rctemp == 0)||(rctemp==2)||(rctemp==4))
				{
					kfntspce = 16+rctemp;
					afntspce = kfntspce/2;
				}
				continue;
			}
			if( strnicmp("graphicstype",rcwd,12) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				if(strnicmp(rcwd,"ATT",3) == 0) attflag = TRUE;
				continue;
			}
			if( strnicmp("jverb",rcwd,5) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				if(strnicmp(rcwd,"on",2) == 0) Jverb = TRUE;
				if(strnicmp(rcwd,"off",3) == 0) Jverb = FALSE;
				continue;
			}
			if( strnicmp("verbose",rcwd,7) == 0)
			{
				rcwd = strtok(NULL," \t\f\r\n");
				if (strnicmp("off",rcwd,3) == 0) Vmode = FALSE;
				continue;
			}
		}
	}
	fclose(fm);
	if(strlen(kanjidir) > 1)
	{
		strcpy(Dname,kanjidir);
		strcpy(Dname2,kanjidir);
		strcpy(JDXname,Dname);
		strcpy(JDXname2,Dname);
		strcat(Dname,"edict");
		strcat(Dname2,"jtoe.dct");
		strcat(JDXname,"edict.jdx");
		strcat(JDXname2,"jtoe.jdx");
	}
	return(TRUE);
}

/*=====HOut=== display a line of the help screen===================*/
void HOut(char *s)
{
	char c;

	if(HRow >= maxyt-32)
	{
		outtextxy(10,maxyt-20,"  .... Press any key to continue;");
		HRow = 10;
		c=getch();
		if(c == 0) c=getch();
		clearviewport();
	}
	outtextxy(10,HRow,s);
	HRow+=12;
}
/*=====WordOut====display a word, folding line if necessary========*/
void WordOut(char *ops)
{
	int sl;
	
	sl = strlen(ops);
	if (ops[0] == SPTAG)
	{
		setcolor(Kcolour);
		KIAcolour = Kcolour;
		strcpy(ops,ops+1);
	}
	if (sl*8+pcol > maxx-11)
	{
		pcol = 40;
		prow+=17;
		Fold = TRUE;
	}
	kouttextxy(pcol,prow,ops);
	pcol=pcol+sl*8;
	ops[0] = 0;
	setcolor(Acolour);
	KIAcolour = Acolour;
}
/*==== Verbinit===Load & initialize verb inflection details==========*/
void Verbinit()
{
	unsigned char *vptr,verbdir[120];
	int vmode,i;
	
	for (i = 0;i< 350;i++)
	{
		vdicf[i][0] = 0;
		vinfl[i][0] = 0;
		vcommno[i] = 40;
	}
	for (i = 0;i<40;i++)
	{
		vcomms[i][0] = 0;
	}
	vmode = 1;
	strcpy(vcomms[40],"Unknown type");
	verbdir[0] = 0;
	if (strlen(kanjidir) > 1)
	{
		strcpy(verbdir,kanjidir);
		strcat(verbdir,"\\");
	}
	strcat(verbdir,"vconj");
	verblen = 0;
	fi = fopen(verbdir,"r");
	if (fi == NULL) 
	{
		Jverb = FALSE;
		return;
	}
	while(TRUE)
	{
		fgets(tempstr,511,fi);
		if(feof(fi))break;
		if (tempstr[0] == '#')continue;
		if (tempstr[0] == '$')
		{
			vmode = 2;
			continue;
		}
		
		switch (vmode) {
		case 1 :
			vptr = strtok(tempstr," \t\n\r");
			i = atoi(vptr);
			if ((i < 0) || (i > 39)) break;
			vptr = strtok(NULL,"\t\n\r");
			strcpy(vcomms[i],vptr);
			break;	
		case 2 :	
			vptr = strtok(tempstr," \t\n\r");
			strcpy(vinfl[verblen],vptr);
			vptr = strtok(NULL," \t\n\r");
			strcpy(vdicf[verblen],vptr);
			vptr = strtok(NULL," \t\n\r");
			i = atoi(vptr);
			if ((i >= 0)&&(i <= 40)) vcommno[verblen] = i;
			verblen++;
			break;
		}
	}
	verblen--;
	fclose(fi);
}

void SeekErr(int iores)
{
	sprintf(debugb,"Seek error %d",iores);
	Bomb(debugb);
}

void jis2sjis(int *p1,int *p2)
{
    register unsigned char c1 = *p1;
    register unsigned char c2 = *p2;
    register int rowOffset = c1 < 95 ? 112 : 176;
    register int cellOffset = c1 % 2 ? 31 + (c2 > 95) : 126;

    *p1 = ((c1 + 1) >> 1) + rowOffset;
    *p2 = c2 + cellOffset;
}
int han2zen(int *p1,int *p2)
{
  int junk,maru,nigori,retval;

  maru = nigori = FALSE;
  retval = 0;
  if (*p2 == 222) 
  {
      if (ISNIGORI(*p1) || *p1 == 179)
	  {
        nigori = TRUE;
		retval = 1;
	  }
  }
  else if (*p2 == 223) 
  {
      if ISMARU(*p1)
	  {
        maru = TRUE;
		retval = 1;
	  }
  }
  switch (*p1) {
    case 161 :
      *p1 = 129;
      *p2 = 66;
      break;
    case 162 :
      *p1 = 129;
      *p2 = 117;
      break;
    case 163 :
      *p1 = 129;
      *p2 = 118;
      break;
    case 164 :
      *p1 = 129;
      *p2 = 65;
      break;
    case 165 :
      *p1 = 129;
      *p2 = 69;
      break;
    case 166 :
      *p1 = 131;
      *p2 = 146;
      break;
    case 167 :
      *p1 = 131;
      *p2 = 64;
      break;
    case 168 :
      *p1 = 131;
      *p2 = 66;
      break;
    case 169 :
      *p1 = 131;
      *p2 = 68;
      break;
    case 170 :
      *p1 = 131;
      *p2 = 70;
      break;
    case 171 :
      *p1 = 131;
      *p2 = 72;
      break;
    case 172 :
      *p1 = 131;
      *p2 = 131;
      break;
    case 173 :
      *p1 = 131;
      *p2 = 133;
      break;
    case 174 :
      *p1 = 131;
      *p2 = 135;
      break;
    case 175 :
      *p1 = 131;
      *p2 = 98;
      break;
    case 176 :
      *p1 = 129;
      *p2 = 91;
      break;
    case 177 :
      *p1 = 131;
      *p2 = 65;
      break;
    case 178 :
      *p1 = 131;
      *p2 = 67;
      break;
    case 179 :
      *p1 = 131;
      *p2 = 69;
      break;
    case 180 :
      *p1 = 131;
      *p2 = 71;
      break;
    case 181 :
      *p1 = 131;
      *p2 = 73;
      break;
    case 182 :
      *p1 = 131;
      *p2 = 74;
      break;
    case 183 :
      *p1 = 131;
      *p2 = 76;
      break;
    case 184 :
      *p1 = 131;
      *p2 = 78;
      break;
    case 185 :
      *p1 = 131;
      *p2 = 80;
      break;
    case 186 :
      *p1 = 131;
      *p2 = 82;
      break;
    case 187 :
      *p1 = 131;
      *p2 = 84;
      break;
    case 188 :
      *p1 = 131;
      *p2 = 86;
      break;
    case 189 :
      *p1 = 131;
      *p2 = 88;
      break;
    case 190 :
      *p1 = 131;
      *p2 = 90;
      break;
    case 191 :
      *p1 = 131;
      *p2 = 92;
      break;
    case 192 :
      *p1 = 131;
      *p2 = 94;
      break;
    case 193 :
      *p1 = 131;
      *p2 = 96;
      break;
    case 194 :
      *p1 = 131;
      *p2 = 99;
      break;
    case 195 :
      *p1 = 131;
      *p2 = 101;
      break;
    case 196 :
      *p1 = 131;
      *p2 = 103;
      break;
    case 197 :
      *p1 = 131;
      *p2 = 105;
      break;
    case 198 :
      *p1 = 131;
      *p2 = 106;
      break;
    case 199 :
      *p1 = 131;
      *p2 = 107;
      break;
    case 200 :
      *p1 = 131;
      *p2 = 108;
      break;
    case 201 :
      *p1 = 131;
      *p2 = 109;
      break;
    case 202 :
      *p1 = 131;
      *p2 = 110;
      break;
    case 203 :
      *p1 = 131;
      *p2 = 113;
      break;
    case 204 :
      *p1 = 131;
      *p2 = 116;
      break;
    case 205 :
      *p1 = 131;
      *p2 = 119;
      break;
    case 206 :
      *p1 = 131;
      *p2 = 122;
      break;
    case 207 :
      *p1 = 131;
      *p2 = 125;
      break;
    case 208 :
      *p1 = 131;
      *p2 = 126;
      break;
    case 209 :
      *p1 = 131;
      *p2 = 128;
      break;
    case 210 :
      *p1 = 131;
      *p2 = 129;
      break;
    case 211 :
      *p1 = 131;
      *p2 = 130;
      break;
    case 212 :
      *p1 = 131;
      *p2 = 132;
      break;
    case 213 :
      *p1 = 131;
      *p2 = 134;
      break;
    case 214 :
      *p1 = 131;
      *p2 = 136;
      break;
    case 215 :
      *p1 = 131;
      *p2 = 137;
      break;
    case 216 :
      *p1 = 131;
      *p2 = 138;
      break;
    case 217 :
      *p1 = 131;
      *p2 = 139;
      break;
    case 218 :
      *p1 = 131;
      *p2 = 140;
      break;
    case 219 :
      *p1 = 131;
      *p2 = 141;
      break;
    case 220 :
      *p1 = 131;
      *p2 = 143;
      break;
    case 221 :
      *p1 = 131;
      *p2 = 147;
      break;
    case 222 :
      *p1 = 129;
      *p2 = 74;
      break;
    case 223 :
      *p1 = 129;
      *p2 = 75;
      break;
  }
  if (nigori) 
  {
    if ((*p2 >= 74 && *p2 <= 103) || (*p2 >= 110 && *p2 <= 122)) (*p2)++;
    else 
	if (*p1 == 131 && *p2 == 69) *p2 = 148;
  }
  else 
  if (maru && *p2 >= 110 && *p2 <= 122) *p2 += 2;
  return(retval);
}

/*=========DoNelson===carry out Nelson display=============*/

void DoNelson()
{
	int is,iores,i,prownext;
	int bush,nels,halp,strk,onk,kunk,meank,grade;
	int c1n,c2n,p1,p2;
	char fks[100],c1,c2,c3,cs1,cs2;
	char nelname[50];
	long seekoff;

	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  	clearviewport();
	Vmsg = FALSE;
	c1 = fbuff[chline][chpos] & 0x7f;
	c2 = fbuff[chline][chpos+1] & 0x7f;
	c3 = fbuff[chline][chpos+2] & 0x7f;
	if(fbuff[chline][chpos] < 128)
	{
		sprintf(fks,"The ASCII character [%X]: %c",fbuff[chline][chpos],fbuff[chline][chpos]);
		outtextxy(10,20,fks);
		return;
	}
	if(fbuff[chline][chpos] == 0x8f)
	{
		pcol = 380;
		prow = 20;
		JIS212 = TRUE;
		OutKanji(jis2index(c2,c3));
		sprintf (fks,"The JIS 212 character [JIS: %X%X Kuten: %d]: ",c2,c3,((c2&0x7f)-0x20)*100+(c3&0x7f)-0x20);
		outtextxy(10,20,fks);
		JIS212 = FALSE;
		prow+=20;
		pcol = 20;
		c2 |= 0x80;
		c3 |= 0x80;
		Dispk212(c2,c3);
		return;
	}
	if(fbuff[chline][chpos] < 0xb0)
	{
		pcol = 230;
		prow = 20;
		OutKanji(jis2index(c1,c2));
		sprintf (fks,"The JIS character [%X%X]: ",c1,c2);
		outtextxy(10,20,fks);
		return;
	}
	c2 = fbuff[chline][chpos+1] & 0x7f;
	c1n = (fbuff[chline][chpos] & 0x7f) - 0x30;
	c2n = (fbuff[chline][chpos+1] & 0x7f) - 0x21;
	if (!nelopen)
	{
		strcpy(nelname,kanjidir);
		strcat(nelname,"kinfo.dat");
		fn = fopen(nelname,"rb");
		if ( fn == NULL)
		{
			sprintf(Bmsg," Cannot open: %s \n",nelname);
			outtextxy(10,10,Bmsg);
			return;
		}
		nelopen = TRUE;
	}

	seekoff = c1n *94 + c2n;
	if ((seekoff < 0)||(seekoff > MAXJIS))
	{
		sprintf(fks," %x%x No information available on this kanji!",c1,c2);
		outtextxy(10,20,fks);
		return;
	}
	seekoff *= sizeof(KINFORECORD);
	if((iores = fseek(fn,seekoff,SEEK_SET)) != 0)SeekErr(iores);
	iores = fread(&krec,sizeof(KINFORECORD),1,fn);
	if (iores != 1)Bomb("Read failure on kinfo.dat");
	if (krec.padding != KVER) Bomb("Incorrect kinfo.dat version!");
	bush = krec.bushu;
	nels = krec.indexn;
	halp = krec.indexh;
	strk = krec.strokes;
	kunk = krec.onkun >> 4;
	onk = krec.onkun & 0xf;
	meank = krec.meanings >> 4;
	grade = krec.grade;
	p1 = c1 & 0x7f;
	p2 = c2 & 0x7f;
	jis2sjis(&p1,&p2);
	cs1 = p1;
	cs2 = p2;
	pcol = 4;
	prow = 8;
	OutKanji(jis2index(c1,c2));
	sprintf (fks,"J: %X%X (%c%c) Ku: %d SJ: %X%X Bsh: %d Str: %d Gr: %d Nel: %d Hlp: %d",c1,c2,c1,c2,((c1&0x7f)-0x20)*100+(c2&0x7f)-0x20,cs1,cs2,bush,strk,grade,nels,halp);
	kouttextxy(29,8,fks);
	seekoff = krec.offset;
	if ((seekoff == 0L)||(seekoff == -1L))
	{
		kouttextxy(10,26,"No further details available");
		return;
	}
	if((iores = fseek(fn,seekoff,SEEK_SET)) != 0)SeekErr(iores);
	if ((krec.offset == 0)||(krec.onkun == 0))
	{
		kouttextxy(10,26,"No yomikata available.");
		prownext = 44;
	}
	else
	{
		prownext = 44;
		prow = 26;
		if (onk > 0)
		{
			pcol = 70;
			kouttextxy(4,prow,"ONYOMI:");
			for (is = 0; is < onk; is++)
			{
				fgets(fks,99,fn);
				if(pcol+strlen(fks)*kfntspce > maxx-3)
				{
					prow+=18;
					prownext = prow+18;
					pcol = 70;
				}
				for (i = 0; i < strlen(fks)-1; i++)
				{
					if(fks[i] == 0x20)
					{
						OutKanji(jis2index(0x21,0x26));
						continue;
					}
					if(fks[i] == 0x1f)
					{
						OutKanji(jis2index(0x21,0x3c));
						continue;
					}
					OutKanji(jis2index(0x25,fks[i]));
				}
				pcol+=kfntspce;
			}
		}
		else prownext = prow;
		if (kunk > 0)
		{
			if(maxx-200 < pcol)
			{
				prow = prownext;
				pcol = 70;
			}
			else pcol+=5;
			prownext = prow+18;
			kouttextxy(pcol,prow,"KUNYOMI:");
			pcol+=75;
			for (is = 0; is < kunk; is++)
			{
				fgets(fks,99,fn);
				if(pcol+strlen(fks)*kfntspce > maxx-3)
				{
					prow+=18;
					prownext = prow+18;
					pcol = 70;
				}
				for (i = 0; i < strlen(fks)-1; i++)
				{
					if(fks[i] == 0x20)
					{
						OutKanji(jis2index(0x21,0x26));
						continue;
					}
					if(fks[i] == 0x1f)
					{
						OutKanji(jis2index(0x21,0x3c));
						continue;
					}
					OutKanji(jis2index(0x24,fks[i]));
				}
				pcol+=kfntspce;
			}
		}
	}
	if (meank == 0)
	{
		kouttextxy(10,prownext,"No meanings available.");
	}
	else
	{
		prow = prownext;
		pcol = 70;
		kouttextxy(4,prow,"DETAILS:");
		for (is = 0; is < meank; is++)
		{
			fgets(fks,99,fn);
			fks[strlen(fks)-1] = '\0';
			if (is < meank-1)strcat(fks,"; ");
			meanstr = strtok(fks," ");
			while(meanstr != NULL)
			{
				if (pcol+strlen(meanstr)*afntspce > maxx-3)
				{
					pcol = 4; prow+=18;
				}
				for (i = 0; i < strlen(meanstr); i++)
				{
					ops[0] = meanstr[i]; ops[1] = '\0';
					kouttextxy(pcol,prow,ops);
					pcol+=afntspce;
				}
				ops[0] = ' '; ops[1] = '\0';
				kouttextxy(pcol,prow,ops);
				pcol+=afntspce;
				meanstr = strtok(NULL," ");
			}
		}
	}
}

/*=========string comparison function used in yomikata lookup===*/
int Kstrcmpy(int slen)
{
	unsigned c1,c2;
	int i,rc1,rc2;
/* effectively does a strnicmp on two "strings" , one in fbuff[chline][chpos]
   and the other in yline
   except it will make katakana and hiragana match (EUC A4 & A5) */

	for (i = 0; i<slen ; i++)
	{
		c1 = fbuff[chline][chpos+i];
		c2 = yline[i];
		if ((c1 == '\0')||(c2 == '\0')) return(0);
		if ((i % 2) ==0)
		{
			if (c1 == '\xA5')
			{
				c1 = '\xA4';
			}
			if (c2 == '\xA5')
			{
				c2 = '\xA4';
			}
		}
		if (c1 != c2 ) 
		{
			rc1 = c1;
			rc2 = c2;
			return(rc1-rc2);
		}
	}
	return(0);
}
/*=========string comparison functions used in binary search (jbsearch)===*/
int Kstrcmp2(int slen)
{
	unsigned char c1,c2;
	int i,rc1,rc2;
/* effectively does a strnicmp on two "strings" , one in fbuff[chline][chpos]
   and the other pointed to by jindex(it)
   except it will make katakana and hiragana match (EUC A4 & A5) */

	for (i = 0; i<slen ; i++)
	{
		c1 = fbuff[chline][chpos+i];
		c2 = dbchar(jindex(it)+i);
		if ((c1 == '\0')||(c2 == '\0')) return(0);
		if ((i % 2) ==0)
		{
			if (c1 == '\xA5')
			{
				c1 = '\xA4';
			}
			if (c2 == '\xA5')
			{
				c2 = '\xA4';
			}
		}
		if ((c1 >= 'A') && (c1 <= 'Z')) c1 |= '\x20'; /*fix ucase*/
		if ((c2 >= 'A') && (c2 <= 'Z')) c2 |= '\x20';
		if (c1 != c2 ) 
		{
			rc1 = c1;
			rc2 = c2;
			return(rc1-rc2);
		}
	}
	return(0);
}

int Kstrcmp3()
{
	unsigned char c1,c2;
	int slen,i,rc1,rc2;
/* effectively does a strnicmp on two "strings" , one in vstr
   and the other pointed to by jindex(it)
   except it will make katakana and hiragana match (EUC A4 & A5) */

	slen = strlen(vstr);
	for (i = 0; i<slen ; i++)
	{
		c1 = vstr[i];
		c2 = dbchar(jindex(it)+i);
		if ((c1 == '\0')||(c2 == '\0')) return(0);
		if ((i % 2) ==0)
		{
			if (c1 == '\xA5')
			{
				c1 = '\xA4';
			}
			if (c2 == '\xA5')
			{
				c2 = '\xA4';
			}
		}
		if ((c1 >= 'A') && (c1 <= 'Z')) c1 |= '\x20'; /*fix ucase*/
		if ((c2 >= 'A') && (c2 <= 'Z')) c2 |= '\x20';
		if (c1 != c2 ) 
		{
			rc1 = c1;
			rc2 = c2;
			return(rc1-rc2);
		}
	}
	return(0);
}
/*======function to test if this entry has already been displayed=====*/
int addhit(long spot)
{
	int i;
	for (i=0;i<=hitind;i++)
	{
		if(hittab[i] == spot) return(0);
	}
	if (hitind < HITSIZE) hitind++;
	hittab[hitind] = spot;
	return(1);
}

/*====GetColour - convert colour name to ordinal  =======================*/

int GetColour(char *s)
{
	int i;
	char cols[16][20] = {
		"black",
		"blue",
		"green",
		"cyan",
		"red",
		"magenta",
		"brown",
		"lightgray",
		"darkgray",
		"lightblue",
		"lightgreen",
		"lightcyan",
		"lightred",
		"lightmagenta",
		"yellow",
		"white"		};

	for (i = 0; i <16 ; i++)
	{
		if (strnicmp (s,cols[i],strlen(s)) == 0) return (i);
	}
	return(WHITE);
}

/*====kouttextxy===emulates outtextxy using kiascii fonts==========*/

void kouttextxy(int kx, int ky, char *s)
{
	int ift,fr,fc,i,ib,bit,jiaoff,fce,byte;

	if (Bfont)   /* if this font is disabled use bgi fonts   */
	{
		outtextxy(kx,ky,s);
		return;
	}
	for (i = 0 ; i < strlen(s); i++)
	{

		jiaoff = s[i];
		jiaoff *= BPCH;
		ift = 0;
		for ( fr = 0; fr < 14; fr++)
		{
			fce = 0;
			for (fc = 0; fc >=0; fc--)
			{
				byte = kiain[jiaoff+ift+fc];
				for(ib = 0;ib < 8;ib++)
				{
					bit = byte & 1;
					if (bit)putpixel(kx+i*8+fce,ky+fr-4,KIAcolour);
					byte >>= 1;
					fce+=1;
				}
			}
			ift=ift+1;
		}
	}
}

/*===kiaset====read in kiascii font file (if necessary)============*/

void kiaset()
{

	FILE *fp,*fopen();
	char kiadir[50];
	if(Bfont)return;   /* using bgi fonts  */
	kiadir[0] = 0;
	if (strlen(kanjidir) > 1) strcpy(kiadir,kanjidir);
	strcat(kiadir,"kiascii.fnt");
	fp=fopen(kiadir,"rb");
	fread(kiain,BPCH*128,1,fp);
	fclose(fp);
}


/*=====Bomb===print error message and quit==========================*/

void Bomb( char *m)
{
	  /* worry about graphics mode  */
	if(Gron)
	{
		cleardevice();
		closegraph();
	}

	printf(m);
	printf("\n");
	if(Logopen)fclose(fl);
	exit(0);
}

void ScrollBack( int nrlines)
{
	int si;
	char c;
	long offs;

	REOF = FALSE;
	linenosav=lineno;
	if (Foffsets[0] <= 1) return;
	fseek(fi,Foffsets[0],SEEK_SET);
	offs = Foffsets[0];
	for (si = nrlines+1; si != 0; si--)
	{
		while(1)
		{
			offs--;
			if (offs <= 0) break;
			fseek(fi,offs,SEEK_SET);
			c = fgetc(fi);
			if (c == 0x0a) break;
		}
		if (offs <= 0) break;
	}
	Foffsets[0] = ftell(fi);
	if (offs <= 0)
	{
		fseek(fi,0L,SEEK_SET);
		Foffsets[0] = 0L;
	}
	Rfirst = TRUE;
	NextPage();
	lineno = linenosav-nrlines;
}

void LastScr()
{
	fseek(fi,0L,SEEK_END);
	Foffsets[0] = ftell(fi);
	ScrollBack(10);
	lineno = 9999;
}

/*====GetEUC - gets next text line, and converts to EUC ============*/

void GetEUC(char *eucline)
{
	char *retval,instr[256];
	char euctemp[256];
	int i,j,SI,p1,p2,p3;

	euctemp[0] = '\0';
	PBRK = FALSE;
	lineno++;
	SI = FALSE;
	retval = fgets(instr,255,fi);
	if(feof(fi))
	{
		REOF = TRUE;
		if (chppage < 500) chppage = 500;
		return;
	}
	chppage = chppage+strlen(instr);
	if (retval == NULL) Bomb( "File read failure!");
	j = strlen(instr);
	for (i = j-1; i > 0; i--)
	{
		if ((instr[i] == '\n') || (instr[i] == '\r') || (instr[i] == ' '))
		{
			instr[i] = 0;
		}
		else
		{
			break;
		}
	}
	j = 0;
	for (i = 0; i < strlen(instr); i++)
	{
		if((instr[i]==0x1b)&&(instr[i+1]=='&')&&(instr[i+2]=='@'))
		{
			JIS212ON = TRUE;
			JIS_FLIP = 0;
			LockEUC = TRUE;
			i+=2;
			continue;
		}
		if((instr[i]==0x1b)&&(instr[i+1]=='$')&&(instr[i+2]=='B'))
		{
			SI = TRUE;
			JISmode = TRUE;
			i+=2;
			continue;
		}
		if((instr[i]==0x1b)&&(instr[i+1]=='$')&&(instr[i+2]=='@'))
		{
			SI = TRUE;
			i+=2;
			continue;
		}
		if((instr[i]==0x1b)&&(instr[i+1]=='(')&&(instr[i+2]=='J'))
		{
			SI = FALSE;
			i+=2;
			continue;
		}
		if((instr[i]==0x1b)&&(instr[i+1]=='(')&&(instr[i+2]=='B'))
		{
			SI = FALSE;
			i+=2;
			continue;
		}
		if (instr[i] == '\0')break;
		if (SI)
		{
			if (JIS_FLIP == 0)
			{
				JIS_FLIP = (JIS_FLIP+1) % 2;
				euctemp[j] = 0x8f;
				j++;
			}
			euctemp[j] = instr[i] | 0x80;
		}
		else
		{
			euctemp[j] = instr[i];
		}
		j++;
		euctemp[j] = '\0';
	}
/*  fix up SHIFT-JIS, if present  */
	if (LockEUC)
	{
		strcpy(eucline,euctemp);
	}
	else
	{
		j = 0;
		for (i = 0; i < strlen(euctemp); i++)
		{
			p1 = euctemp[i];
			if (p1 < 127)
			{
				eucline[j] = p1;
				j++;
				continue;
			}
			p2 = euctemp[i+1];
			if (ShiftJIS && ( p1 >= 160 && p1 <= 223))
			{
				p3 = han2zen(&p1,&p2);
            	eight2seven(&p1,&p2);
            	p1 += 128;
            	p2 += 128;
				eucline[j] = p1;
				eucline[j+1] = p2;
				i+=p3;
				j+=2;
				continue;
			}
        		if ((p1 >= 129) && (p1 <= 159)) ShiftJIS = TRUE;
			if (((p1 >= 224) && (p1 <= 239))&& ((p2 >= 64) && (p2 <= 158))) ShiftJIS = TRUE;
			if (ShiftJIS)
			{
            	eight2seven(&p1,&p2);
            	p1 += 128;
            	p2 += 128;
				eucline[j] = p1;
				eucline[j+1] = p2;
			}
			else
			{
				eucline[j] = p1;
				eucline[j+1] = p2;
			}
			i++;
			j+=2;
		}
		eucline[j] = 0;
	}
}

/*===eight2seven - convert ShiftJIS to JIS ===========================*/

void eight2seven(int *p1,int *p2)   /* Ken Lunde's routine  */
{
  int temp;

  temp = *p2;
  if ((*p2 >= 64) && (*p2 <= 158))
    *p2 -= 31;
  else if ((*p2 >= 159) && (*p2 <= 252))
    *p2 -= 126;
  if ((temp > 127) && (temp <= 158))
    (*p2)--;
  if ((*p1 >= 129) && (*p1 <= 159)) {
    if ((temp >= 64) && (temp <= 158))
      *p1 = ((*p1 - 113) * 2) + 1;
    else if ((temp >= 159) && (temp <= 252))
      *p1 = (*p1 - 112) * 2;
  }
  else if ((*p1 >= 224) && (*p1 <= 239)) {
    if ((temp >= 64) && (temp <= 158))
      *p1 = ((*p1 - 177) * 2) + 1;
    else if ((temp >= 159) && (temp <= 252))
      *p1 = (*p1 - 176) * 2;
  }
}

/*==== NextPage - read and display next screen of text ==================*/

void NextPage()
{
	int i;
  	int dline,khi,klo,trow,tcol;
	char cc;

	if (REOF) return;
	setviewport(3,3,maxx-4,maxyt-4,1);
	clearviewport();
	chppage = 0;
	trow = 5;
	tcol = 1;
	flcurr = 0;
	if (Rfirst)
	{
		Rfirst = FALSE;
		Foffsets[0] = ftell(fi);
		GetEUC(fbuff[0]);
		flmax = 0;
	}
	else
	{
		strcpy(fbuff[0],fbuff[flmax]);
		Foffsets[0] = Foffsets[flmax];
	}
	for (dline = 0; ;dline++)
	{
		if (dline == 1) ScrollLine = ftell(fi);
		if (dline != 0)
		{
			Foffsets[dline] = ftell(fi);
			GetEUC(fbuff[dline]);
			if (REOF)
			{
				strcpy(fbuff[dline],"***END*OF*FILE***");
			}
		}
		fbcurs[dline] = trow;
		khi = 0;
		klo = 0;
		for (i = 0; i < strlen(fbuff[dline]); i++)
		{
			cc = fbuff[dline][i];
			if (cc == 0x8f)
			{
				JIS212 = TRUE;
				continue;
			}
			if (PBRK && (cc != 0x0c)) continue;
			if (PBRK && (cc == 0x0c))
			{
				PBRK = FALSE;
				continue;
			}
			if (cc < 128)
			{
				if (cc == 0x0c)
				{
					PBRK = TRUE;
					kouttextxy(tcol,trow,"^L");
					tcol+=afntspce*2;
					break;
				}
				if (tcol > maxx-4-afntspce)
				{
					tcol=1;
					trow+=20;
					if (trow >= maxyt-18)break;
				}
				if (cc == '\t')
				{
					tcol+=afntspce;
					tcol = (((tcol-1)/(8*afntspce))+1)*(8*afntspce)+1;
				}
				else
				{
					ops[0] = cc;
					ops[1] = 0;
					kouttextxy(tcol,trow,ops);
					tcol+=afntspce;
				}
				continue;
			}
			else
			{
				if (khi == 0)
				{
					khi = (cc-128) & 0xff;
				}
				else
				{
					if (tcol > maxx-2-kfntspce)
					{
						tcol=1;
						trow+=20;
						if (trow >= maxyt-18)break;
					}
					prow = trow;
					pcol = tcol;
					klo = (cc-128) & 0xff;
					OutKanji(jis2index(khi,klo));
					khi = 0;
					klo = 0;
					JIS212 = FALSE;
					tcol+=kfntspce;
				}
			}
		}
		tcol = 1;
		trow+=20;
		if(REOF)break;
		if(PBRK)break;
		if (trow >= maxyt-18)break;
	}
	flmin = 0;
	flmax = dline;
	cursx = 1;
	cursy = 19;
	chline = flmin;
	chpos = 0;
	ToggleCurs();
}

/*====ToggleCurse - toggles cursor in present position ==================*/

void ToggleCurs()
{
	putimage(cursx,cursy,curstore,XOR_PUT);
}

/*==== IncCur - move cursor to right =================================*/

void IncCur()
{
	if (chpos < strlen(fbuff[chline])-1)
	{
		ToggleCurs();
		if (fbuff[chline][chpos] == 0x8f) chpos++;
		if (fbuff[chline][chpos] > 127)
		{
			chpos+=2;
		}
		else
		{
			chpos++;
		}
		NewCurs();
	}
}

/*======== DecCur - Move cursor one to left =============================*/

void DecCur()
{
	if (chpos > 0)
	{
		ToggleCurs();
		chpos--;
		if (fbuff[chline][chpos] > 127)
		{
			chpos--;
			if (fbuff[chline][chpos-1] == 0x8f) chpos--;
		}
		NewCurs();
	}
}

/*=====UpCur - Move cursor up one line =================================*/

void UpCur()
{
	if (chline > flmin)
	{
		ToggleCurs();
		chline--;
		if (chpos > strlen(fbuff[chline])-1)chpos =  strlen(fbuff[chline])-1;
		NewCurs();
	}
	else
	{
		REOF = FALSE;
		ScrollBack(1);
	}
}

/*===== DownCur - move cursor down one line ================================*/

void DownCur()
{
	if (chline < flmax)
	{
		ToggleCurs();
		chline++;
		if (chpos > strlen(fbuff[chline])-1)chpos =  strlen(fbuff[chline])-1;
		NewCurs();
	}
	else  if (!REOF)
	{
		fseek(fi,ScrollLine,SEEK_SET);
		Rfirst = TRUE;
		linenosav = lineno;
		NextPage();
		ToggleCurs();
		chline = flmax;
		chpos = 0;
		NewCurs();
		lineno = linenosav+1;
	}
}

/*=====NewCurs - display cursor in (new) position =======================*/

void NewCurs()
{
		int i;

		LUlen = 0;		/* disable skip in next <k> command  */
		cursx = 1;
		cursy = fbcurs[chline]+14;
		if (chpos > strlen(fbuff[chline])-1) chpos =  strlen(fbuff[chline])-1;
		for (i = 0; i < chpos; i++)
		{
			if (fbuff[chline][i] < 127)
			{
				cursx+=afntspce;
				if (fbuff[chline][i] == '\t')cursx = (((cursx-1)/(8*afntspce))+1)*(8*afntspce)+1;
				if (cursx > maxx-4-afntspce)
				{
					if (cursy < maxyt-18)
					{
						cursx = 1;
						cursy+=20;
					}
					else
					{
						i--;
						cursx-=afntspce;
						break;
					}
				}
			}
			else
			{
				if (fbuff[chline][i] == 0x8f) i++;
				i++;
				cursx+=kfntspce;
				if (cursx > maxx-4-kfntspce)
				{
					if (cursy < maxyt-18)
					{
						cursx = 1;
						cursy+=20;
					}
					else
					{
						i--;
						cursx-=afntspce;
						break;
					}
				}
			}
		}
		if (i >= strlen(fbuff[chline])) /* fix over-run for trailing kanji */
		{
			i-=2;
			cursx-=kfntspce;
		}
		chpos = i;
		ToggleCurs();
}

/*========== Dispk212 - carry out disply of JIS 212 info  ================*/

void Dispk212(char c2, char c3)
{
	int i,yi,khi,klo;
	long yp;
	char *lstr,cc;

	if (!k212open)
	{
		strcpy(k212name,kanjidir);
		strcat(k212name,"kanjd212.ind");
		fpw2 = fopen(k212name,"rb");
		if ( fpw2 == NULL)
		{
			sprintf(Bmsg," Cannot open: %s \n",k212name);
			outtextxy(10,10,Bmsg);
			return;
		}
		fread(k212ind,255*sizeof(long),1,fpw2);
		fclose(fpw2);
		strcpy(k212name,kanjidir);
		strcat(k212name,"kanjd212");
		fpw2 = fopen(k212name,"rb");
		if ( fpw2 == NULL)
		{
			sprintf(Bmsg," Cannot open: %s \n",k212name);
			outtextxy(10,10,Bmsg);
			return;
		}
		k212open = TRUE;
	}
	yi = c2;
	yp = k212ind[yi];
	if (yp == 0)
	{
		outtextxy(pcol,prow,"Cannot find this kanji in the KANJD212 file! (1)");
		return;
	}
	yp--;
	fseek(fpw2, yp, SEEK_SET);
	while (!feof(fpw2))
	{
		fgets(yline,255,fpw2);
		if (yline[1] != c2)
		{
			outtextxy(pcol,prow,"Cannot find this kanji in the KANJD212 file! (2)");
			return;
		}
		if (yline[2] != c3) continue;
		strcpy(ylinebest,yline+4);
  		khi = 0;
  		klo = 0;
		for (i = 0; i < strlen(ylinebest)-1; i++)
		{
			if (pcol >= maxx-20)
			{
				pcol = 20;
				prow+=20;
			}
			cc = ylinebest[i];
			if (cc == 0x8f)
			{
				JIS212 = TRUE;
				continue;
			}
			if (cc < 128) /* non-Japanese, display it*/
			{
				ops[0]= cc;
				ops[1] = '\0';
				kouttextxy(pcol,prow,ops);
				pcol = pcol+=afntspce;
			}
			else   /* kana or kanji  */
			{
				if (khi == 0)
				{
					khi = (cc-128) & 0xff;
				}
				else
				{
					klo = (cc-128) & 0xff;
					OutKanji(jis2index(khi,klo));
					khi = 0;
					klo = 0;
					JIS212 = FALSE;
				}
			}
		}
		return;
	}
}
/*========== Yomilook - carry out yomikata lookup command ================*/

void Yomilook()
{
	int i,yi,khi,klo,bestlen,res;
	long yp;
	char *lstr,cc;

  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  	clearviewport();
	Vmsg = FALSE;
	if (!wskopen)
	{
		strcpy(wskname,kanjidir);
		strcat(wskname,"wsktok.ind");
		fpw = fopen(wskname,"rb");
		if ( fpw == NULL)
		{
			sprintf(Bmsg," Cannot open: %s \n",wskname);
			outtextxy(10,10,Bmsg);
			return;
		}
		fread(wskind,255*sizeof(long),1,fpw);
		fclose(fpw);
		strcpy(wskname,kanjidir);
		strcat(wskname,"wsktok.dat");
		fpw = fopen(wskname,"rb");
		if ( fpw == NULL)
		{
			sprintf(Bmsg," Cannot open: %s \n",wskname);
			outtextxy(10,10,Bmsg);
			return;
		}
		wskopen = TRUE;
	}
	yi = fbuff[chline][chpos];
	yp = wskind[yi];
	if (yp == 0)
	{
		outtextxy(10,10,"Cannot find yomikata");
		return;
	}
	fseek(fpw, yp, SEEK_SET);
	bestlen = 0;
	while (!feof(fpw))
	{
		fgets(yline,255,fpw);
		res = Kstrcmpy(2);
		if (res > 0) continue;
		if (res < 0) break;
		if (bestlen == 0)
		{
			strcpy(ylinebest,yline);
			bestlen = 2;
		}
		for (yi = 0; yi < 20; yi++)
		{
			if(yline[yi] != fbuff[chline][chpos+yi]) break;
		}
		if (yi >= bestlen)
		{
			bestlen = yi;
			strcpy(ylinebest,yline);
		}
		if (yi < bestlen)break;
	}
	if (bestlen == 0)
	{
		outtextxy(10,10,"Cannot find yomikata");
		return;
	}
	else
	{
		sprintf(Bmsg,"%d:",bestlen/2);
		outtextxy(10,10,Bmsg);
  		pcol = 18+afntspce*strlen(Bmsg);
  		prow = 10;
  		khi = 0;
  		klo = 0;
		for (i = 0; i < strlen(ylinebest)-1; i++)
		{
			cc = ylinebest[i];
			if (cc == 0x8f)
			{
				JIS212 = TRUE;
				continue;
			}
			if (cc < 128) /* non-Japanese, display it*/
			{
				ops[0]= cc;
				ops[1] = '\0';
				kouttextxy(pcol,prow,ops);
				pcol = pcol+=afntspce;
			}
			else   /* kana or kanji  */
			{
				if (khi == 0)
				{
					khi = (cc-128) & 0xff;
				}
				else
				{
					klo = (cc-128) & 0xff;
					OutKanji(jis2index(khi,klo));
					khi = 0;
					klo = 0;
					JIS212 = FALSE;
				}
			}
		}
		outtextxy(10,30,"Log this entry? (y/n)");
		cc = getch();
		if ((cc == 'y')||(cc == 'Y'))
		{
			cc = 'n';
			if(!Logopen)
			{
				fl = fopen(LogFile,"at");
				if (fl == NULL)
				{
					clearviewport();
					sprintf(Bmsg,"Cannot open %s",LogFile);
					outtextxy(10,10,Bmsg);
					return;
				}
				Logopen = TRUE;
			}
			Getlogeng(50);
			lstr = strtok(ylinebest,"]");
			fprintf(fl,"%s] /%s/\n",lstr,logeng);
			outtextxy(200,30,"Logged");
		}
		if ((cc != 'N')&&(cc != 'n'))
		{
			yi = cc;
			ungetch(yi);
		}

	}


}

void AppKanji(unsigned char c1,unsigned char c2)
{
	unsigned char ops[3];

	ops[0] = c1;
	ops[1] = c2;
	ops[2] = 0;
	strcat(vline,ops);
}

int Vlookup()
{
	long lo,lo2,hi,hi2,schix,schiy;
	int res,hit;
	unsigned char khi,klo,cc;

	khi = 0;
	klo = 0;
	lo = 1;
	hi = indptr;
	vline[0] = 0;
	while(TRUE)
	{
		it = (lo+hi)/2;
		res = Kstrcmp3();
		if (res == 0) break;
		if (res < 0)
		{
			hi = it-1;
		}
		else
		{
			lo = it+1;
		}
		if (lo > hi)break;
	}
	if (res != 0) return (FALSE);
/*  we have a match, so scan backwards up the table to find the first   */
	while (TRUE)
	{
		if(Kstrcmp3() == 0)
		{
			it--;
			if (it == 0)
			{
				it = 1;
				break;
			}
			continue;
		}
		else
		{
			it++;
			break;
		}
	}

     while (Kstrcmp3() == 0)
     {
        schix = jindex(it);
        if(dbchar(schix-1) != 10) 
	{
		it++;
		continue;
	}
	/* back off to the start of this line   */
	while ((dbchar(schix) != 10) && (schix >= 0)) schix--;
	schix++;
	/* now work forwards, displaying the line  */
	hit = FALSE;
	/* If the first word has already been displayed, skip it.
	   Otherwise, put braces around the first word (kanji)  */
	while (TRUE)
	{
		cc = dbchar(schix);
		if (cc < 32) break;
		/* put a () around the yomikata in an ascii or Kanji search */
		if (cc=='[')
		{
			AppKanji(0xa1,0xcA);  /* EUC (  */
			schix++;
			continue;
		}
		if (cc==']')
		{
			AppKanji(0xA1,0xCB);  /* EUC )  */
			schix++;
			continue;
		}
		if (cc < 128) /* non-Japanese, display it
				(fix up the "/") */
		{
			ops[0]= cc;
			ops[1] = '\0';
			if (ops[0] == '/')
			{
				if (hit)
				{
					ops[0] = ';';
					ops[1] = ' ';
					ops[2] = '\0';
				}
				else
				{
					hit = TRUE;
					ops[0] = '\0';
				}
			}
			strcat(vline,ops);
		}
		else
		{
			if (khi == 0)
			{
				khi = cc;
			}
			else
			{
				klo = cc;
				AppKanji(khi,klo);
				khi = 0;
				klo = 0;
			}
		}
		schix++;
	}
        if(strlen(vline) > 0) break;
     }
     if(strlen(vline) <=1) return(FALSE);
     return(TRUE);
}


/*=========== Lookup - carry out dictionary search ================*/

void Lookup()
{
	unsigned long schix,schiy,lo,hi,lo2,hi2,itsav,itok;
	int AnyDisp,dind,res,hit,skip,brace;
	int i,slench,slen;
  	unsigned int LUCont,khi,klo,cc,cc1;
	unsigned long bshit[20];
	unsigned char vlast[11],temp[11],strtmp[80],resp;
	int JOflag,vi,vok;

  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  	clearviewport();
	Vmsg = FALSE;
	kouttextxy(10,10,"Searching....");
	vlast[0] = 0;

	if (Jverb&&(fbuff[chline][chpos] > 0xa8) && (fbuff[chline][chpos+2] < 0xa5) && (fbuff[chline][chpos+4] < 0xa5))
	{
		/* possible inflected verb or adjective */

		vstr[0] = fbuff[chline][chpos];
		vstr[1] = fbuff[chline][chpos+1];
		vstr[2] = 0;
		for(i=0;i<11;i++) temp[i] = fbuff[chline][chpos+i];

		for (vi = 0;vi <= verblen;vi++)
		{
			vok = TRUE;
			vstr[2] = 0;
			for (i = 0;i < strlen(vinfl[vi]);i++)
			{
				if (fbuff[chline][chpos+2+i] != vinfl[vi][i])
				{
					vok = FALSE;
					break;
				}
			}
			if (!vok) continue;
			strcat(vstr,vdicf[vi]);
			
			if(strcmp(vstr,temp) == 0) continue;
			if (strcmp(vstr,vlast) == 0)continue;
			if (Vlookup())
			{
				strcpy(vlast,vstr);
				pcol = 10;
				prow = 10;
				/*klast = 0;*/
				khi = 0;
  				clearviewport();
				sprintf(ops," Possible inflected verb or adjective: (%s)",vcomms[vcommno[vi]]);				
				kouttextxy(pcol,prow,ops);
				prow+=22;
				for(it = 0; it <strlen(vline)-2; it++)
				{
					cc = vline[it];
					if (cc == 0x8f)
					{
						JIS212 = TRUE;
						continue;
					}
					if (cc < 128) /* non-Japanese, display it  */
					{
						ops[0]= cc;
						ops[1] = '\0';
						WordOut(ops);
					}
					else   /* kana or kanji  */
					{
						if (khi == 0)
						{
							khi = (cc-128) & 0xff;
						}
						else
						{
							klo = (cc-128) & 0xff;
							OutKanji(jis2index(khi,klo));
							khi = 0;
							klo = 0;
							JIS212 = FALSE;
						}
					}
				}
				prow += 20;
				pcol = 10;
				kouttextxy(pcol,prow,"Continue with this search (y/n)");
				cc = getch();
				clearviewport();
				if ((cc == 'n')||(cc == 'N')) return;
				if ((cc != 'y')&&(cc != 'Y'))
				{
					i=cc;
					ungetch(i);
					return;
				}
			}		
		}
		clearviewport();
		kouttextxy(10,10,"Searching....");
  	}

	/* now do a binary search through the index table looking for a match  */
  	pcol = 10;
  	prow = 10;
  	khi = 0;
  	klo = 0;
  	lo = 1;
  	hi = indptr;
  	LUCont = TRUE;
	AnyDisp = FALSE;
	LUlen  = 0;
	slench = 2;
	if (fbuff[chline][chpos] < 127) slench = 1;
	Smode = 0;
	if ((fbuff[chline][chpos] == 0xa4)||(fbuff[chline][chpos] == 0xa5)) Smode = 1;
  	for ( slen = 0; slen <20; slen++)
  	{
		while(TRUE)
		{
  			it = (lo+hi)/2;
			res = Kstrcmp2(slen*slench+slench);
			if (res == 0)
			{
				itsav = it;
				itok = it;
				lo2 = lo;
				hi2 = it;
				while (TRUE)
				{
					if(lo2+1 >= hi2) break;
					it = (lo2+hi2)/2;
					res = Kstrcmp2(slen*slench+slench);
					if (res == 0)
					{
						hi2 = it;
						itok = it;
						continue;
					}
					else
					{
						lo2 = it+1;
					}
				}
				bshit[slen] = itok;
				res = 0;
				it = itsav;
				break;
			}
			if (res < 0)
			{
				hi = it-1;
			}
			else
			{
				lo = it+1;
			}
			if (lo > hi)
			{
				LUCont = FALSE;
				break;
			}
		}
		if (!LUCont)
		{
			break;
		}
	}
  	if (slen == 0)
  	{
		kouttextxy(10,25,"No Match Found");
		return;
  	}
	clearviewport();

	if (fbuff[chline][chpos] > 0xa8) LUlen = slen;
  	hitind = 0;
  	hittab[0] = -1;
	/*  loop for each possible string length  */
	for (dind = slen-1; dind >= 0 ; dind--)
	{
		Fold = FALSE;
	/*  scan backwards up the table to find the first   */
		it = bshit[dind];
		while (1)
		{
			if(Kstrcmp2(dind*slench+slench) == 0)
			{
				it--;
				if (it == 0)
				{
					it = 1;
					break;
				}
				continue;
			}
			else
			{
				it++;
				break;
			}
		}
  		hit = FALSE;

		/* this is the display loop - usually one line per entry  */
  		while (Kstrcmp2(dind*slench+slench) == 0)   /* display as long as there are matches*/
  		{
			schix = jindex(it);
			schiy = schix;
		/* back off to the start of this line   */
			while ((dbchar(schix) != 10) && (schix >= 0)) schix--;
			schix++;
			JOflag = FALSE;
		/* now work forwards, displaying the line  */
			if((addhit(schix) != 0)&&(!FirstKanj||( FirstKanj && (dbchar(schiy-1) < 127)))) /* only display a line once  */
			{
				AnyDisp = TRUE;
			/* First, display the matched word/kana string  */
				sprintf(ops,"%d",dind+1);
				strcat(ops,": ");
				kouttextxy(pcol,prow,ops);
				pcol=pcol+afntspce*strlen(ops);
				ops[0] = 0;
				while (TRUE)
				{
					cc = dbchar(schiy);
					if (cc == 0x8f)
					{
						JIS212 = TRUE;
						schiy++;
						continue;
					}
					if (cc < 128)
					{
						if (!isalpha(cc)) break;
					}
					if (cc < 128) /* non-Japanese, display it*/
					{
						ops[0]= cc;
						ops[1] = '\0';
						kouttextxy(pcol,prow,ops);
						pcol = pcol+afntspce;
					}
					else   /* kana or kanji  */
					{
						if (khi == 0)
						{
							khi = (cc-128) & 0xff;
						}
						else
						{
							klo = (cc-128) & 0xff;
							OutKanji(jis2index(khi,klo));
							khi = 0;
							klo = 0;
							JIS212 = FALSE;
						}
					}
					schiy++;

				} /* end of match display  */
				ops[0] = 0;
				pcol+=afntspce;
				hit = FALSE;
				skip = FALSE;
				brace = FALSE;
				/* If the first word has already been displayed, skip it.
	   			Otherwise, put braces around the first word (kanji)  */
				if (schix == jindex(it))
				{
					skip = TRUE;
				}
				else
				{
					pcol-=7;
					OutKanji(jis2index(0x21,0x5A));  /* JIS [  */
					brace = TRUE;
				}
				while ((cc = dbchar(schix)) != 10)
				{
					cc1 = dbchar(schix+1);
					if (cc==' ')skip = FALSE;
					if ((brace)&&(cc==' '))
					{
						brace = FALSE;
						OutKanji(jis2index(0x21,0x5B));     /* JIS ]  */
					/*	pcol-=7;*/
					}
					/* turn off yomikata skipping when a ']' is reached  */
					if ((skip)&&(cc==']'))
					{
						skip = FALSE;
						schix++;
						continue;
					}
					/* skip yomikata display during a kana search  */
					if ((Smode > 0)&&(cc=='[')) skip = TRUE;
					/* put a () around the yomikata in an ascii search */
					if ((Smode==0)&&(cc=='['))
					{
						pcol-=7;
						OutKanji(jis2index(0x21,0x4A));  /* JIS (  */
						schix++;
						continue;
					}
					if ((Smode==0)&&(cc==']'))
					{
						OutKanji(jis2index(0x21,0x4B));  /* JIS )  */
						pcol-=7;
						schix++;
						continue;
					}
					if (skip)
					{
						schix++;
						continue;
					}
					if (cc < 128) /* non-Japanese, display it
								(fix up the "/") */
					{
						switch (cc) {
			
					case '/':
						if (hit)
						{
							if(cc1 >= 0x20)	strcat(ops,"; ");
						}
						else
						{
							hit = TRUE;
							strcpy (ops," ");
						}
						WordOut(ops);
						break;
					case '.':
						strcat(ops,".");
						WordOut(ops);
						break;
					case '-':
						strcat(ops,"-");
						WordOut(ops);
						break;
					case ' ':
						if (strlen(ops) > 0)
						{
							WordOut(ops);
							strcpy(ops," ");
							WordOut(ops);
						}
						if (JOflag)
						{
							strcpy(ops," ");
							WordOut(ops);
						}
						break;
					default:
						strtmp[0] = cc;
						strtmp[1] = 0;
						strcat(ops,strtmp);
						JOflag = FALSE;
				}	
					}
					else   /* kana or kanji  */
					{
						JOflag = TRUE;
						if (cc == 0x8f)
						{
							JIS212 = TRUE;
							schix++;
							continue;
						}
						if (khi == 0)
						{
							khi = (cc-128) & 0xff;
						}
						else
						{
							klo = (cc-128) & 0xff;
							if (pcol+17 > maxx-6)
							{
								pcol = 40;
								prow+=17;
							}
							OutKanji(jis2index(khi,klo));
							khi = 0;
							klo = 0;
							JIS212 = FALSE;
						}
					}
					schix++;
				}  /* end of line display loop  */
				prow = prow+17;
				pcol = 10;
			}  /* of "once-per-line" test */
			if (prow > maxy- maxyt-32)  /* no more room on screen */
			{
				if(Fold) 
				{
					it--;
					hitind--;
				}
				setcolor(Pcolour);
				putimage (4,maxy-maxyt-22,bline,COPY_PUT);
				outtextxy(20,maxy-maxyt-20,"Press M for more of this Display ");
				resp = getch();
				if ((resp != 'm') && (resp !='M'))
				{
					ungetch(resp);
					return;
				}
				clearviewport();
				pcol = 10;
				prow = 10;
				setcolor(Acolour);
			}
			it++;
			if (it >= indptr) break;
		}  /*  end of the "while it matches loop  */
	}  /* end of the dind loop  */
	if (!AnyDisp) 
	{
		outtextxy(20,20,"No Match Found");
	}
	else
	{
		outtextxy(20,maxy-maxyt-20,"No further matches found");
	}
}  /* end of lookup */

void JumpLines()

{
	long offs;
	int i,il;
	char c;

  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
	clearviewport();
	Vmsg = FALSE;
	outtextxy(10,10,"Enter number of lines to skip:");
	logeng[0] = 0;
	i = 0;
	while (i < 50)
	{
		c = getch();

		if (c == '\r') break;

		if (c == 8)  /* backspace  */
		{
			if ( i > 0 )
			{
				logeng[i-1] = '\0';
				c = ' ';
				i--;
				putimage(300+9*i,10,blank,COPY_PUT);
				continue;
			}
		}
		logeng[i] = c;
		logeng[i+1] = '\0';
		ops[0] = c;
		ops[1] = 0;
		outtextxy(300+9*i,10,ops);
		i++;
	}
	sscanf(logeng,"%d",&i);
	if ((strlen(logeng) < 1) || (i <= 0))
	{
		setviewport(3,3,maxx-4,maxyt-4,1);
		return;
	}
	outtextxy(10,25,"Skipping...");
	fseek(fi,Foffsets[0],SEEK_SET);
	for(il = 0;il < i;il++)
	{
		offs = ftell(fi);
		GetEUC (yline);
		if(REOF)
		{
			outtextxy(140,25,"File end reached");
			setviewport(3,3,maxx-4,maxyt-4,1);
			LastScr();
			return;
		}
	}
	outtextxy(140,25,"Done");
/*	strcpy(fbuff[0],yline);
	Foffsets[0] = offs;    */
	fseek(fi,offs,SEEK_SET);
	Rfirst = TRUE;
	NextPage();
	return;
}

/*====== SkipArt - skip to next article in file =====================*/

void SkipArt()
{
	long offs,offsav;
	int oldeof;

  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  	clearviewport();
	Vmsg = FALSE;
	outtextxy(10,10,"Skipping to next Article");
	offsav = ftell(fi);
	oldeof = REOF;
	while(1)
	{
		offs = ftell(fi);
		GetEUC (yline);
		if(REOF)
		{
			outtextxy(10,30,"File end reached");
			setviewport(3,3,maxx-4,maxyt-4,1);
			fseek(fi,offsav,SEEK_SET);
			REOF = oldeof;
			return;
		}
		if (strncmp("Article",yline,7) == 0) break;
		if (strncmp("Subject:",yline,8) == 0) break;
	}
	strcpy(fbuff[0],yline);
	Foffsets[0] = offs;
	Rfirst = FALSE;
	NextPage();
	return;
}
void CursSch()
{
	char c;
	int i,lk;

  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
	clearviewport();
	Vmsg = FALSE;
	outtextxy(10,10,"Enter number of characters in key");
	c = getch();
	lk = c-'0';
	if (( lk < 1) || (lk > 9))
	{
		outtextxy(10,25,"Illegal Number!");
		return;
	}
	if (fbuff[chline][chpos] > 0xa0) lk*=2;
	for (i=0;i<lk;i++) 
	{
		logeng[i] = fbuff[chline][chpos+i];
		logeng[i+1] = 0;
	}
	TextSrch(1);
}

void KUT2EUC (char *instr, char *outstr)
{
	char tmpout[3],c;
	int kn;
	int i;

	kn = 0;
	for (i = 0;i<4;i++) kn = kn*10 + instr[i]-'0';
	tmpout[0] = (kn/100)+0xa0;
	tmpout[1] = (kn % 100)+0xa0;
	tmpout[2] = 0;
	strcat(outstr,tmpout);
}

void SJS2EUC (char *instr, char *outstr)
{
	char jistmp[4],tmpout[3],c;
	int p1,p2;
	int i;

	for (i = 0;i<4;i++)
	{
		c = instr[i] | 0x20;
		if (c < 0x40) c = c - '0';
		else
		c = c - 'a' + 10;
		jistmp[i] = c;
	}
	tmpout[2] = 0;
	p1 = jistmp[0]*16 + jistmp[1];
	p2 = jistmp[2]*16 + jistmp[3];
    eight2seven(&p1,&p2);
	tmpout[0] = p1+0x80;
	tmpout[1] = p2+0x80;
	strcat(outstr,tmpout);
}
void JIS2EUC (char *instr, char *outstr)
{
	char jistmp[4],tmpout[3],c;
	int i;

	for (i = 0;i<4;i++)
	{
		c = instr[i] | 0x20;
		if (c < 0x40) c = c - '0';
		else
		c = c - 'a' + 10;
		jistmp[i] = c;
	}
	tmpout[2] = 0;
	for (i = 0; i < 2 ;i++)
	{
		tmpout[i] = (jistmp[i*2] << 4) + jistmp[i*2+1] + 0x80;
	}
	strcat(outstr,tmpout);
}
void TextSrch(int TStype)
{
	long offs,offsav;
	int i,oldeof,ktype,lnsav;
	char c,schstr[100];

  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
	clearviewport();
	Vmsg = FALSE;
	oldeof = REOF;
	if(TStype == 0)
	{
		outtextxy(10,10,"Enter Search String:");
		logeng[0] = 0;
		i = 0;
		while (i < 50)
		{
			c = getch();
	
			if (c == '\r') break;
		
			if (c == 8)  /* backspace  */
			{
				if ( i > 0 )
				{
					logeng[i-1] = '\0';
					c = ' ';
					i--;
					putimage(200+9*i,10,blank,COPY_PUT);
					continue;
				}
			}
			logeng[i] = c;
			logeng[i+1] = '\0';
			ops[0] = c;
			ops[1] = 0;
			outtextxy(200+9*i,10,ops);
			i++;
		}
	}
	if (logeng[0] == '?') strcpy(logeng,schbak);
	if (strlen(logeng) <= 1)
	{
		setviewport(3,3,maxx-4,maxyt-4,1);
		return;
	}
	if (logeng[0] == '\\')
	{
		schstr[0] = 0;
		ktype = 0;
		if ((logeng[1] | 0x20) == 'k') ktype = 1;
		if ((logeng[1] | 0x20) == 's') ktype = 2;
		for(i = 1 ; i < strlen(logeng)-2; i+=4) 
		{

			if (ktype == 0) JIS2EUC(logeng+i,schstr);
			if (ktype == 1) KUT2EUC(logeng+i+1,schstr);
			if (ktype == 2) SJS2EUC(logeng+i+1,schstr);
		}
	}
	else
	{
		strcpy(schstr,logeng);
	}
	strcpy(schbak,schstr);
	offsav = ftell(fi);
	outtextxy(10,28,"Searching for: ");
	outtextxy(20,maxy-maxyt-20,"(Press Esc to abandon search)");
	if (schstr[0] < 127) outtextxy(140,28,schstr);
	else
	{
		pcol = 140;
		prow = 28;
		for (i = 0; i < strlen(schstr); i+=2)
		{
			if (schstr[i] == 0x8f)
			{
				JIS212 = TRUE;
				i++;
			}
			OutKanji(jis2index(schstr[i] & 0x7f, schstr[i+1] & 0x7f));
			JIS212 = FALSE;
		}
	}
	fseek(fi,Foffsets[1],SEEK_SET);
	lnsav = lineno;
	while(1)
	{
		offs = ftell(fi);
		GetEUC (yline);
		if(REOF)
		{
			outtextxy(10,50,"File end reached");
			setviewport(3,3,maxx-4,maxyt-4,1);
			fseek(fi,offsav,SEEK_SET);
			REOF = oldeof;
			lineno = lnsav;
			return;
		}
		i = kbhit();
		if (i != 0)
		{
			c = getch();
			if (c == 0x1b)
			{
				outtextxy(10,50,"Escape Pressed - Search abandoned");
				setviewport(3,3,maxx-4,maxyt-4,1);
				fseek(fi,offsav,SEEK_SET);
				REOF = oldeof;
				lineno = lnsav;
				return;
			}
		}
		if (strstr(yline,schstr) != NULL) break;
	}
/*	strcpy(fbuff[0],yline);
	Foffsets[0] = offs;    */
	outtextxy(10,50,"Done");
	fseek(fi,offs,SEEK_SET);
	Rfirst = TRUE;
	NextPage();
	return;
}

/*=========== Logchars - log the current kanji/kana group =================*/

void Logchars()
{
	int nolog,lin,lout,kanaonly,allkanj,li,lk;
	char c,lstr[31];

  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  	clearviewport();
	Vmsg = FALSE;
	if(!Logopen)
	{
		fl = fopen(LogFile,"at");
		if (fl == NULL)
		{
			sprintf(Bmsg,"Cannot open %s",LogFile);
			outtextxy(10,10,Bmsg);
			setviewport(3,3,maxx-4,maxyt-4,1);
			return;
		}
		Logopen = TRUE;
	}
	if (fbuff[chline][chpos] < 127)
	{
		outtextxy(10,10,"Only kana & kanji can be logged");
		return;
	}
	outtextxy(10,10,"Enter number of characters to log (1-9)");
	allkanj = FALSE;
	kanaonly = TRUE;
	c = getch();
	lk = c-'0';
	if (c == '\r') allkanj = TRUE;
	if ((!allkanj)&&((lk <1)||(lk > 9)))
	{
		outtextxy(10,30,"Illegal number!");
		return;
	}
	lin = 0;
	lout = 0;
	nolog = 0;
	if (allkanj)
	{
		for (li = 0; li < 9; li++)
		{
			kanaonly = FALSE;
			if (fbuff[chline][chpos+lin ] == 0x8f)
			{
				lstr[lout] = fbuff[chline][chpos+lin ];
				lin++;
				lout++;
			}
			lstr[lout] = fbuff[chline][chpos+lin ];
			lstr[lout+1] = fbuff[chline][chpos+lin +1];
			lstr[lout+2] = 0;
			nolog++;
			if (fbuff[chline][chpos+lin+2] <128) break;
			if ((fbuff[chline][chpos+lin+2] == 0xa4 )||(fbuff[chline][chpos+lin+2] == 0xa5)) break;
			lout+=2;
			lin+=2;
		}
	}
	else
	{
		for (li = 0; li < lk; li++)
		{
			if (fbuff[chline][chpos+lin ] <128) break;
			if (fbuff[chline][chpos+lin ] == 0x8f)
			{
				lstr[lout] = fbuff[chline][chpos+lin ];
				lin++;
				lout++;
			}
			lstr[lout] = fbuff[chline][chpos+lin ];
			lstr[lout+1] = fbuff[chline][chpos+lin +1];
			lstr[lout+2] = 0;
			if(lstr[lout] > 0xa5) kanaonly = FALSE;
			lout+=2;
			lin+=2;
			nolog++;
		}
	}
	Getlogeng(30);
	if (kanaonly)
	{
		fprintf(fl,"%s /%s/\n",lstr,logeng);
	}
	else
	{
		fprintf(fl,"%s [] /%s/\n",lstr,logeng);
	}
	sprintf(lstr,"%d characters logged",nolog);
	outtextxy(10,70,lstr);
	return;
}

/*====Getlogeng - get some english for the logged entry===============*/

void Getlogeng(int rowpix)
{
	int i,rowpix2;
	char c;

	rowpix2 = rowpix+18;
	outtextxy(10,rowpix,"English?(y/n)");
	c = getch();
	logeng[0] = 0;
	if (( c != 'y')&&(c != 'Y')) return;
	outtextxy(10,rowpix2,"Enter:");
	i = 0;
	while (i < 64)
	{
		c = getch();

		if (c == '\r') return;

		if (c == 8)  /* backspace  */
		{
			if ( i > 0 )
			{
				logeng[i-1] = '\0';
				c = ' ';
				i--;
				putimage(60+9*i,rowpix2,blank,COPY_PUT);
				continue;
			}
		}
		logeng[i] = c;
		logeng[i+1] = '\0';
		ops[0] = c;
		ops[1] = 0;
		outtextxy(60+9*i,rowpix2,ops);
		i++;
	}
}

/*==== NextKanji - skip cursor to next kanji compound ================*/

void NextKanji()
{
	int ic,ir,Kfound;
	char c;

	if( LUlen > 0 )
	{
		chpos=chpos+LUlen*2;
		LUlen = 0;
	}
	else
	{
		Kfound = FALSE;
		for (ir = chline; ir <= flmax; ir++)
		{
			for (ic = chpos; ic < strlen(fbuff[ir]); ic++)
			{
				c =fbuff[ir][ic];
				if (c == 0x8f) continue;
				if (c <= 0xa8)
				{
					Kfound = TRUE;
					break;
				}
				ic++;
			}
			if(Kfound) break;
			chpos = 0;
			if (ir == flmax) break;
		}
		chline = ir;
		chpos = ic;
	}
	Kfound = FALSE;
	for (ir = chline; ir <= flmax; ir++)
	{
		for (ic = chpos; ic < strlen(fbuff[ir]); ic++)
		{
			c =fbuff[ir][ic];
			if ((c == 0x8f) || (c > 0xa8))
			{
				Kfound = TRUE;
				break;
			}
			if(c > 127)ic++;
		}
		if(Kfound) break;
		chpos = 0;
		if (ir == flmax) break;
	}
	chline = ir;
	chpos = ic;
	ToggleCurs();
	NewCurs();
}
/*==== NextWord  - skip cursor to next word ================*/

void NextWord ()
{
	int ic,ir,Wfound,Wgotit;
	char c;

	Wfound = FALSE;
	Wgotit = FALSE;
	for (ir = chline; ir <= flmax; ir++)
	{
		for (ic = chpos; ic < strlen(fbuff[ir]); ic++)
		{
			c =fbuff[ir][ic];
			if (!Wfound && ((c == ' ') || (c < 0x20)))
			{
				Wfound = TRUE;
				continue;
			}
			c = c | 0x20;
			if (Wfound && ((c >= 'a') && (c <= 'z')))
			{
				Wgotit = TRUE;
				break;
			}
		}
		Wfound = TRUE;
		if(Wgotit) break;
		chpos = 0;
		if (ir == flmax) break;
	}
	chline = ir;
	chpos = ic;
	ToggleCurs();
	NewCurs();
}

/*=======StatusRep==== Report on the Status and file being read=========*/
void StatusRep()
{
	char ts1[10],ts2[10],ts3[10],ts4[10];

  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  	clearviewport();
	Vmsg = FALSE;
	strcpy(filmode,"EUC");
	if(JISmode) strcpy(filmode,"JIS");
	if(ShiftJIS) strcpy(filmode,"SJIS");
	sprintf (Bmsg,"Reading file: %s [%s] at byte %ld, Line no: %ld",Rname,filmode,ftell(fi),lineno);
	outtextxy( 10,10,Bmsg);
	sprintf (Bmsg,"Dic: %s  Fnts: %s ",Dname,fontfilename);
	if (!Bfont)
	{
		strcat(Bmsg,kanjidir);
		strcat(Bmsg,"kiascii.fnt");
	}
	outtextxy( 10,25,Bmsg);
	sprintf (Bmsg,"Page buffers: %d  Page Faults: (Dic) %d (Ind) %d (Fonts) %d",novbuff,vbrd,vbri,vbrf);
	outtextxy( 10,40,Bmsg);
	strcpy(ts1,"CLOSED");
	if (Logopen) strcpy(ts1,"OPEN");
	sprintf (Bmsg,"Logging File: %s  (%s)",LogFile,ts1);
	outtextxy( 10,55,Bmsg);
	strcpy(ts1,"OFF");
	strcpy(ts2,"OFF");
	strcpy(ts3,"OFF");
	strcpy(ts4,"OFF");
	if (Jverb) strcpy(ts1,"ON");
	if (ScrBlnk) strcpy(ts2,"ON");
	if (AutoLook) strcpy(ts3,"ON");
	if (Vmode) strcpy(ts4,"ON");
	sprintf (Bmsg,"Toggles: Verbs= %s  Screen Blanking= %s  Auto lookup= %s  On-line Help= %s",ts1,ts2,ts3,ts4);
	outtextxy( 10,70,Bmsg);
	setviewport(3,3,maxx-4,maxyt-4,1);
}

void DoVmsg()
{
	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
	clearviewport();
	Vmsg = TRUE;
outtextxy(5,15,
"Use the PgUp/PgDn keys to scroll the text, and the arrow keys to move");
outtextxy(5,30,
"the cursor to text you wish to examine. The space bar starts the search");
outtextxy(5,45,
"of the dictionary, 'n' examines individual kanji, 'y' looks up readings");
outtextxy(5,60,
"of kanji compounds, 'l' logs test to file. Use F1 for more information.");
	setviewport(3,3,maxx-4,maxyt-4,1);
}

/*====ExtFileDisp===Display from EDICTEXT file=======================*/

void ExtFileDisp()
{

	unsigned long extrec[2],seekoff,iores,hi,lo,mid,ejdxtest[2];
	char khi,klo,Ssch[20],c,cc;
	int bsres,i;

	if(fbuff[chline][chpos] < 128) return;
	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  	clearviewport();
	setviewport(3,3,maxx-4,maxyt-4,1);
	if(!Extopen)
	{
		fe = fopen(EXTname,"rb");
		if (fe == NULL)
		{
			sprintf(Bmsg,"Cannot open %s",EXTname);
			Bomb(Bmsg);
		}
		fex = fopen(EXTJDXname,"rb");
		if (fex == NULL)
		{
			sprintf(Bmsg,"Cannot open %s",EXTJDXname);
			Bomb(Bmsg);
		}
		Extopen = TRUE;
  		extlen = filelength(fileno(fe));
		extlen++;
		fread(ejdxtest,sizeof(long),1,fex);
		if (ejdxtest[0] != (extlen+jiver))
		{
			sprintf(Bmsg,"EDICT Extension file & Index Mismatch! %ld %ld",ejdxtest[0],extlen+jiver);
			Bomb(Bmsg);
		}
	}
  	extjdxlen = filelength(fileno(fex));
	lo = 0;
	hi = (extjdxlen/(2*sizeof(long)))-1;
	while(TRUE)
	{
		mid = (lo+hi)/2;
		seekoff = mid;
		seekoff *= (2*sizeof(long));
		seekoff+=sizeof(long);
		if((iores = fseek(fex,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(&extrec,sizeof(long),2,fex);
		seekoff = extrec[0];
		if((iores = fseek(fe,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		iores = fread(&Ssch,sizeof(char),19,fe);
		Ssch[19] = 0;
		i = 0;
		bsres = 0;
		for (i = 0; Ssch[i] != 0 ;i++)
		{
			if (Ssch[i] < 128) break;
			if (fbuff[chline][chpos+i] < 128) break;
			if (fbuff[chline][chpos+i] < Ssch[i])
			{
				bsres = -1;
				break;
			}
			if (fbuff[chline][chpos+i] > Ssch[i])
			{
				bsres = 1;
				break;
			}
		}
		if ((bsres != 0) && ((lo + hi) == 0)) break;
		if(bsres < 0)
		{
			hi = mid-1;
		}
		else
		{
			lo = mid+1;
		}
		if ((bsres  == 0) || (lo > hi)) break;
	}
	if (bsres == 0)
	{
  		clearviewport();
		outtextxy(maxy/2-40,4,"Dictionary Extension Display");
		seekoff = extrec[1];
		if((iores = fseek(fe,seekoff,SEEK_SET)) != 0)SeekErr(iores);
		prow = 20;
		kouttextxy(10,prow,"<");
		pcol=10+afntspce;
		khi = 0;
		while(!feof(fe))
		{
			fgets(LogLine,199,fe);
			if (feof(fe)) break;
			if ((LogLine[0] == '<') && (LogLine[1] > 128)) break;
			if (LogLine[strlen(LogLine)-1] < 0x20) LogLine[strlen(LogLine)-1] = 0;
			for (i = 0; i < strlen(LogLine); i++)
			{
				cc = LogLine[i];
				if (cc == 0x8f)
				{
					JIS212 = TRUE;
					continue;
				}
				if (cc < 128) 
				{
					ops[0] = cc;
					ops[1] = 0;
					kouttextxy(pcol,prow,ops);
					pcol=pcol+afntspce;
					if (pcol > maxx-6) break;
				}
				if (cc >= 128)
				{
					if (khi == 0)
					{
						khi = cc & 0x7f;
					}
					else
					{
						klo = cc & 0x7f;
						OutKanji(jis2index(khi,klo));
						if (pcol > maxx-6) break;
						khi = 0;
						klo = 0;
						JIS212 = FALSE;
					}
				}
			}
			prow = prow+17;
			pcol = 10;
			if (prow > maxyt-18)  
			{
				setviewport(3,maxyt+4,maxx-4,maxy-4,1);
				outtextxy(10,14,"Press Enter to continue Display, Esc to return to the main file: ");
				c = waitch();
				clearviewport();
				setviewport(3,3,maxx-4,maxyt-4,1);
				clearviewport();
				outtextxy(maxy/2-40,4,"Dictionary Extension Display");
				prow = 20;
				pcol = 10;
				if(c == 0x1b)
				{
					fseek(fi,Foffsets[0],SEEK_SET);
					Rfirst = TRUE;
					REOF = FALSE;
					NextPage();
					return;
				}
			}
		}
		setviewport(3,maxyt+4,maxx-4,maxy-4,1);
		outtextxy(10,14,"Press Enter to return to the main file:");
		c = waitch();
		clearviewport();
		setviewport(3,3,maxx-4,maxyt-4,1);
		fseek(fi,Foffsets[0],SEEK_SET);
		Rfirst = TRUE;
		REOF = FALSE;
		NextPage();
		return;
	}
	if (bsres != 0)
	{
		setviewport(3,maxyt+4,maxx-4,maxy-4,1);
		outtextxy(10,14,"Not found in Extension file.");
		setviewport(3,3,maxx-4,maxyt-4,1);
		return;
	}
	fseek(fi,Foffsets[0],SEEK_SET);
	Rfirst = TRUE;
	REOF = FALSE;
	NextPage();
}

/*=====NewFile====Open a new file to read============================*/
	
void NewFile()
{
	int NFrow,i;
	char NFname[80],c;
  	setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  	clearviewport();
	Vmsg = FALSE;
	lineno = 0;
	NFrow = 10;
	ShiftJIS  = FALSE;
	JISmode = FALSE;
	if (strlen(NextFile) > 1)
	{
		sprintf(Bmsg,"The next file is: %s. Open? (y/n)",NextFile);
		outtextxy(10,NFrow,Bmsg);
		NFrow+=15;
		c = getch();
		if (c == 0x1b) return;
		if ((c == 'y')||(c == 'Y'))
		{
			strcpy(Rname,NextFile);
			fclose(fi);
			fi = fopen(Rname,"rb");
			if ( fi == NULL)
			{
				sprintf(Bmsg," Cannot open: %s \n",Rname);
				Bomb(Bmsg);
			}
			Rfirst = TRUE;
			REOF = FALSE;
			NextPage();
			NextFile[0] = '\0';
			return;
		}
	}
	outtextxy(10,NFrow,"New file name: (Esc if none) ");
	NFname[0] = '\0';
	i = 0;
	while (i < 50)
	{
		c = getch();
		if (c == 0x1b) return;
		if (c == '\r') break;

		if (c == 8)  /* backspace  */
		{
			if ( i > 0 )
			{
				NFname[i-1] = '\0';
				c = ' ';
				i--;
				putimage(250+9*i,NFrow,blank,COPY_PUT);
				continue;
			}
		}
		NFname[i] = c;
		NFname[i+1] = '\0';
		ops[0] = c;
		ops[1] = 0;
		outtextxy(250+9*i,NFrow,ops);
		i++;
	}
	strcpy(Rname,NFname);
	if ((findfirst(Rname,&ffblk,0)) != 0)
	{
		sprintf(Bmsg,"Cannot open %s",Rname);
		outtextxy(10,30,Bmsg);
		return;
	}
	fclose(fi);
	fi = fopen(Rname,"rb");
	if ( fi == NULL)
	{
		sprintf(Bmsg," Cannot open: %s \n",Rname);
		outtextxy(10,NFrow+15,Bmsg);
		setviewport(3,3,maxx-4,maxyt-4,1);
	}
	Rfirst = TRUE;
	REOF = FALSE;
	NextPage();
	NextFile[0] = '\0';
	return;
}	
	

/*                  M A I N                                      */

main(argc,argv)
int argc;
char **argv;
{
	int iptr2;
	int ClineSrch;
	int FilePrompt=FALSE;
  	char fpage[256],c,c2,strtmp[80];
	char **ap;
	int spr=7,iptr,i,j,GError;

  /*  get working environment info   */

	if (!Rcfile("JDICRC","jdic.rc"))Rcfile("MOKERC","moke.rc");
  	kiaset();
	Verbinit();

  /*   get command line arguments   */
  	if (argc > 1)
  	{
		ap = argv;
		ClineSrch = FALSE;
		for (iptr = 0; iptr < argc-1; iptr++)
		{
			ap++;
			strcpy(strtmp,*ap);
			if ((strtmp[0] == '-')&&(strtmp[1] == 'd'))
			{
				if (strtmp[2] == 0)
				{
					ap++;
					iptr++;
					strcat(strtmp,*ap);
					if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
				}
				strcpy(DnameList[NoDics],strtmp+2);
				strcpy(JDXnameList[NoDics],strtok(strtmp+2," ."));
				strcat(JDXnameList[NoDics],".jdx");
				NoDics++;
				if (NoDics > 10) Bomb (" More than 10 dictionaries!");
				TestDic = FALSE;
				continue;
			}
			if ((strtmp[0] == '-')&&(strtmp[1] == 'v'))
			{
				Vmode = FALSE;
				continue;
			}
			if ((strtmp[0] == '-')&&(strtmp[1] == 'b'))
			{
				if (strtmp[2] == 0)
				{
					ap++;
					iptr++;
					strcat(strtmp,*ap);
					if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
				}
				novbmax = atoi(strtmp+2);
				if (novbmax < 1) Bomb("You need buffers!");
				continue;
			}
			if ((strtmp[0] == '-')&&(strtmp[1] == 'L'))
			{
				if (strtmp[2] == 0)
				{
					ap++;
					iptr++;
					strcat(strtmp,*ap);
					if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
				}
				strcpy(LogFile,strtmp+2);
				continue;
			}

			if ((strtmp[0] == '-')&&(strtmp[1] == '/'))
			{
				if (strtmp[2] == 0)
				{
					ap++;
					iptr++;
					strcat(strtmp,*ap);
					if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
				}
				strcpy(logeng,strtmp+2);
				ClineSrch = TRUE;
				continue;
			}
			if ((strtmp[0] == '-')&&(strtmp[1] == 's'))
			{
				if (strtmp[2] == 0)
				{
					ap++;
					iptr++;
					strcat(strtmp,*ap);
					if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
				}
				j = atoi(strtmp+2);
				if (( j > 2) && (j < 9)) spr = j;
				continue;
			}

			if ((strtmp[0] == '-')&&(strtmp[1] == 'l'))
			{
				Load = FALSE;
				continue;
			}
			if ((strtmp[0] == '-')&&(strtmp[1] == 'E'))
			{
				LockEUC = TRUE;
				continue;
			}
			if ((strtmp[0] == '-')&&(strtmp[1] == 'f'))
			{
				Bfont = TRUE;
				continue;
			}
			if ((strtmp[0] == '-')&&(strtmp[1] == 'F'))
			{
				FilePrompt = TRUE;
				continue;
			}
			if ((strtmp[0] == '-')&&(strtmp[1] == 'c'))
			{
				if (strtmp[2] == 0)
				{
					ap++;
					iptr++;
					strcat(strtmp,*ap);
					if (strtmp[2] == '-') Bomb("JDIC: Illegal command-line option");
				}
				strcpy(ops,strtmp+2);
				strcat(ops,"\\jdic.rc");
  				if (!Rcfile("BLETCHXX",ops))
				{
					strcpy(ops,strtmp+2);
					strcat(ops,"\\moke.rc");
  					Rcfile("BLETCHXX",ops);
				}
				continue;
			}

		/* none of the above - assume file name   */
			strcpy(Rname,*ap);
			break;
		}
  	}
	if (strlen(Rname) == 0)
	{
		if (FilePrompt)
		{
			printf("\n[JREADER] Name of text file: ");
			scanf("%s",Rname);
			printf("\n");
		}
		else
		{
			printf("\n Usage:\njreader [-l] [-f] [-bnn] [-sn] [-E] [-ddicname(s)] [-Llogfile] textfile(s)\n");
			exit(0);
		}
	}
	fi = fopen(Rname,"rb");
	if ( fi == NULL)
	{
		sprintf(Bmsg," Cannot open: %s \n",Rname);
		Bomb(Bmsg);
	}
	if (NoDics > 0) 
	{
		NoDics--;
		strcpy(Dname,DnameList[0]);
		strcpy(JDXname,JDXnameList[0]);
	}
/*  No user-specified dictionary, so test which default is present */
	if (TestDic)
	{
		if ((findfirst(Dname,&ffblk,0)) != 0)
  		{
  			strcpy(Dname,Dname2);
			strcpy(JDXname,JDXname2);
		}
		strcpy(DnameList[0],Dname);
		strcpy(JDXnameList[0],JDXname);
	}
/*  check that all dictionary files are there, and find the largest so I
    can set the right table sizes   */

  MAXDICTAB=0; MAXJDXTAB=0;

  for (i = 0;i <= NoDics; i++)
  {
  	fpd = fopen(DnameList[i],"r");
	if(fpd == NULL)
	{
		sprintf(Bmsg,"Unable to open %s",DnameList[i]);
		Bomb(Bmsg);
	}
  	diclen = filelength(fileno(fpd));
	j = (diclen/VBUFFSIZE)+1;
	if (j > MAXDICTAB) MAXDICTAB = j;
	fclose(fpd);
  	fpd = fopen(JDXnameList[i],"r");
	if(fpd == NULL)
	{
		sprintf(Bmsg,"Unable to open %s",JDXnameList[i]);
		Bomb(Bmsg);
	}
  	indlen = filelength(fileno(fpd));
	j = (indlen/VBUFFSIZE)+1;
	if (j > MAXJDXTAB) MAXJDXTAB = j;
	fclose(fpd);
  }
  doffp = malloc(MAXDICTAB*sizeof(int));
  if (!doffp) Bomb("Insufficient memory!");
  joffp = malloc(MAXJDXTAB*sizeof(int));
  if (!joffp) Bomb("Insufficient memory!");
  for (i = 0; i < MAXDICTAB; i++) doffp[i] = -1;
  for (i = 0; i < MAXJDXTAB; i++) joffp[i] = -1;

/* test which JIS font file is present  */
	strcpy(fontfilename, kanjidir);
	strcat(fontfilename, "kijis16.fnt");
	OldJIS = FALSE;
	if ((findfirst(fontfilename,&ffblk,0)) != 0)
	{
		OldJIS = TRUE;
	}

  /*  sort out graphics   */

  	detectgraph(&GraphDriver,&GraphMode);
  	if ( GraphDriver < 0)
  	{
  		Bomb("No Graphics Driver Detected!\n");
  	}
  	if((stricmp(getenv("JGRAPHIC"),"ATT400") == 0)||(attflag))
  	{
		GraphDriver = ATT400;
		GraphMode = 5;
  	}
  	if (getenv("BGI") != NULL)
  	{
		strcpy(BGIDir,getenv("BGI"));
  	}
  	initgraph(&GraphDriver,&GraphMode,BGIDir);
  	if ((GError = graphresult()) < 0)
  	{
		sprintf(Bmsg,"Graphics Error: %s\n",grapherrormsg(GError));
		Bomb(Bmsg);
  	}
  	Gron = TRUE;
  	maxx = getmaxx();
  	maxy = getmaxy();
	maxyt = (maxy*spr)/10 - 2;
  	cleardevice();
  	setbkcolor(Bcolour);
  	setcolor(Pcolour);
  	KIAcolour = Pcolour;
  	/*  set up some blank images for backspacing, etc.   */
  	bsize = imagesize(0,0,7,7);
  	blank = malloc(bsize);
  	getimage(0,0,7,7,blank);
	cursize = imagesize(0,0,7,2);
	curstore = malloc(cursize);
  	setlinestyle(SOLID_LINE,0xFFFF,THICK_WIDTH);
	line (50,50,57,50);
	getimage(50,50,57,52,curstore);
  	Msize = imagesize(0,0,28,7);
  	lblank = malloc(Msize);
  	getimage(0,0,28,7,lblank);
  	blsize = imagesize(0,0,maxx-20,14);
  	bline = malloc(blsize);
  	getimage(0,0,maxx-20,14,bline);
  	kbsize = imagesize(0,0,40,16);
  	kblank = malloc(kbsize);
  	getimage(0,0,40,16,kblank);
	cleardevice();
  	/*  initial banner  */
  	sprintf(fpage,"JREADER Version %s (Japanese Text Reader)",sver);
  	kouttextxy((maxx-9*strlen(fpage))/2,maxy/3,fpage);
  	sprintf(fpage,"Copyright J.W.Breen 1994.");
  	kouttextxy((maxx-9*strlen(fpage))/2,maxy/3+20,fpage);
  	sprintf(fpage,"Text File: %s  Dictionary: %s ",Rname,Dname);
  	kouttextxy((maxx-9*strlen(fpage))/2,maxy/3+40,fpage);
  	sprintf (fpage,"Loading Dictionary and Kanji/Kana font files.  Please wait.....");
  	if (Load) kouttextxy((maxx-9*strlen(fpage))/2,maxy/3+60,fpage);
  	sprintf(fpage,"Press F1 for Help with Keyboard Commands");
  	kouttextxy((maxx-9*strlen(fpage))/2,maxy-20,fpage);
  	KIAcolour = Acolour;

  	FontSetUp();  /* initialize font file(s)  */
  	DicSet ();      /* set up dictionary buffers  */
  	DicInit();      /* load dictionary  */

  	cleardevice();
  	setlinestyle(SOLID_LINE,0xFFFF,THICK_WIDTH);
  	rectangle(0,0,maxx-2,maxy-2);
  	line (0,maxyt,maxx-2,maxyt);
	Rfirst = TRUE;
	wskopen = FALSE;
	for (iptr2 = 0; iptr2 < 50; iptr2++) strcpy (fbuff[iptr2]," ");
  	NextPage();   /* initialize with first page  */
	if (Vmode & !Vmsg) DoVmsg();

	/* loop until Esc is pressed, interpreting keystrokes           */

  	while (TRUE)
	{
		if (ClineSrch)
		{
			ClineSrch = FALSE;
			TextSrch(1);
		}
		c = getch();
		FirstKanj = TRUE;
		if (ScrBlnk & !Vmode)
		{
			setviewport(3,maxyt+4,maxx-4,maxy-4,1);
			clearviewport();
			setviewport(3,3,maxx-4,maxyt-4,1);
		}
		if (Vmode & !Vmsg) DoVmsg();
		switch (c)
		{
  			case 0x1b :				/* Esc      */
  				setviewport(3,maxyt+4,maxx-4,maxy-4,1);
				clearviewport();
				Vmsg = FALSE;
				outtextxy(10,10, "Escape pressed! Press [y] or Esc to confirm exit.");
				c = getch();
				if ((c == 0x1b)||(c == 'y')||(c == 'Y'))
				{
					cleardevice();
					closegraph();
					if(Logopen)fclose(fl);
					exit(0);
				}
				ungetch(c);
				setviewport(3,3,maxx-4,maxyt-4,1);
				break;

			case 'a' :
			case 'A' :	FirstKanj = FALSE; /* fall into lookup */

			case ' ' :	Lookup();                   /* spacebar  */
					setviewport(3,3,maxx-4,maxyt-4,1);
					break;

			case '\r' : chpos = 0;DownCur();break;   /* Enter  */

			case 'L'  :
			case 'l'  : Logchars(); 
					setviewport(3,3,maxx-4,maxyt-4,1);
					break;

			case 'Y'  :
			case 'y'  : Yomilook(); 
					setviewport(3,3,maxx-4,maxyt-4,1);
					break;

			case 'n'  :
			case 'N'  : DoNelson();
					setviewport(3,3,maxx-4,maxyt-4,1);
					break;

			case 'k'  :
			case 'K'  : NextKanji();
					if (AutoLook)
					{
			          		Lookup(); 
						setviewport(3,3,maxx-4,maxyt-4,1);
					}
					break;

			case 'w'  :
			case 'W'  : NextWord(); break;
			      
			case 's'  :
			case 'S'  : SkipArt(); break;

			case 'j' : case 'J': JumpLines(); break;

			case 'c'  :
			case 'C'  :  CursSch(); break;

			case 'd' : case 'D' : StatusRep(); break;

			case 'e' : case 'E' : ExtFileDisp(); break;

			case '/'  : TextSrch(0); break;
			
			case 'o' : case 'O' :
				if (Vmode)
				{
			  		Vmode = FALSE;
				}
				else
				{
					Vmode = TRUE;
				}
				break;
			case 'b' : case 'B' :
				setviewport(3,maxyt+4,maxx-4,maxy-4,1);
				clearviewport();
				Vmsg = FALSE;
				if (ScrBlnk)
				{
			  		ScrBlnk = FALSE;
					outtextxy(10,10,"Window Blanking Disabled");
				}
				else
				{
					ScrBlnk = TRUE;
					outtextxy(10,10,"Window Blanking Enabled");
				}
				setviewport(3,3,maxx-4,maxyt-4,1);
				break;

			case 'v' : case 'V' :
				setviewport(3,maxyt+4,maxx-4,maxy-4,1);
				clearviewport();
				Vmsg = FALSE;
				if (Jverb)
				{
			  		Jverb = FALSE;
					outtextxy(10,10,"Verb Deinflection Disabled");
				}
				else
				{
					Jverb = TRUE;
					outtextxy(10,10,"Verb Deinflection Enabled");
				}
				setviewport(3,3,maxx-4,maxyt-4,1);
				break;

			case 'F' :
         		case 'f'  : 	/* F  - new file   */
					if (strlen(NextFile) <=1)
					{
						iptr++;
						ap++;
						if (iptr < argc-1) strcpy(NextFile,*ap);
					}
					NewFile();
					setviewport(3,3,maxx-4,maxyt-4,1);
					break;

			case 0x08 : DecCur(); break;		/* <- */

			case 0x00 :    			/*  2-byte keycode  */

			c2 = getch();

			switch (c2)
			{

				case 0x47  : chpos = 0;    /* Home*/
						ToggleCurs();NewCurs();break;

				case 0x4f  : chpos = strlen(fbuff[chline])-1; /*End*/
						ToggleCurs();NewCurs();break;

				case 0x84 :    /* Ctrl PgUp - restart file  */
						fseek(fi,long0,SEEK_SET); REOF = FALSE;
						Rfirst = TRUE; lineno = 0; NextPage(); break;

				case 0x51 : NextPage ();break;		/* PgDn */

				case 0x77 :	/* Ctrl Home  - top of Screen*/
				            chline = flmin; chpos = 0;
						ToggleCurs();NewCurs(); break;

				case 0x49 : REOF = FALSE; ScrollBack(flmax); break; /* PgUp */

				case 0x75 : chline = flmax; chpos = 0;  /* Ctrl End */
						ToggleCurs();NewCurs(); break;

				case 0x76 : LastScr(); break;  	/*Ctrl PgDn */

				case 0x4d : IncCur ();break;	/* ->  */

				case 0x4b : DecCur ();break;	/* <--  */

				case 0x48 : UpCur ();break;	/* ^  */

				case 0x50 : DownCur ();break;	/* v  */

				case 0x3c : 			/* F2 */
  						setviewport(3,maxyt+4,maxx-4,maxy-4,1);
  						clearviewport();
						Vmsg = FALSE;
						if (AutoLook)
						{
							AutoLook = FALSE;
							outtextxy(10,10,"Automatic Lookup Disabled");
						}
						else
						{
							AutoLook = TRUE;
							outtextxy(10,10,"Automatic Lookup Enabled");
						}
						setviewport(3,3,maxx-4,maxyt-4,1);
						break;
				case 0x69 :		/* Alt-F2 Select Alt Dictionary */
						setviewport(3,3,maxx-4,maxyt-4,1);
  						clearviewport();
						Vmsg = FALSE;
						HRow = 10;
						if (NoDics < 1)
						{
							outtextxy(10,30,"No alternative dictionaries available!");
							outtextxy(10,40,"  Press any key to return to the Dictionary ......");
							c = getch();
							fseek(fi,Foffsets[0],SEEK_SET);
							Rfirst = TRUE;
							REOF = FALSE;
							NextPage();
							break;
						}
						outtextxy(30,30,"Alternative Dictionary Selection");
						i = 45;
						for (j = 0; j<=NoDics;j++)
						{
							sprintf(Bmsg,"No: %d %s",j,DnameList[j]);
							outtextxy(10,i,Bmsg);
							i+=15;
						}
						i+=5;
						outtextxy(10,i,"Enter the number of the new Dictionary, or Esc to exit without change:");
						c = getch();
						if (c == 0x1b)
						{
							fseek(fi,Foffsets[0],SEEK_SET);
							Rfirst = TRUE;
							REOF = FALSE;
							NextPage();
							break;
						}
						j = c-'0';
						if ((j >= 0) && (j <= NoDics))
						{
							strcpy(Bmsg,"No: X Selected  Press any key to continue...");
							Bmsg[4] = c;
							outtextxy(10,i+15,Bmsg);
							fclose(fpd);
							fclose(fpi);
							strcpy(Dname,DnameList[j]);
							strcpy(JDXname,JDXnameList[j]);
							for (j = 0;j<MAXDICTAB;j++)
							{
								if(doffp[j] != -1)
								{
									usebuff[doffp[j]] = -1;
									doffp[j] = -1;
								}
							}
							for (j = 0;j<MAXJDXTAB;j++)
							{
								if(joffp[j] != -1)
								{
									usebuff[joffp[j]] = -1;
									joffp[j] = -1;
								}
							}
							DicSet();
							c = getch();
							fseek(fi,Foffsets[0],SEEK_SET);
							Rfirst = TRUE;
							REOF = FALSE;
							NextPage();
							break;
						}
						else
						{
							outtextxy(10,i+15,"INVALID! .... press any key to return");
							c = getch();
							fseek(fi,Foffsets[0],SEEK_SET);
							Rfirst = TRUE;
							REOF = FALSE;
							NextPage();
							break;
						}
				case 0x3b : 			/* F1 */
						setviewport(3,3,maxx-4,maxyt-4,1);
  						clearviewport();
						Vmsg = FALSE;
						HRow = 10;
HOut("      J R E A D E R  Help Information");
HRow+=5;
HOut("  <F1>        This Help Information");
HOut("  <F2>        Toggle Autolookup Mode");
HOut("  <Alt-F2>    Select alternative Dictionary");
HOut("  <spacebar>  Look up word in dictionary");
HOut("  <a>         Dictionary lookup, displaying All kanji compounds");
HOut("  <PgDn,PgUp> Read Next/Previous Page ");
HOut("  <arrows, End, Home, Enter> Position Cursor");
HOut("  <Ctrl-Home,Ctrl-End> Top/Bottom of Screen");
HOut("  <Ctrl-PgUp,Ctrl-PgDn> Top/Bottom of File");
HOut("  <l>         Copy kanji/kana to Log File with annotation");
HOut("  <y>         Look Up Yomikata of compound");
HOut("  <s>         Skip to next article");
HOut("  <k>         Skip to next kanji on the screen");
HOut("  <w>         Skip to next word on the screen");
HOut("  <n>         Display Details of a Character, e.g. Kanji or Kana");
HOut("  <e>         Display Dictionary Extension information");
HOut("  </>         Search File for text string (? and \\ options)");
HOut("  <c>         Search File for text string selected from screen");
HOut("  <f>         Start reading next or new text file");
HOut("  <j>         Jump forward n lines");
HOut("  <d>         Display Status Report");
HOut("  <v>         Toggle Verb Deinflection function");
HOut("  <b>         Toggle Blanking of Lower Window");
HOut("  <o>         Toggle On-line Help in the Lower Window");
HRow+=5;
HOut("  <Esc>       Exit");
HOut("      Press any key to return to the text ......");
						c = getch();
						fseek(fi,Foffsets[0],SEEK_SET);
						Rfirst = TRUE;
						REOF = FALSE;
						NextPage();
						break;
			}
		}
	}
	cleardevice();
	closegraph();
	if(Logopen)fclose(fl);
}
